app.controller('addassociationscontroller', function($scope,$ionicPopup, $state, $translate, DB, patientGroupContactService,AssociationSharedProperties, UTIL_SERVICE) {
    $scope.associationContact = {
        name: "",
        description: "",
        $$hashKey: "",
        address: "",
        builtin: "0",
        cell: "",
        cellModel : [
                      { index:0, id:"1", value: "", displayNum:"" }
                    ],
        email: "",
        emailModel : [
                      { index:0, id:"1", value: "", displayNum:"" }
                    ],
        icon: "",
        id: "",
        phone: "",
        phoneModel : [
                      { index:0, id:"1", value: "", displayNum:"" }
                    ],
        phoneExtra: "",
        website: ""
    };
    $scope.editMode = false;
    $scope.isInEditMode = false;
    $scope.triggeredButton = false;
    $scope.associationContact.address1="";
    $scope.associationContact.address2="";
    $scope.associationContact.address3="";
    $scope.buttonName = $translate.instant('SAVE');
    $scope.headerTitle = $translate.instant('ASSOC_LIST_ADD_HEADER');

    $scope.addPhoneNumbers = function(callType) {
          var newItemNo = $scope.associationContact[callType].length+1;
          var displayNumber = "("+parseInt(newItemNo)+")";
          $scope.associationContact[callType].push({index:$scope.associationContact[callType].length, id:newItemNo, value: "", displayNum: displayNumber});
      };

      $scope.deletePhoneNumbers = function(dataObj, callType) {
          for(var i=0; i< $scope.associationContact[callType].length; i++){
              if(dataObj.id === $scope.associationContact[callType][i].id){
                  $scope.associationContact[callType].splice(i, 1);
              }
          }
          for(var i=0; i< $scope.associationContact[callType].length; i++){
              $scope.associationContact[callType][i].index = i;
              $scope.associationContact[callType][i].displayNum = (i==0)?"":"("+(parseInt(i)+1)+")";
          }
      };

      $scope.showAddButton = function(dataObj, callType){
          return dataObj.id === $scope.associationContact[callType][0].id;
      }

      $scope.showDeleteButton = function(dataObj, callType){
          if(dataObj.id != $scope.associationContact[callType][0].id){
              return true;
          } else{
              return false;
          }
      }

    $scope.init = function(){
        var modAssociate = AssociationSharedProperties.getAssociationt();
        if(modAssociate != null){
            $scope.editMode = true;
            $scope.isInEditMode = true;
            $scope.headerTitle = $translate.instant('ASSOC_LIST_EDIT_HEADER');
            $scope.associationContact.name = modAssociate.name;
            $scope.associationContact.description = modAssociate.description;
            $scope.associationContact.id = modAssociate.refId;
            var jsonAddress = modAssociate.jsonAddress;
            $scope.associationContact.builtin = 0;
                
            var phoneList = (modAssociate.phone == null || modAssociate.phone == 'null')?"":modAssociate.phone;
            phoneListObj = [];
            if(phoneList != ""){
              phoneListObj = phoneList.split(",");
            }
            $scope.associationContact.phoneModel = [];
            if(phoneListObj.length > 0){
              for(var i=0; i<phoneListObj.length; i++){
                  var newItemNo = i+1;
                  var displayNumber = "";
                  if(i != 0)
                    displayNumber = "("+parseInt(newItemNo)+")";
                  $scope.associationContact.phoneModel.push({"index":i, "id":newItemNo, "value": phoneListObj[i], "displayNum":displayNumber});
              }
            } else {
              $scope.associationContact.phoneModel.push({"index":0, "id":"1", "value": ""});
            }
            
            var cellList = (modAssociate.cell == null || modAssociate.cell == 'null')?"":modAssociate.cell;
            cellListObj = [];
            if(cellList != ""){
              cellListObj = cellList.split(",");
            }
            $scope.associationContact.cellModel = [];
            if(cellListObj.length > 0){
              for(var i=0; i<cellListObj.length; i++){
                  var newItemNo = i+1;
                  var displayNumber = "";
                  if(i != 0)
                    displayNumber = "("+parseInt(newItemNo)+")";
                  $scope.associationContact.cellModel.push({"index":i, "id":newItemNo, "value": cellListObj[i], "displayNum":displayNumber});
              }
            } else {
              $scope.associationContact.cellModel.push({"index":0, "id":"1", "value": ""});
            }
            
            try{
                var text = JSON.parse(jsonAddress);
                $scope.associationContact.address1 = text.address1;
                $scope.associationContact.address2 = text.address2;
                $scope.associationContact.address3 = text.address3;
            }catch(error){
                $scope.associationContact.address1 = jsonAddress;
            }
            
            var emailList = (modAssociate.email == null || modAssociate.email == 'null')?"":modAssociate.email;
            emailListObj = [];
            if(emailList != ""){
              emailListObj = emailList.split(",");
            }
            $scope.associationContact.emailModel = [];
            if(emailListObj.length > 0){
              for(var i=0; i<emailListObj.length; i++){
                  var newItemNo = i+1;
                  var displayNumber = "";
                  if(i != 0)
                    displayNumber = "("+parseInt(newItemNo)+")";
                  $scope.associationContact.emailModel.push({"index":i, "id":newItemNo, "value": emailListObj[i], "displayNum":displayNumber});
              }
            } else {
              $scope.associationContact.emailModel.push({"index":0, "id":"1", "value": ""});
            }

            $scope.associationContact.website = modAssociate.website;
            
        } else {
            $scope.editMode = false;
        }
    };
    $scope.init();

    $scope.blurAllFormInput = function(){
        //ionic.DomUtil.blurAll()
    }
    
    $scope.onCancel = function(){
//      ADB.trackState($translate.instant('SEPA_CONTACT_ASSOCIATIONS_DE_PATIENTS_ANNULER'));
        ADB.trackState($translate.instant('SEPA_CONTACT_LIST_ASSOCIATIONS_DE_PATIENTS'));
        $state.go('app.associationlist');
    };
    
    $scope.onEnableEdit = function(){
        $scope.editMode = false;
        $scope.buttonName = $translate.instant('VALIDER');
    };
    
    $scope.onSaveorModify = function(){
        $scope.triggeredButton = true;
       // ADB.trackState($translate.instant('SEPA_CONTACT_ASSOCIATIONS_DE_PATIENTS_AJOUTER'));
        ADB.trackState($translate.instant('SEPA_CONTACT_LIST_ASSOCIATIONS_DE_PATIENTS'));
        var text ={
            address1 : $scope.associationContact.address1,
            address2 : $scope.associationContact.address2,
            address3 : $scope.associationContact.address3
        };
        $scope.associationContact.address = JSON.stringify(text);
        
        if($scope.isValidInput()){
            var tempPhoneArr = new Array();
          for(var i = 0; i < $scope.associationContact.phoneModel.length; i++){
              if($scope.associationContact.phoneModel[i].value != ""){
                  tempPhoneArr.push($scope.associationContact.phoneModel[i].value);
              }
          }
          $scope.associationContact.phone = tempPhoneArr.join(",");

          var tempMobileArr = new Array();
          for(var i = 0; i < $scope.associationContact.cellModel.length; i++){
              if($scope.associationContact.cellModel[i].value != ""){
                  tempMobileArr.push($scope.associationContact.cellModel[i].value);
              }
          }
          $scope.associationContact.cell = tempMobileArr.join(",");

          var tempEmailArr = new Array();
          for(var i = 0; i < $scope.associationContact.emailModel.length; i++){
              if($scope.associationContact.emailModel[i].value != ""){
                  tempEmailArr.push($scope.associationContact.emailModel[i].value);
              }
          }
          $scope.associationContact.email = tempEmailArr.join(",");
        
        if($scope.isInEditMode){
            var assoContactForService = angular.copy($scope.associationContact);
            patientGroupContactService.updatePatientGroupContact(assoContactForService).then(function(success){
                ADB.trackState($translate.instant('SEPA_CONTACT_LIST_ASSOCIATIONS_DE_PATIENTS'));
                $state.go('app.associationlist');
            },function(error){
                alert("Error while updating contact");
            });
        } else {
            var assoContactForService = angular.copy($scope.associationContact);
            patientGroupContactService.insertPatientGroupContact(assoContactForService).then(function(success){
                ADB.trackState($translate.instant('SEPA_CONTACT_LIST_ASSOCIATIONS_DE_PATIENTS'));
                $state.go('app.associationlist');
            },function(error){
                alert("Error while updating contact");
            });
        }
        }
    };

    $scope.isValidInput=function() {
      var phoneFormat=", Valid format +XX XXXX XXXX , XX XXXX XXXX";
      if($scope.associationContact.name===null || $scope.associationContact.name==="" ) {
        $scope.triggeredButton = false;
 
        $ionicPopup.show({
          //title: $translate.instant('CON_TITLE_2'),
          cssClass:'form-alert-popup',
                            buttons: [
                                            { 
                                                text: 'OK', 
                                                type:'button-default first-button last-button',
                                                onTap: function(e) {
                                                    
                                                }
                                            } 
                                     ],
          template: $translate.instant('MSG_NOM_REQUIRED')
        });
        //alert($translate.instant('MSG_NOM_REQUIRED'));
        return false;
      } 

      if($scope.associationContact.phoneModel.length > 0){
          for(var i=0; i < $scope.associationContact.phoneModel.length; i++){
              if($scope.associationContact.phoneModel[i].value!==null && $scope.associationContact.phoneModel[i].value!=="" && !UTIL_SERVICE.isValidPhoneNo($scope.associationContact.phoneModel[i].value)){

                    $scope.triggeredButton = false;

                    $ionicPopup.show({
                      //title: $translate.instant('CON_TITLE_2'),
                      cssClass:'form-alert-popup',
                                        buttons: [
                                                        { 
                                                            text: 'OK', 
                                                            type:'button-default first-button last-button',
                                                            onTap: function(e) {
                                                                
                                                            }
                                                        } 
                                                 ],
                      template: $translate.instant('MSG_INVALID_FIXE')
                    });
       // alert($translate.instant('MSG_INVALID_FIXE')+phoneFormat);
        return false;
              }         
          }
      } 

      if($scope.associationContact.cellModel.length > 0){
          for(var i=0; i < $scope.associationContact.cellModel.length; i++){
            if($scope.associationContact.cellModel[i].value!==null && $scope.associationContact.cellModel[i].value!=="" && !UTIL_SERVICE.isValidPhoneNo($scope.associationContact.cellModel[i].value)){

                $scope.triggeredButton = false;

                $ionicPopup.show({
                  //title: $translate.instant('CON_TITLE_2'),
                  cssClass:'form-alert-popup',
                                    buttons: [
                                                    { 
                                                        text: 'OK', 
                                                        type:'button-default first-button last-button',
                                                        onTap: function(e) {
                                                            
                                                        }
                                                    } 
                                             ],
                  template: $translate.instant('MSG_INVALID_MOBILE')
                });
                //alert($translate.instant('MSG_INVALID_CELL')+phoneFormat);
                return false;
                } 
            }
      }

      if($scope.associationContact.address3!==undefined && $scope.associationContact.address3!==null && $scope.associationContact.address3!=="" && !UTIL_SERVICE.isValidPostalCode($scope.associationContact.address3)){

        $scope.triggeredButton = false;

        $ionicPopup.show({
          //title: $translate.instant('CON_TITLE_2'),
          cssClass:'form-alert-popup',
                            buttons: [
                                            { 
                                                text: 'OK', 
                                                type:'button-default first-button last-button',
                                                onTap: function(e) {
                                                    
                                                }
                                            } 
                                     ],
          template: $translate.instant('MSG_INVALID_POSTALCODE')
        });
        //alert($translate.instant('MSG_INVALID_POSTALCODE'));
        return false;
      }

      if($scope.associationContact.emailModel.length > 0){
          for(var i=0; i < $scope.associationContact.emailModel.length; i++){
                if($scope.associationContact.emailModel[i].value!==null && $scope.associationContact.emailModel[i].value!=="" && !UTIL_SERVICE.isValidEmail($scope.associationContact.emailModel[i].value)){

                    $scope.triggeredButton = false;

                    $ionicPopup.show({
                      //title: $translate.instant('CON_TITLE_2'),
                      cssClass:'form-alert-popup',
                                        buttons: [
                                                        { 
                                                            text: 'OK', 
                                                            type:'button-default first-button last-button',
                                                            onTap: function(e) {
                                                                
                                                            }
                                                        } 
                                                 ],
                      template: $translate.instant('MSG_INVALID_EMAIL')
                    });
                    //alert($translate.instant('MSG_INVALID_EMAIL'));
                    return false;
          }
        }
      }

      if($scope.associationContact.website!==null && $scope.associationContact.website!=="" && !UTIL_SERVICE.isValidWeb($scope.associationContact.website)){

            $scope.triggeredButton = false;

            $ionicPopup.show({
              //title: $translate.instant('CON_TITLE_2'),
              cssClass:'form-alert-popup',
                                buttons: [
                                                { 
                                                    text: 'OK', 
                                                    type:'button-default first-button last-button',
                                                    onTap: function(e) {
                                                        
                                                    }
                                                } 
                                         ],
              template: $translate.instant('MSG_INVALID_WEB')
            });
        //alert($translate.instant('MSG_INVALID_EMAIL'));
        return false;

      } 
      return true;
      
    }
})
.service('AssociationSharedProperties', function () {
    var property = null;

    return {
        getAssociationt: function () {
            return property;
        },
        setAssociation: function(value) {
            property = value;
        }
    };

});