app.controller('addeventcontroller', function($scope,$rootScope, $state, $ionicModal, $ionicPopup, $ionicPlatform, $ionicHistory, $ionicScrollDelegate,  $translate, $filter, appntService, DB, $cordovaCalendar, EventSharedProperties, $document,professionalService,patientGroupContactService, healthContactService,websiteService) {
     ADB.trackState($translate.instant('SEPA_AGENDA_ADD_MODIFY'));
    $scope.event = {
     id : "",
    apttype : 25,
    aptdate : "",
    description : "",
    reminder0 : 0,
    reminder1 : 0,
    reminder7 : 0,
    reminder8 : 0,
    contactName : "",
    eventId : "1"
    };
    
    $scope.rem0Dsbld = false;
    $scope.rem1Dsbld = false;          
    $scope.rem7Dsbld = false;
    $scope.rem8Dsbld = false;
    
    $scope.aptDateDay = "";
    $scope.aptDateTime = "";
    $scope.apttypename="";
    $scope.dateinfo=[];
    $scope.editMode = false;
    $scope.disableFlag = true;
    $scope.contactListShow = true;
    $scope.triggeredButton = false;
    
    
    $scope.dateformat = 'dd  MMMM  yyyy';
    $scope.timeformat = "HH 'h' mm";
    $scope.showingContactPopup = false;
    $scope.showingSEPContactPopup = false;
    $rootScope.showingEventSecondPopup = false;
    $scope.buttonName = $translate.instant('SAVE');
    $scope.headerTitle = $translate.instant('ADD_EVENT_HEADER');

    $scope.intitulelistitems = [
    {listId: "0", listName: $translate.instant('ADDEVENT_LIST_ITEM1')},
    {listId: "1", listName: $translate.instant('ADDEVENT_LIST_ITEM2')},
    {listId: "2", listName: $translate.instant('ADDEVENT_LIST_ITEM3')},
    {listId: "3", listName: $translate.instant('ADDEVENT_LIST_ITEM4')},
    {listId: "4", listName: $translate.instant('ADDEVENT_LIST_ITEM5')},
    {listId: "5", listName: $translate.instant('ADDEVENT_LIST_ITEM6')},
    {listId: "6", listName: $translate.instant('ADDEVENT_LIST_ITEM7')},
    {listId: "7", listName: $translate.instant('ADDEVENT_LIST_ITEM8')},
    {listId: "8", listName: $translate.instant('ADDEVENT_LIST_ITEM9')},
    {listId: "9", listName: $translate.instant('ADDEVENT_LIST_ITEM10')},
    {listId: "10", listName: $translate.instant('ADDEVENT_LIST_ITEM11')},
    {listId: "11", listName: $translate.instant('ADDEVENT_LIST_ITEM12')},
    {listId: "12", listName: $translate.instant('ADDEVENT_LIST_ITEM13')},
    {listId: "13", listName: $translate.instant('ADDEVENT_LIST_ITEM14')},
    {listId: "14", listName: $translate.instant('ADDEVENT_LIST_ITEM15')},
    {listId: "15", listName: $translate.instant('ADDEVENT_LIST_ITEM16')},
    {listId: "16", listName: $translate.instant('ADDEVENT_LIST_ITEM17')},
    {listId: "17", listName: ""}
  ];
   
  $scope.contactFieldEditable = false;
  $scope.focusme = "";
  $scope.popup;
  $scope.pastContact = "";
  $scope.aptDateDayDisp = "";
  $scope.isEvntsPriorRemindrsEnabled = false;
    
    
    $scope.init = function(){
        var evnt = EventSharedProperties.getEvent();
        if(localStorage.getItem('eventToggle') == undefined){
            localStorage.setItem('eventToggle',true);
        }
        $scope.isEvntsPriorRemindrsEnabled = localStorage.getItem('eventToggle');
        
        if(evnt != null){
            $scope.event = evnt;
            $scope.aptDateDay = $filter('date')(new Date(evnt.aptDate), $scope.dateformat);
            var momentFormat = moment(new Date(evnt.aptDate));
            $scope.aptDateDayDisp = momentFormat.locale("fr").format('LL');
            
            $scope.aptDateTime = evnt.aptTime;
            
            if(evnt.apttype !== "" && evnt.apttype>=0){
                $scope.apttypename = $scope.intitulelistitems[evnt.apttype].listName;
            }

            if($scope.event.apttype === ""){
                $scope.event.apttype = 25;
            }

            if(parseInt(evnt.apttype) === 17){
                $scope.apttypename = "Autre";
            }

            if($scope.event.reminder0 === null || $scope.event.reminder0 === "null"){
                $scope.event.reminder0 = 0;
            }

            if($scope.event.reminder1 === null || $scope.event.reminder1 === "null"){
                $scope.event.reminder1 = 0;
            }

            if($scope.event.reminder7 === null || $scope.event.reminder7 === "null"){
                $scope.event.reminder7 = 0;
            }

            if($scope.event.reminder8 === null || $scope.event.reminder8 === "null"){
                $scope.event.reminder8 = 0;
            }
            $scope.headerTitle = $translate.instant('EDIT_EVENT_HEADER');
            $scope.editMode = true;
        }else{
            $scope.editMode = false;
        }
    };

    $ionicPlatform.onHardwareBackButton(function(event){
        if($scope.contactpopup !== undefined){
               $scope.contactpopup.close();
               $rootScope.showingEventSecondPopup = false;
        }
    });
      
    $ionicModal.fromTemplateUrl('templates/intitulelist.html', {
        scope: $scope
    }).then(function(modal) {
        $scope.modal = modal;
    });

    $rootScope.hideModal = function(){
          if($scope.modal !== undefined){
              $scope.modal.hide();
          }
          if($scope.eventContactModel !== undefined){
              $scope.eventContactModel.hide();
          }
          if($scope.documentmodel !== undefined){
              $scope.documentmodel.hide();
          }
          if($scope.questionmodel !== undefined){
              $scope.questionmodel.hide();
          }
      }
    
    $scope.listTitles = function(){
        ADB.trackState($translate.instant('SEPA_AGENDA_ADDNEW_INTITULE_SELECTION'),{});
        $scope.oldAptType = $scope.event.apttype;
        $scope.modal.show();
    }

    $scope.blurAllFormInput = function(){
        //ionic.DomUtil.blurAll()
    }

    $scope.editEvent = function(){
//        ADB.trackState($translate.instant('SEPA_MODIFY_EVENT'));
        $scope.buttonName = $translate.instant('VALIDER');
        $scope.editMode = false;
        var reminder=parseInt($scope.event.reminder0)+parseInt($scope.event.reminder1)+parseInt($scope.event.reminder7)+parseInt($scope.event.reminder8);
        if(reminder === 2){
            $scope.disableDefaultOptions(true);
        } else{
            $scope.disableDefaultOptions(false);
        }
    }

    $scope.showContactList = function(){
        ADB.trackState($translate.instant('SEPA_AGENDA_ADDNEW_CHOOSE_CONTACT'),null);
        //if($scope.contactFieldEditable == false){
        $scope.popup = $ionicPopup.show({
                templateUrl:'templates/contactlistoption.html',
                cssClass:'popup-list-close',
                scope: $scope,
                animation: 'slide-in-up'
        });
        //}
    }

    $scope.closeContactListOption = function(){
        //$scope.contactsmodal.hide();
        $scope.popup.close();
    }

    $scope.closeContactListOption2 = function(){
        //$scope.contactsmodal.hide();
        //$scope.contactPopup.close();
        $scope.contactpopup.close();
        $scope.showContactList();
        $rootScope.showingEventSecondPopup = false;
    }
    
    $scope.pickSepaContacts = function(){
        ADB.trackState($translate.instant('SEPA_AGENDA_ADDNEW_CHOOSE_CONTACT_SEP'));
        $scope.popup.close();
        $rootScope.showingEventSecondPopup = true;
        $scope.contactpopup = $ionicPopup.show({
                templateUrl:'templates/contactstypelist.html',
                cssClass:'popup-list-close contactlistname',
                scope: $scope,
                animation: 'slide-in-up'
        });
    }
    
    $scope.contactList = [];
    $ionicModal.fromTemplateUrl('templates/eventcontactslistselect.html', {
        scope: $scope
    }).then(function(modal) {
        $scope.eventContactModel = modal;
    });
    $scope.openContacts = function(contactType){
        $scope.pastContact = $scope.event.contactName;
        $scope.contactList = [];
        switch(contactType){
            case 1:
                ADB.trackState($translate.instant('SEPA_AGENDA_PROF'));
                professionalService.selectAllprofessionalContacts().then(function(result){
                    var contactCount = result.rows.length;
                    if(contactCount == 0){
                        $scope.contactListShow = false;
                    }else{
                        $scope.contactListShow = true;
                    }
                
                    for(var i=0;i<contactCount;i++){
                         var object = result.rows.item(i);
                         object.phone = aesUtil.decrypt(salt, iv, passPhrase, object.phone);
                         object.cell = aesUtil.decrypt(salt, iv, passPhrase, object.cell)
                         object.email = aesUtil.decrypt(salt, iv, passPhrase, object.email);
                         object.address = aesUtil.decrypt(salt, iv, passPhrase, object.address);
                         $scope.contactList.push(object);
                    }
                },function(error){});
                break;
            case 2:
            ADB.trackState($translate.instant('SEPA_AGEMDA_PATIENT'));
                patientGroupContactService.selectAllpatientGroupContacts().then(function(result){
                    var contactCount = result.rows.length;
                    if(contactCount == 0){
                        $scope.contactListShow = false;
                    }else{
                        $scope.contactListShow = true;
                    }
                    for(var i=0;i<contactCount;i++){
                         var object = result.rows.item(i);
                         object.address = aesUtil.decrypt(salt, iv, passPhrase, object.address);
                         object.phone = aesUtil.decrypt(salt, iv, passPhrase, object.phone);
                         object.cell = aesUtil.decrypt(salt, iv, passPhrase, object.cell);
                         object.email = aesUtil.decrypt(salt, iv, passPhrase, object.email);
                         $scope.contactList.push(object);
                    }
                },function(error){});
                break;
            case 3:
            ADB.trackState($translate.instant('SEPA_AGENDA_HEALTH'));
                healthContactService.selectAllHealthContacts().then(function(result){
                    var contactCount = result.rows.length;
                    if(contactCount == 0){
                        $scope.contactListShow = false;
                    }else{
                        $scope.contactListShow = true;
                    }
                    for(var i=0;i<contactCount;i++){
                        var obectListStore = [];
                        var objectItemHealth = result.rows.item(i);
                        objectItemHealth.address = aesUtil.decrypt(salt, iv, passPhrase, objectItemHealth.address);
                        objectItemHealth.phone = aesUtil.decrypt(salt, iv, passPhrase, objectItemHealth.phone);
                        objectItemHealth.phoneExtra = aesUtil.decrypt(salt, iv, passPhrase, objectItemHealth.phoneExtra);
                        objectItemHealth.phone2 = aesUtil.decrypt(salt, iv, passPhrase, objectItemHealth.phone2);
                        objectItemHealth.phone2Extra = aesUtil.decrypt(salt, iv, passPhrase, objectItemHealth.phone2Extra);
                        objectItemHealth.fax = aesUtil.decrypt(salt, iv, passPhrase, objectItemHealth.fax);
                        objectItemHealth.email = aesUtil.decrypt(salt, iv, passPhrase, objectItemHealth.email);
                        objectItemHealth.email2 = aesUtil.decrypt(salt, iv, passPhrase, objectItemHealth.email2);
                        
                        obectListStore.id = objectItemHealth.id;
                        var res = objectItemHealth.name.split("%SEPA%");
                        if(res.length > 0) {
                           var contactName = res[0];
                           var contactDesc = res[1];
                           obectListStore.name = contactName; 
                        }
                        $scope.contactList.push(obectListStore);
                    }
                },function(error){});
                break;
            case 4:
            ADB.trackState($translate.instant('SEPA_AGENDA_WEB'));
                websiteService.selectAllWebSites().then(function(result){
                    var contactCount = result.rows.length;
                    if(contactCount == 0){
                        $scope.contactListShow = false;
                    }else{
                        $scope.contactListShow = true;
                    }
                    for(var i=0;i<contactCount;i++){
                        var objectItem = result.rows.item(i);
                        var res = objectItem.description.split("%SEPA%");
                        if(res.length > 0) {
                           var contactName = res[0];
                           var contactDesc = res[1];
                           objectItem.description = contactDesc; 
                           objectItem.name = contactName;
                        } else {
                           objectItem.name = objectItem.description;
                        }
                         //var object = result.rows.item(i);
                         $scope.contactList.push(objectItem);
                    }
                },function(error){});
                break;
        }
        $scope.contactpopup.close();
        $scope.eventContactModel.show();
    }
    
    $scope.cancelContactlist = function(){
   //     ADB.trackState($translate.instant('SEPA_CONTACT_LIST_ANNULER'));
   ADB.trackState($translate.instant('SEPA_AGENDA_ADD_MODIFY'));
        $scope.event.contactName = $scope.pastContact;
        $ionicScrollDelegate.$getByHandle('contactlistscroll').scrollTop();
        $scope.eventContactModel.hide();
    }
    
    $scope.saveContactlist = function(){
//        ADB.trackState($translate.instant('SEPA_CONTACT_LIST_SAVE'));
    ADB.trackState($translate.instant('SEPA_AGENDA_ADD_MODIFY'));
        $scope.eventContactModel.hide();
        $scope.contactFieldEditable = false;
        $scope.textAutoHeight();
    }

    $scope.textAutoHeight = function(){
        var autoElement = document.getElementById("event-contact-name");
        autoElement.style.height = "" + autoElement.scrollHeight + "px";
    }

    $scope.pickDeviceContacts = function(){
//        ADB.trackState($translate.instant('SEPA_AGENDA_ADDNEW_CHOOSE_CONTACT_DEVICE'));
        navigator.contacts.pickContact(function(contact){
            var name = contact.displayName;
            if(name === null) {
                name = contact.name.formatted;
            }
            $scope.event.contactName = name;
            $scope.contactFieldEditable = false;
            $scope.textAutoHeight();
            if (!$scope.$$phase) {
                $scope.$apply();
            }
        },function(err){
            console.log('Error: ' + err);
        });
        $scope.popup.close();
    }

    $scope.makeContactEditable = function(){
//        ADB.trackState($translate.instant('SEPA_AGENDA_ADDNEW_CHOOSE_CONTACT_FREETEXT'));
        $scope.contactFieldEditable = true;
        $scope.disableFlag = false;
        setTimeout(function(){ 
                //alert("Hello"); 
                $scope.popup.close(); 
                //document.getElementById("event-contact-name").focus();
                  var elObj = document.getElementById("event-contact-name");
                  elObj.focus();
                  var s = elObj.value;
                  elObj.value = '';
                  elObj.value = s; 
        }, 0);
    }


    
   $scope.showDatePicker = function(){
        //$scope.options = {date: new Date(), mode: 'date'};
        $scope.options = {
               date: ($scope.aptDateDay==="")? new Date() : new Date($scope.aptDateDay),
               mode: 'date',
               androidTheme:1,
               locale: 'fr_FR',
               doneButtonLabel: "Valider",
               cancelButtonLabel: "Annuler",
               okText:"Valider",
               cancelText:"Annuler"
               };
        window.datePicker.show($scope.options, function(date){
            if(date && date !== "Invalid Date" ){
                $scope.aptDateDay = $filter('date')(date, $scope.dateformat);
                $scope.dateinfo.date = date.getDate();
                $scope.dateinfo.month = date.getMonth();
                $scope.dateinfo.fullyear = date.getFullYear();
                
                var momentFormat = moment(date);
                $scope.aptDateDayDisp = momentFormat.locale("fr").format('LL');
            }
            $scope.$digest();
        });
    }
    $scope.showTimePicker = function(){
        
        $scope.options = {
               date: ($scope.aptDateTime==="")? new Date() : new Date("01 January 2000 "+$scope.aptDateTime.replace(" h ",":")),
               mode: 'time',
               is24Hour: true,
               androidTheme:1 ,
               locale: 'fr_FR',
               doneButtonLabel: "Valider",
               cancelButtonLabel: "Annuler",
               okText:"Valider",
               cancelText:"Annuler"
               };
        window.datePicker.show($scope.options, function(date){
          if(date && date !== "Invalid Date"){
              $scope.aptDateTime = $filter('date')(date, $scope.timeformat);
              $scope.dateinfo.hours = date.getHours();
              $scope.dateinfo.minutes = date.getMinutes();
          }
            $scope.$digest();
        });
    }
    $scope.cancelEvent = function(){
        //ADB.trackState($translate.instant('SEPA_AGENDA_ADDNEW_ANNULER'));
        if ($state.current.name === 'app.addevent') {
             $state.go('app.agenda.events');
        } else if($state.current.name === "app.addevent.fromDashboard"){
            $state.go('app.dashboard');
        } else {
             $state.go('app.agenda.calendar');
        }
        
    }
    $scope.saveIntituleOption = function(){
       // ADB.trackState($translate.instant('SEPA_AGENDA_ADDNEW_INTITULE_SELECTION_VALIDER'));
        ADB.trackState($translate.instant('SEPA_AGENDA_ADD_MODIFY'));
        if(parseInt($scope.event.apttype) >= 0 && parseInt($scope.event.apttype) <= ($scope.intitulelistitems.length - 2)){
            $scope.apttypename = $scope.intitulelistitems[$scope.event.apttype].listName;
            $scope.modal.hide();
        } else{
            console.log("Failed Seelcting Intitule");
        }
    }

    $scope.cancelIntitulelist = function(){
        //ADB.trackState($translate.instant('SEPA_AGENDA_ADDNEW_INTITULE_SELECTION_ANNULER'));
        ADB.trackState($translate.instant('SEPA_AGENDA_ADD_MODIFY'));
        $scope.event.apttype = $scope.oldAptType;
        $ionicScrollDelegate.$getByHandle('intitulescroll').scrollTop();
        $scope.modal.hide();
    }

    
    $scope.saveEvent = function(){
        $scope.triggeredButton = true;
      //  ADB.trackState($translate.instant('SEPA_AGENDA_ADDNEW_AJOUTER'));
        if(parseInt($scope.event.apttype) === 25){
            $scope.event.apttype = "";
        }
        if($scope.isValidInput()){
            var oldEventData = EventSharedProperties.getEvent();
            if(oldEventData == null){//New Event case
               //  add new
                    $scope.addEvent();
                
            } else {//Existing event modification
                
            // modifiy
            var oldEventRec=appntService.getEvent(oldEventData.id);
            $scope.updateEvent(oldEventRec);
                  
            }

        }
    }

    $scope.isValidInput=function(){
              if($scope.event.description===null || $scope.event.description==="" ){
                $scope.triggeredButton = false;
                $ionicPopup.show({
                    cssClass:'form-alert-popup',
                            buttons: [
                                            { 
                                                text: 'OK', 
                                                type:'button-default first-button last-button',
                                                onTap: function(e) {
                                                    
                                                }
                                            } 
                                     ],
                            template: $translate.instant('MSG_TITRE_REQUIRED')
                });
                return false;
              } else if($scope.aptDateTime===null || $scope.aptDateTime==="" || $scope.aptDateDayDisp===null || $scope.aptDateDayDisp===""){
                $scope.triggeredButton = false;
                $ionicPopup.show({
                    cssClass:'form-alert-popup',
                            buttons: [
                                            { 
                                                text: 'OK', 
                                                type:'button-default first-button last-button',
                                                onTap: function(e) {
                                                    
                                                }
                                            } 
                                     ],
                            template: $translate.instant('MSG_HEURE_DATE_REQUIRED')
                });
                return false;
              }else if($scope.event.reminder0 == 0 && $scope.event.reminder1 == 0 && $scope.event.reminder7 == 0 && $scope.event.reminder8 == 0){
                $scope.triggeredButton = false;
                $ionicPopup.show({
                    cssClass:'form-alert-popup',
                            buttons: [
                                            { 
                                                text: 'OK', 
                                                type:'button-default first-button last-button',
                                                onTap: function(e) {
                                                    
                                                }
                                            } 
                                     ],
                            template: $translate.instant('MSG_REMINDER_REQUIRED')
                });
                return false;
              } else {
                $scope.triggeredButton = true;
                return true;
              }
        }

    $scope.disableDefaultOptions = function(action){
        if(parseInt($scope.event.reminder0) === 0){
            $scope.rem0Dsbld = action;
        }

        if(parseInt($scope.event.reminder1) === 0){
            $scope.rem1Dsbld = action;
        }

        if(parseInt($scope.event.reminder7) === 0){
            $scope.rem7Dsbld = action;
        }

         if(parseInt($scope.event.reminder8) === 0){
            $scope.rem8Dsbld = action;
        }
    }

    $scope.canSelect=function(id){
        var reminder=parseInt($scope.event.reminder0)+parseInt($scope.event.reminder1)+parseInt($scope.event.reminder7)+parseInt($scope.event.reminder8);
        if(reminder === 2){
            $scope.disableDefaultOptions(true);
        } else{
            $scope.disableDefaultOptions(false);
        }
    }

    $scope.showRappelMessage = function(){

        $ionicPopup.show({
                cssClass:'form-alert-popup',
                buttons: [
                                { 
                                    text: 'OK', 
                                    type:'button-default first-button last-button',
                                    onTap: function(e) {
                                    }
                                } 
                         ],
                template: $translate.instant('MSG_MAX_TWO_OPTIONS_SELECTED')
            });
    }

    $scope.getEventEndDate=function(startDateTime){
        return new Date(startDateTime.getTime()+(60*60*1000));
    }

    $scope.getEvent=function(){
     $scope.event.aptdate = $scope.aptDateDay +" "+ $scope.aptDateTime.replace(" h ",":");
       //$scope.dateinfo=new Date($scope.event.aptdate);

       var date = new Date($scope.event.aptdate);
                    $scope.dateinfo.date = date.getDate();
                    $scope.dateinfo.month = date.getMonth();
                    $scope.dateinfo.fullyear = date.getFullYear();
                    $scope.dateinfo.hours = date.getHours();
                    $scope.dateinfo.minutes = date.getMinutes();
       

            var startDateTime=new Date($scope.dateinfo.fullyear, $scope.dateinfo.month, $scope.dateinfo.date, $scope.dateinfo.hours, $scope.dateinfo.minutes, 0, 0, 0);
            var endDateTime = $scope.getEventEndDate(startDateTime);
            

            var strAvec=($scope.event.contactName!=="" && $scope.event.contactName !== null && $scope.event.contactName !== "null") ? " avec " +$scope.event.contactName:"";
            var objEventJson={
                title: $scope.event.description+strAvec,
                location: null,//$scope.event.apttype,
                notes: $scope.event.description,
                startDate: startDateTime,
                endDate: endDateTime,
                firstReminderMinutes: null,
                secondReminderMinutes: null,
                recurrence: null, // options are: 'daily', 'weekly', 'monthly', 'yearly'
                recurrenceInterval: 1, // only used when recurrence is set
                recurrenceEndDate: null,
                calendarName: null,
                calendarId: null,
                url: null
            };

            if(localStorage.getItem('eventToggle') !== undefined && (localStorage.getItem('eventToggle') === true || localStorage.getItem('eventToggle') === "true")){
                var slotTimeInMinutes = [10080, 1440, 120, 60];
                var reminderSlotPosition = [$scope.event.reminder7, $scope.event.reminder1, $scope.event.reminder8, $scope.event.reminder0];
                var selectedSlotTime = [];
                for(var rSlot in reminderSlotPosition){
                    if(parseInt(reminderSlotPosition[rSlot]) === 1){
                        selectedSlotTime.push(slotTimeInMinutes[rSlot]);
                    }
                }
                if(selectedSlotTime[0] != undefined){
                    objEventJson.firstReminderMinutes=selectedSlotTime[0];
                }
                if(selectedSlotTime[1] != undefined){
                    objEventJson.secondReminderMinutes=selectedSlotTime[1];
                }
            }
            return objEventJson;
 }

 $scope.addEvent=function(){
    $rootScope.showLoader();
        $scope.items = [];
    var  objEventJson=$scope.getEvent();
        $cordovaCalendar.createEventWithOptions(objEventJson).then(function (result) {
            $scope.event.eventId = result;
            var eventDataForService = angular.copy($scope.event);
            appntService.insertEvent(eventDataForService).then(function(result){
                    $state.go('app.agenda.events');   
                    $rootScope.hideLoader();                             
            },function(error){
                $rootScope.hideLoader();
                console.log("Error Inserting Event : "+error);
                $ionicPopup.alert({
                    title: 'Error',
                    template: 'Unable to add event'
                });
            });
        }, function (err) {
            $rootScope.hideLoader();
            console.error("There was an error: " + err);
            $ionicPopup.alert({
                title: 'Error',
                template: 'Unable to add event'
            });
        });
 }

 $scope.updateEvent=function(oldEventRec){
    $rootScope.showLoader();
            //var date = new Date(oldEventRec.aptDate+" "+oldEventRec.aptTime.replace(" h ",":"));
            var date = new Date(oldEventRec.aptdate);
            $scope.dateinfo.date = date.getDate();
            $scope.dateinfo.month = date.getMonth();
            $scope.dateinfo.fullyear = date.getFullYear();
            $scope.dateinfo.hours = date.getHours();
            $scope.dateinfo.minutes = date.getMinutes();
            var oldEventData=oldEventRec;

            var startDateTime=new Date($scope.dateinfo.fullyear, $scope.dateinfo.month, $scope.dateinfo.date, $scope.dateinfo.hours, $scope.dateinfo.minutes, 0, 0, 0);
            var endDateTime = $scope.getEventEndDate(startDateTime);

            var strAvec=(oldEventData.contactName!=="" && oldEventData.contactName !== null && oldEventData.contactName !== "null") ? " avec " +$scope.event.contactName:""; 
        
            var objOldEventJson={
            title: oldEventData.description + strAvec,//oldEventData.contactName,
            //location: oldEventData.apttype,
            notes: oldEventData.description,
            startDate:startDateTime, 
            endDate: endDateTime
            };

            $cordovaCalendar.deleteEvent(objOldEventJson).then(function (result) {
                     var objModifedEvent=$scope.getEvent();
                      $cordovaCalendar.createEventWithOptions(objModifedEvent).then(function (result) {
                            var eventDataForService = angular.copy($scope.event);
                            appntService.updateEvent(eventDataForService).then(function(result){
                                    localStorage.setItem("DashBoardEventDeleted"+oldEventData.id,false);
                                    $state.go('app.agenda.events');
                                    $rootScope.hideLoader();                                
                            },function(error){
                                    $rootScope.hideLoader();
                                    console.log("Error Inserting Event : "+error);
                                    $ionicPopup.alert({
                                        title: 'Error',
                                        template: 'Unable to update event'
                                    });
                            });
                            
                            }, function (err) {
                                $rootScope.hideLoader();
                                console.error("There was an error: " + err);
                                $ionicPopup.alert({
                                    title: 'Error',
                                    template: 'Unable to add event'
                                });
                    });
                    
            }, function (err) {
                $rootScope.hideLoader();
                console.error("There was an error: " + err);
                $ionicPopup.alert({
                    title: 'Error',
                    template: 'Unable to update event'
                });
            });
                
        }
    })  



.service('EventSharedProperties', function () {
    var property = null;

    return {
        getEvent: function () {
            return property;
        },
        setEvent: function(value) {
            property = value;
        }
    };

});

app.directive('focusMe', function ($timeout) {
  /*return {
    link: function (scope, element, attrs) {
      if (attrs.focusMeDisable === "true") {
        return;
      }
      $timeout(function () {
        element[0].focus();
        if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
          cordova.plugins.Keyboard.show(); //open keyboard manually
        }
      }, 350);
    }
  };*/
}) .directive('ionRadioFix', function() {
  return {
    restrict: 'E',
    replace: true,
    require: '?ngModel',
    transclude: true,
    template:
      '<label class="item item-radio">' +
        '<input type="radio" class="testerd" name="radio-group">' +
        '<div class="radio-content">' +
          '<div class="item-content disable-pointer-events" ng-transclude></div>' +
          '<i class="radio-icon disable-pointer-events icon ion-checkmark"></i>' +
        '</div>' +
      '</label>',

    compile: function(element, attr) {
      if (attr.icon) {
        var iconElm = element.find('i');
        iconElm.removeClass('ion-checkmark').addClass(attr.icon);
      }

      var input = element.find('input');
      angular.forEach({
          'name': attr.name,
          'value': attr.value,
          'disabled': attr.disabled,
          'ng-value': attr.ngValue,
          'ng-model': attr.ngModel,
          'ng-disabled': attr.ngDisabled,
          'ng-change': attr.ngChange,
          'ng-required': attr.ngRequired,
          'required': attr.required
      }, function(value, name) {
        if (angular.isDefined(value)) {
            input.attr(name, value);
          }
      });

      return function(scope, element, attr) {
        scope.getValue = function() {
          return scope.ngValue || attr.value;
        };
      };
    }
  };
});




