app.controller('addtreatmentcontroller', function($scope, $rootScope,$ionicScrollDelegate,$ionicPlatform, $state, $translate, $ionicModal, $ionicPopup, $cordovaCamera, $filter, DB, TreatmentSharedProperties, notificationutil,treatmentService) {
   
    $scope.editMode = false;
    $scope.fromEditMode = false;
    $scope.inAddMode = true;
    $scope.changedTabValue = false;
    $scope.pickerLabel = "";
    $scope.treatmenttype = 0;
    $scope.listoption = {weekSelected:""};
    $scope.pharmaicontype = "";
    $scope.editModePressed = false;
    $scope.dateformat = 'dd  MMMM  yyyy';
    $scope.timeformat = "HH 'h' mm";
    $scope.imageOptArray = [{"item":"gallery","selectedId": 1},{"item":"Camera","selectedId": 2}];
    $scope.frequencyDisplayName = "";
    $scope.dureeDisplayName = "Durée";
    $scope.frequencyOptionsName = {1: 'Journalière', 2: 'Hebdomadaire', 3: 'Mensuelle', 4: 'Tous les'};
    $scope.reminderLength = 0;
    $scope.oldTakenCount = 0;
    $scope.defaultReminderLength = 0;
    $scope.reminderNotEntered = false;
    $scope.morgDisabled = false;
    $scope.aftrnunDisabled = false;
    $scope.evngDisabled = false;
    $scope.popupShow = false;
    $scope.oldTreatmentObj = null;
    $scope.triggeredButton = false;
    $scope.boiteDisplayValue = "0";
    $scope.buttonName = $translate.instant('SAVE');
    $scope.headerTitle = $translate.instant('MY_TREATMENTS_ADD_MSG');
    $scope.weeklyOptionsName  =  {
        1: $translate.instant('MONDAY'),
        2: $translate.instant('TUESDAY'),
        3: $translate.instant('WEDNESDAY'), 
        4: $translate.instant('THRUSDAY'),
        5: $translate.instant('FRIDAY'),
        6: $translate.instant('SATURDAY'),
        7: $translate.instant('SUNDAY')
    };
    $scope.medicineTakePlace = [$translate.instant('AVANT_LE_REPAS'),$translate.instant('PENDANT_LE_REPAS'),$translate.instant('APRES_LE_REPAS')];

    $scope.timeSlots =  [];
    $scope.everyOptionsName = {1: 'Jour(s)', 2: 'Semaine(s)', 3: 'Mois'};
    $scope.treatmentlist = [
        {listId: "1", listType:"tablet",  listName: $translate.instant('TREATMENTS_LIST_ITEM1')},
        {listId: "2", listType:"effervescent",  listName: $translate.instant('TREATMENTS_LIST_ITEM2')},
        {listId: "3", listType:"capsule", listName: $translate.instant('TREATMENTS_LIST_ITEM3')},
        {listId: "4", listType:"granules",  listName: $translate.instant('TREATMENTS_LIST_ITEM4')},
        {listId: "5", listType:"syrup",  listName: $translate.instant('TREATMENTS_LIST_ITEM5')},
        {listId: "6", listType:"oinment",  listName: $translate.instant('TREATMENTS_LIST_ITEM6')},
        {listId: "7", listType:"patch",  listName: $translate.instant('TREATMENTS_LIST_ITEM7')},
        {listId: "8", listType:"injection",  listName: $translate.instant('TREATMENTS_LIST_ITEM8')},
        {listId: "9", listType:"inhalation", listName: $translate.instant('TREATMENTS_LIST_ITEM9')},
        {listId: "10", listType:"suppository", listName: $translate.instant('TREATMENTS_LIST_ITEM10')},
        {listId: "11", listType:"bulb", listName: $translate.instant('TREATMENTS_LIST_ITEM11')},
        {listId: "12", listType:"drops", listName: $translate.instant('TREATMENTS_LIST_ITEM12')}
    ];
    
    $scope.treatmentArrayObj = {
          doseUnit : "",
          id : "",
          type : 2,
          name : "",
          doseFrequency : "",
          doseFrequencyUnit : "",
          doseFrequencyUnitValue : "",
          doseHour : "",
          doseMinute  : "",
          lastDoseTakenDate : "",
          boxCapacity : "",
          lastBoxOpenedDate : "",
          newBoxScheduledDate : "",
          doseTakenCount  : 0,
          medicineId : "",
          medicineType  : 25,
          durationType  : 0,
          reminderMatin  : 0,
          reminderMidi  : 0,
          reminderSoir  : 0,
          boiteNote  : "",
          durationValue : "",
          fileName  : "./img/Camera@3x.png",
          medicineIntake : "",
          reminderOther: "",
          otherStatus:null
    };

    $ionicPlatform.onHardwareBackButton(function(event){
          if($scope.Monthlypopup !== undefined){
               $scope.Monthlypopup.close();
               $scope.treatmentArrayObj.doseFrequencyUnit = $scope.oldFrequencyValue;
               $scope.frequencyDisplayName = $scope.oldFrequencyName;
               $scope.treatmentArrayObj.doseFrequencyUnitValue = $scope.oldMonthlyValue;
               $rootScope.showingTreatmentRappelPopup = false;
          }
          if($scope.Weeklypopup !== undefined){
               $scope.Weeklypopup.close();
               $scope.treatmentArrayObj.doseFrequencyUnit = $scope.oldFrequencyValue;
               $scope.frequencyDisplayName = $scope.oldFrequencyName;
               $scope.treatmentArrayObj.doseFrequencyUnitValue = $scope.oldWeeklyValue;
               $scope.listoption.weekSelected = $scope.oldListOptionValue;
               $rootScope.showingTreatmentRappelPopup = false;
          }
          if($scope.Everypopup !== undefined){
               $scope.Everypopup.close();
               $scope.treatmentArrayObj.doseFrequencyUnit = $scope.oldFrequencyValue;
              $scope.frequencyDisplayName = $scope.oldFrequencyName;
              $scope.treatmentArrayObj.doseFrequencyUnitValue = $scope.oldEveryValue;
               $rootScope.showingTreatmentRappelPopup = false;
          }
    });
    
    $scope.init = function(){
        var treatmentEditValue = TreatmentSharedProperties.getTreatment();
        var treatmentAddValue = TreatmentSharedProperties.getAddTreatment();
        if(treatmentAddValue !== null && treatmentAddValue !== undefined){
          treatmentAddValue.formepharma = (treatmentAddValue.medicineType!=null && treatmentAddValue.medicineType !== "")?$scope.treatmentlist[treatmentAddValue.medicineType-1].listName:"";
          $scope.pharmaicontype = (treatmentAddValue.medicineType!=null && treatmentAddValue.medicineType !== "")?$scope.treatmentlist[treatmentAddValue.medicineType-1].listType:"";
          $scope.frequencyDisplayName = $scope.frequencyOptionsName[treatmentAddValue.doseFrequencyUnit];
          
          if(treatmentAddValue.medicineType === "" || treatmentAddValue.medicineType === null){
              treatmentEditValue.medicineType = 25;
          }

            if(parseInt(treatmentAddValue.doseFrequencyUnit) === 1){

            } else if(parseInt(treatmentAddValue.doseFrequencyUnit)  === 2){
                $scope.frequencyDisplayName += " " + $scope.weeklyOptionsName[parseInt(treatmentAddValue.doseFrequencyUnitValue)];
            } else if(parseInt(treatmentAddValue.doseFrequencyUnit) === 3){
                $scope.frequencyDisplayName += " "+ $translate.instant('THE') + " " + parseInt(treatmentAddValue.doseFrequencyUnitValue);
            } else if(parseInt(treatmentAddValue.doseFrequencyUnit) === 4){
                var splitUpScrollValue = treatmentAddValue.doseFrequencyUnitValue.split(",");
                $scope.frequencyDisplayName += " "+ splitUpScrollValue[0] + " " + $scope.everyOptionsName[parseInt(splitUpScrollValue[1])];
            }

            var durationScrollValue = [];
            if(treatmentAddValue.durationValue != null) {
              durationScrollValue = treatmentAddValue.durationValue.split(",");
            }
            if(durationScrollValue.length === 2){
                $scope.dureeDisplayName =  " "+ durationScrollValue[0] + " " + $scope.everyOptionsName[parseInt(durationScrollValue[1])];
            } else {
                $scope.dureeDisplayName = "Durée";
            }
            if(treatmentAddValue.reminderOther !== "" && treatmentAddValue.reminderOther !== null){
                var slotListObj = JSON.parse(treatmentAddValue.reminderOther);
                $scope.timeSlots = slotListObj;
            }

            //$scope.reminderLength = parseInt(treatmentAddValue.doseFrequency);
            $scope.defaultReminderLength = 0;
            if(parseInt(treatmentAddValue.reminderMatin) === 1){
                $scope.defaultReminderLength += 1;
            }

            if(parseInt(treatmentAddValue.reminderMidi) === 1){
                $scope.defaultReminderLength += 1;
            }

            if(parseInt(treatmentAddValue.reminderSoir) === 1){
                $scope.defaultReminderLength += 1;
            }
            $scope.reminderLength = parseInt($scope.defaultReminderLength) + parseInt($scope.timeSlots.length);
            if(treatmentAddValue.lastBoxOpenedDate === null || treatmentAddValue.lastBoxOpenedDate === "null"){
                treatmentAddValue.lastBoxOpenedDate = new Date();
            }
            if(treatmentAddValue.newBoxScheduledDate === null || treatmentAddValue.newBoxScheduledDate === "null"){
                treatmentAddValue.newBoxScheduledDate = new Date();
            }
            if(treatmentAddValue.lastBoxOpenedDate !== "" && treatmentAddValue.newBoxScheduledDate !== ""){
              var momentFormat = moment(treatmentAddValue.lastBoxOpenedDate);
              treatmentAddValue.lastBoxOpenedDateDisplay = momentFormat.locale("fr").format('LL');
              momentFormat = moment(treatmentAddValue.newBoxScheduledDate);
              treatmentAddValue.newBoxScheduledDateDisplay = momentFormat.locale("fr").format('LL');
            } else{
              treatmentAddValue.lastBoxOpenedDateDisplay = "";
              treatmentAddValue.newBoxScheduledDateDisplay = "";
            }
            if(treatmentAddValue.boxCapacity === ""){
                $scope.boiteDisplayValue = "0";
            } else{
                $scope.boiteDisplayValue = treatmentAddValue.boxCapacity;
            }

            $scope.treatmentArrayObj = treatmentAddValue;
            TreatmentSharedProperties.resetAddTreatment();

            if($scope.treatmentArrayObj.doseFrequency !== "" && $scope.reminderLength === parseInt($scope.treatmentArrayObj.doseFrequency)){
                $scope.disableDefaultOptions(true);
            } else{
                $scope.disableDefaultOptions(false);
            }
        }
        if(treatmentEditValue.id != null && treatmentEditValue.id !== "" && treatmentEditValue.id !== undefined){
            treatmentEditValue.formepharma = (treatmentEditValue.medicineType!=null && treatmentEditValue.medicineType !== "")?$scope.treatmentlist[treatmentEditValue.medicineType-1].listName:"";
            $scope.pharmaicontype = (treatmentEditValue.medicineType!=null && treatmentEditValue.medicineType !== "")?$scope.treatmentlist[treatmentEditValue.medicineType-1].listType:"";
            $scope.frequencyDisplayName = $scope.frequencyOptionsName[treatmentEditValue.doseFrequencyUnit];
            if(treatmentEditValue.medicineType === "" || treatmentEditValue.medicineType === null){
                treatmentEditValue.medicineType = 25;
            }
            if(parseInt(treatmentEditValue.doseFrequencyUnit) === 1){

            } else if(parseInt(treatmentEditValue.doseFrequencyUnit) === 2){
                $scope.frequencyDisplayName += " " + $scope.weeklyOptionsName[parseInt(treatmentEditValue.doseFrequencyUnitValue)];
            } else if(parseInt(treatmentEditValue.doseFrequencyUnit) === 3){
                $scope.frequencyDisplayName += " "+ $translate.instant('THE') + " " + parseInt(treatmentEditValue.doseFrequencyUnitValue);
            } else{
                var splitUpScrollValue = treatmentEditValue.doseFrequencyUnitValue.split(",");
                $scope.frequencyDisplayName += " "+ splitUpScrollValue[0] + " " + $scope.everyOptionsName[parseInt(splitUpScrollValue[1])];
            }

            var durationScrollValue = [];
            if(treatmentEditValue.durationValue != null) {
              durationScrollValue = treatmentEditValue.durationValue.split(",");
            }
            
            if(durationScrollValue.length === 2){
                $scope.dureeDisplayName =  " "+ durationScrollValue[0] + " " + $scope.everyOptionsName[parseInt(durationScrollValue[1])];
            } else {
                $scope.dureeDisplayName = "Durée";
            }
            // $scope.timeSlots = [];
            if(treatmentEditValue.reminderOther !== "" && treatmentEditValue.reminderOther !== null){
                var slotListObj = JSON.parse(treatmentEditValue.reminderOther);
                $scope.timeSlots = slotListObj;
            }
            if(treatmentEditValue.doseHour != null && treatmentEditValue.doseMinute != null) {
                var timeSlotLength = 0;
                var doseHourArray = treatmentEditValue.doseHour.split("!");
                var doseMinuteArray = treatmentEditValue.doseMinute.split("!");

                for(var iSlot in doseHourArray) {
                    if(!isNaN(doseHourArray[iSlot])) {
                        var timeSlotValue;
                        timeSlotValue = ((doseHourArray[iSlot]) < 10) ? "0"+doseHourArray[iSlot]+ " h " : doseHourArray[iSlot]+ " h ";
                        timeSlotValue += ((doseMinuteArray[iSlot]) < 10) ? "0"+doseMinuteArray[iSlot] : doseMinuteArray[iSlot];
                        $scope.timeSlots.push({index:timeSlotLength, id:parseInt(timeSlotLength)+1, value: timeSlotValue, meal:""});
                        timeSlotLength += 1;
                    }
                }
            }
            $scope.reminderLength = parseInt(treatmentEditValue.doseFrequency);
            $scope.defaultReminderLength = 0;
            if(parseInt(treatmentEditValue.reminderMatin) === 1){
                $scope.defaultReminderLength += 1;
            }

            if(parseInt(treatmentEditValue.reminderMidi) === 1){
                $scope.defaultReminderLength += 1;
            }

            if(parseInt(treatmentEditValue.reminderSoir) === 1){
                $scope.defaultReminderLength += 1;
            }
            if(treatmentEditValue.lastBoxOpenedDate === null || treatmentEditValue.lastBoxOpenedDate === "null")
                treatmentEditValue.lastBoxOpenedDate = new Date();
            if(treatmentEditValue.newBoxScheduledDate === null || treatmentEditValue.newBoxScheduledDate === "null")
                treatmentEditValue.newBoxScheduledDate = new Date();

            $scope.boiteDisplayValue = treatmentEditValue.boxCapacity;

            var momentFormat = moment(treatmentEditValue.lastBoxOpenedDate);
            treatmentEditValue.lastBoxOpenedDateDisplay = momentFormat.locale("fr").format('LL');
            momentFormat = moment(treatmentEditValue.newBoxScheduledDate);
            treatmentEditValue.newBoxScheduledDateDisplay = momentFormat.locale("fr").format('LL');
            $scope.oldTakenCount = treatmentEditValue.doseTakenCount;
            $scope.treatmentArrayObj = treatmentEditValue;
            $scope.oldTreatmentObj = JSON.stringify(treatmentEditValue);
            $scope.editMode = true;
            $scope.inAddMode = false;
            $scope.headerTitle = $translate.instant('MY_TREATMENTS_EDIT_MSG');
        }
    }

    $scope.onAddTabSelected = function(){
        setTimeout(function(){
            var tabWrapper = document.getElementsByClassName('add-treatment-tab-section');
            var i;
            var heightCalc = window.innerHeight;
            //console.log(screen.height+','+screen.availHeight+','+screen.availHeight+','+heightCalc);
            /*if(ionic.Platform.isAndroid()){
                if(screen.height == 567 || screen.height == 659)
                    heightCalc = heightCalc - 50;
            }*/
            for (i = 0; i < tabWrapper.length; i++) {
                //tabWrapper[i].style.minHeight = heightCalc+"px";
            }
        }, 0);
    }

    $scope.disableDefaultOptions = function(action){
        if(parseInt($scope.treatmentArrayObj.reminderMatin) === 0){
            $scope.morgDisabled = action;
        }

        if(parseInt($scope.treatmentArrayObj.reminderMidi) === 0){
            $scope.aftrnunDisabled = action;
        }

        if(parseInt($scope.treatmentArrayObj.reminderSoir) === 0){
            $scope.evngDisabled = action;
        }
    }

    $scope.captureReminderChange = function(reminderType){
        var reminderValue = 0;
        if(reminderType === 1 && parseInt($scope.treatmentArrayObj.reminderMatin) === 1){
            reminderValue = 1;
        } else if(reminderType === 2 && parseInt($scope.treatmentArrayObj.reminderMidi) === 1){
            reminderValue = 1;
        } else if(reminderType === 3 && parseInt($scope.treatmentArrayObj.reminderSoir) === 1){
            reminderValue = 1;
        } else{
            reminderValue = 0;
        }

        if(reminderValue === 1){
            $scope.reminderLength += 1;
            $scope.defaultReminderLength += 1;
        } else {
            $scope.reminderLength -= 1;
            $scope.defaultReminderLength -= 1;
        }

        if($scope.treatmentArrayObj.doseFrequency !== "" && $scope.reminderLength === parseInt($scope.treatmentArrayObj.doseFrequency)){
            $scope.disableDefaultOptions(true);
        } else{
            $scope.disableDefaultOptions(false);
        }
    }

    $scope.addTimeSlots = function(callType) {
        if($scope.treatmentArrayObj.doseFrequency !== "" && 
           $scope.treatmentArrayObj.doseFrequency > 0 && 
           $scope.reminderLength < parseInt($scope.treatmentArrayObj.doseFrequency)){
            var newItemNo = $scope.timeSlots.length+1;
            $scope.reminderLength += 1;
            $scope.timeSlots.push({index:$scope.timeSlots.length, id:newItemNo, value: "", notevalue:""});
            $ionicScrollDelegate.$getByHandle('addTreatmentScroll').scrollBottom(true);
            if($scope.treatmentArrayObj.doseFrequency !== "" && $scope.reminderLength === parseInt($scope.treatmentArrayObj.doseFrequency)){
                $scope.disableDefaultOptions(true);
            } else {
                $scope.disableDefaultOptions(false);
            }
        }
      };

      $scope.deleteTimeSlots = function(dataObj, callType) {
          for(var i=0; i< $scope.timeSlots.length; i++){
              if(dataObj.id === $scope.timeSlots[i].id){
                  $scope.timeSlots.splice(i, 1);
              }
          }
          for(var i=0; i< $scope.timeSlots.length; i++){
              $scope.timeSlots[i].index = i;
          }

          $scope.reminderLength -= 1;
          if($scope.treatmentArrayObj.doseFrequency !== "" && $scope.reminderLength === parseInt($scope.treatmentArrayObj.doseFrequency)){
                $scope.disableDefaultOptions(true);
            } else{
                $scope.disableDefaultOptions(false);
            }
      };


       $scope.OpenAdditionTimeSlotPicker = function(calledTimeSlot) {
        var slotIndex = 0;
        for(var i=0; i< $scope.timeSlots.length; i++){
              if(calledTimeSlot.id === $scope.timeSlots[i].id){
                  slotIndex = i;
              }
          }
        var slotTimeAvailable = $scope.timeSlots[slotIndex].value;
        $scope.options = {
               date: (slotTimeAvailable==="")? new Date() : new Date("01 January 2000 "+slotTimeAvailable.replace(" h ",":")),
               mode: 'time',
               is24Hour: true,
               androidTheme:1 ,
               locale: 'fr_FR',
               doneButtonLabel: "Valider",
               cancelButtonLabel: "Annuler",
               okText:"Valider",
               cancelText:"Annuler"
               };
        window.datePicker.show($scope.options, function(date){
              if(date && date !== "Invalid Date"){
                  $scope.timeSlots[slotIndex].value = $filter('date')(date, $scope.timeformat);
              }
                $scope.$digest();
        });
    }

      /*$scope.showAddButton = function(dataObj, callType){
          return dataObj.id === $scope.timeSlots[0].id;
      }*/

      $scope.showDeleteButton = function(dataObj, callType){
          return (dataObj.id !== $scope.timeSlots.id);
      }
    
    $ionicModal.fromTemplateUrl('templates/treatmenttype.html', {
        scope: $scope
    }).then(function(modal) {
        $scope.modal = modal;
    });

    $scope.hideModal = function(){
        if($scope.modal !== undefined){
            $scope.modal.hide();
        }
    }

    $scope.showFrequenceOption = function(){
        $scope.oldFrequencyValue = $scope.treatmentArrayObj.doseFrequencyUnit;
        $scope.oldFrequencyName = $scope.frequencyDisplayName;
        $scope.popup = $ionicPopup.show({
            templateUrl:'templates/frequencewrapper.html',
            cssClass:'form-alert-popup picker-popup',
            scope: $scope,
            animation: 'slide-in-up',
            buttons: [
                {
                    text: $translate.instant('ANNULER'),
                    type:'button-default first-button',
                    onTap: function(e) {
                        $scope.popup.close();
                        SpinningWheel.close();
                        $scope.treatmentArrayObj.doseFrequencyUnit = $scope.oldFrequencyValue;
                        $scope.frequencyDisplayName = $scope.oldFrequencyName;
                    }
                },
                { text: $translate.instant('VALIDER'),
                  type:'button-default last-button',
                  onTap: function(e) {
                        $scope.changedTabValue = true;
                        var results = SpinningWheel.getSelectedValues();
                        $scope.createOptionsBasedPopup(results.keys.join(''));
                        $scope.treatmentArrayObj.doseFrequencyUnit = results.keys.join('');
                        $scope.frequencyDisplayName = results.values[0];   
                        SpinningWheel.close();                        
                    }
                }
              ]
        });
        setTimeout(function(){
            $scope.createFrequencyOptionPicker();
        }, 0);        
    }

    $scope.createOptionsBasedPopup = function(type){
        if(type === "1" || type === 1){
            $scope.onAfterLeave();
        } else if(type === "2" || type === 2){
            $rootScope.showingTreatmentRappelPopup = true;
            $scope.loadWeeklyFrequencyPopup();
        } else if(type === "3" || type === 3){
            $rootScope.showingTreatmentRappelPopup = true;
            $scope.loadMonthlyFrequencyPopup();
        } else {
            $rootScope.showingTreatmentRappelPopup = true;
            $scope.loadEveryFrequencyPopup("DURATION_FREQUENCY");
        }
    }

    $scope.loadWeeklyFrequencyPopup = function(){
        $scope.oldWeeklyValue = $scope.treatmentArrayObj.doseFrequencyUnitValue;
        $scope.oldListOptionValue  = $scope.listoption.weekSelected;
        $scope.Weeklypopup = $ionicPopup.show({
            templateUrl:'templates/showweeklyoption.html',
            cssClass:'form-alert-popup weekly-popup',
            scope: $scope,
            animation: 'slide-in-up',
            buttons: [
                {
                    text: $translate.instant('ANNULER'),
                    type:'button-default first-button',
                    onTap: function(e) {
                        $scope.Weeklypopup.close();
                        $scope.treatmentArrayObj.doseFrequencyUnit = $scope.oldFrequencyValue;
                        $scope.frequencyDisplayName = $scope.oldFrequencyName;
                        $scope.treatmentArrayObj.doseFrequencyUnitValue = $scope.oldWeeklyValue;
                        $scope.listoption.weekSelected = $scope.oldListOptionValue;
                        $rootScope.showingTreatmentRappelPopup = false;
                    }
                },
                {
                    text: $translate.instant('VALIDER'),
                    type:'button-default last-button',
                    onTap: function(e) {
                        $scope.changedTabValue = true;
                        $scope.treatmentArrayObj.doseFrequencyUnitValue = $scope.listoption.weekSelected;
                        $scope.frequencyDisplayName += " "+$scope.weeklyOptionsName[$scope.listoption.weekSelected];
                        $scope.onAfterLeave();
                        $rootScope.showingTreatmentRappelPopup = false;
                        SpinningWheel.close();
                    }
                }
              ]
        });
    }

    $scope.loadMonthlyFrequencyPopup = function(){
        $scope.oldMonthlyValue = $scope.treatmentArrayObj.doseFrequencyUnitValue;
        $scope.Monthlypopup = $ionicPopup.show({
            templateUrl:'templates/monthlywrapper.html',
            cssClass:'form-alert-popup picker-popup',
            scope: $scope,
            animation: 'slide-in-up',
            buttons: [
                {
                    text: $translate.instant('ANNULER'),
                    type:'button-default first-button',
                    onTap: function(e) {
                        $scope.treatmentArrayObj.doseFrequencyUnit = $scope.oldFrequencyValue;
                        $scope.frequencyDisplayName = $scope.oldFrequencyName
                        $scope.treatmentArrayObj.doseFrequencyUnitValue = $scope.oldMonthlyValue;
                        $scope.Monthlypopup.close();
                        $rootScope.showingTreatmentRappelPopup = false;
                    }
                },
                {
                    text: $translate.instant('VALIDER'),
                    type:'button-default last-button',
                    onTap: function(e) {
                        $scope.changedTabValue = true;
                        var results = SpinningWheel.getSelectedValues();
                        $scope.treatmentArrayObj.doseFrequencyUnitValue = results.keys.join('');
                        $scope.frequencyDisplayName += " le "+ results.keys[0];
                        $scope.onAfterLeave();
                        SpinningWheel.close();
                        $rootScope.showingTreatmentRappelPopup = false;
                    }
                }
              ]
        });
        setTimeout(function(){
            $scope.createMonthlyOptionPicker();
        }, 0);
    }

    $scope.loadEveryFrequencyPopup = function(POPUP_TYPE){
        $scope.oldEveryValue = $scope.treatmentArrayObj.doseFrequencyUnitValue;
        $scope.oldFreqDispName = $scope.frequencyDisplayName;

        $scope.oldDureeValue = $scope.dureeDisplayName;
        $scope.oldDurationValue = $scope.treatmentArrayObj.durationValue;
        $scope.Everypopup = $ionicPopup.show({
            templateUrl:'templates/everywrapper.html',
            cssClass:'form-alert-popup picker-popup',
            scope: $scope,
            animation: 'slide-in-up',
            buttons: [
                {
                    text: $translate.instant('ANNULER'),
                    type:'button-default first-button',
                    onTap: function(e) {
                        $scope.treatmentArrayObj.doseFrequencyUnit = $scope.oldFrequencyValue;
                        $scope.frequencyDisplayName = $scope.oldFrequencyName;
                        
                        $scope.treatmentArrayObj.doseFrequencyUnitValue = $scope.oldEveryValue;
                        $scope.frequencyDisplayName = $scope.oldFreqDispName;

                        $scope.treatmentArrayObj.durationValue = $scope.oldDurationValue;
                        $scope.dureeDisplayName = $scope.oldDureeValue;
                        $scope.Everypopup.close();
                        $rootScope.showingTreatmentRappelPopup = false;
                    }
                },
                {
                    text: $translate.instant('VALIDER'),
                    type:'button-default last-button',
                    onTap: function(e) {
                        $scope.changedTabValue = true;
                        var results = SpinningWheel.getSelectedValues();
                        if(POPUP_TYPE === "DURATION_OPTIONS"){
                            $scope.treatmentArrayObj.durationValue  = results.keys[0] +", "+results.keys[1];
                            $scope.dureeDisplayName = " "+results.values[0] +" "+results.values[1];
                        } else {
                            $scope.treatmentArrayObj.doseFrequencyUnitValue = results.keys[0] +", "+results.keys[1];
                            $scope.frequencyDisplayName += " "+results.values[0] +" "+results.values[1];
                        }
                        $scope.onAfterLeave();
                        SpinningWheel.close();
                        $rootScope.showingTreatmentRappelPopup = false;
                    }
                }
              ]
        });
        setTimeout(function(){
            $scope.createEveryOptionPicker(POPUP_TYPE);
        }, 0);
    }

    $scope.createMealOptionPicker = function(){
        SpinningWheel.slotData = [];
        SpinningWheel.addSlot({
            1:$scope.medicineTakePlace[0], 2:$scope.medicineTakePlace[1], 3:$scope.medicineTakePlace[2]
        });
        SpinningWheel.open();
        SpinningWheel.scrollToValue(0, 1);
    }

    $scope.createMonthlyOptionPicker = function(){
        SpinningWheel.slotData = [];
        SpinningWheel.addSlot({
            1:1, 2:2, 3:3, 4:4, 5:5, 6:6, 7:7, 8:8, 9:9, 10:10, 11:11, 12:12, 13:13,
            14:14, 15:15, 16:16, 17:17, 18:18, 19:19, 20:20, 21:21, 22:22, 23:23, 24:24,
            25:25, 26:26, 27:27, 28:28, 29:29, 30:30, 31:31
        });
        SpinningWheel.open();
        SpinningWheel.scrollToValue(0, 1);
    }

     $scope.createEveryOptionPicker = function(POPUP_TYPE){
        SpinningWheel.slotData = [];
        SpinningWheel.addSlot({
            1:1, 2:2, 3:3, 4:4, 5:5, 6:6, 7:7, 8:8, 9:9, 10:10, 11:11, 12:12, 13:13,
            14:14, 15:15, 16:16, 17:17, 18:18, 19:19, 20:20, 21:21, 22:22, 23:23, 24:24,
            25:25, 26:26, 27:27, 28:28, 29:29, 30:30, 31:31, 32:32, 33:33, 34:34, 35:35,
            36:36, 37:37, 38:38, 39:39, 40:40, 41:41, 42:42, 43:43, 44:44, 45:45, 46:46,
            47:47, 48:48, 49:49, 50:50, 51:51, 52:52, 53:53
        });
        SpinningWheel.addSlot({1: 'Jour(s)', 2: 'Semaine(s)', 3: 'Mois'});
        SpinningWheel.open();
        var scrollValue1  = 1;
        var scrollValue2  = 1;
        if($scope.treatmentArrayObj.durationValue !== "" && POPUP_TYPE === "DURATION_OPTIONS"){
            var splitDuree = $scope.treatmentArrayObj.durationValue.split(",");
            if(splitDuree.length > 0 && splitDuree.length === 2){
                scrollValue1 = parseInt(splitDuree[0]);
                scrollValue2 = parseInt(splitDuree[1]);
            }
        } else if($scope.treatmentArrayObj.doseFrequencyUnitValue !== "" && POPUP_TYPE === "DURATION_FREQUENCY"){
            var splitterValue = $scope.treatmentArrayObj.doseFrequencyUnitValue.toString(); 
            var splitDuree = splitterValue.split(",");
            if(splitDuree.length > 0 && splitDuree.length === 2){
                scrollValue1 = parseInt(splitDuree[0]);
                scrollValue2 = parseInt(splitDuree[1]);
            }
        }

        SpinningWheel.scrollToValue(0, scrollValue1);
        SpinningWheel.scrollToValue(1, scrollValue2);

    }

    $scope.checkDurationChecked = function(){
        if($scope.treatmentArrayObj.durationType === 1){
            $scope.treatmentArrayObj.durationValue = "";
            $scope.dureeDisplayName = "Durée";
        }
    }

    $scope.createFrequencyOptionPicker = function(){
        SpinningWheel.slotData = [];
        SpinningWheel.addSlot({1: 'Journalière', 2: 'Hebdomadaire', 3: 'Mensuelle', 4: 'Tous les'});
        SpinningWheel.open();
        if($scope.treatmentArrayObj.doseFrequencyUnit !== ""){
          SpinningWheel.scrollToValue(0, parseInt($scope.treatmentArrayObj.doseFrequencyUnit));
        } else {
            SpinningWheel.scrollToValue(0, 1);
        }
    }

    $scope.showNumberTakenOption = function(){
        $scope.pickerLabel = "Prise (s)";
        $scope.NumberTakenpopup = $ionicPopup.show({
            templateUrl:'templates/showNumberTakenOption.html',
            cssClass:'form-alert-popup picker-popup',
            scope: $scope,
            animation: 'slide-in-up',
            buttons: [
                {
                    text: $translate.instant('ANNULER'),
                    type:'button-default first-button',
                    onTap: function(e) {
                        $scope.NumberTakenpopup.close();
                        SpinningWheel.close();
                    }
                },
                { text: $translate.instant('VALIDER'),
                  type:'button-default last-button',
                  onTap: function(e) {
                        $scope.changedTabValue = true;
                        $scope.treatmentArrayObj.doseFrequency = SpinningWheel.getSelectedValues().values[0];
                        $scope.onAfterLeave();
                        if($scope.treatmentArrayObj.doseFrequency !== "" && $scope.reminderLength === parseInt($scope.treatmentArrayObj.doseFrequency)){
                            $scope.disableDefaultOptions(true);
                        } else {
                            $scope.disableDefaultOptions(false);
                        }
                        SpinningWheel.close();
                    }
                }
              ]
        });
        setTimeout(function(){
            $scope.createNumberOfTakenPicker("NUMBEROFTIME");
        }, 0);
    }

    $scope.createNumberOfTakenPicker = function(callMethod){
        SpinningWheel.slotData = [];
        SpinningWheel.addSlot({1:1, 2:2, 3:3, 4:4, 5:5, 6:6, 7:7, 8:8, 9:9});
        SpinningWheel.open();
        var scrollValue = 1;
        if(callMethod === "NUMBEROFTIME"){
            if($scope.treatmentArrayObj.doseFrequency !== ""){
                scrollValue = $scope.treatmentArrayObj.doseFrequency;
            }
        } else {
            if($scope.treatmentArrayObj.doseUnit !== ""){
                scrollValue = $scope.treatmentArrayObj.doseUnit;
            }
        }
        SpinningWheel.scrollToValue(0, scrollValue);
    }

    $scope.showNumberUnitsOption = function(){
        $scope.pickerLabel = $translate.instant('PAR_PRISE');
        $scope.NumberUnitspopup = $ionicPopup.show({
            templateUrl:'templates/showNumberTakenOption.html',
            cssClass:'form-alert-popup picker-popup',
            scope: $scope,
            animation: 'slide-in-up',
            buttons: [
                {
                    text: $translate.instant('ANNULER'),
                    type:'button-default first-button',
                    onTap: function(e) {
                        $scope.NumberUnitspopup.close();
                        SpinningWheel.close();
                    }
                },
                { text: $translate.instant('VALIDER'),
                  type:'button-default last-button',
                  onTap: function(e) {
                        $scope.changedTabValue = true;
                        $scope.treatmentArrayObj.doseUnit = SpinningWheel.getSelectedValues().values[0];
                        $scope.treatmentArrayObj.doseUnitDisplayName = SpinningWheel.getSelectedValues().values[0] + $scope.pickerLabel;
                        $scope.onAfterLeave();
                        SpinningWheel.close();
                    }
                }
              ]
        });
        setTimeout(function(){
            $scope.createNumberOfTakenPicker("NOOFUNITS");
        }, 0);
    }

    $scope.listTitles = function(){
      ADB.trackState($translate.instant('SEPA_TREATMENTS_FORME_PHARMA_LIST'));
        $scope.oldFormePharma = $scope.treatmentArrayObj.formepharma;
        $scope.oldFormePharmaIcon = $scope.pharmaicontype;
        $scope.oldMedicineType = $scope.treatmentArrayObj.medicineType;
        $scope.modal.show();
    }

    $scope.cancelTreatmentType = function(){
//      ADB.trackState($translate.instant('SEPA_TREATMENTS_CANCEL_TREATMENT_TYPE'));
        ADB.trackState($translate.instant('SEPA_MY_TREATMENTS_ADDNEW_MEDICAMENT_TAB'));
        $scope.treatmentArrayObj.formepharma = $scope.oldFormePharma;
        $scope.pharmaicontype = $scope.oldFormePharmaIcon;
        $scope.treatmentArrayObj.medicineType = $scope.oldMedicineType;
        $scope.modal.hide();
    }

    $scope.saveTreatmentType = function(){
     // ADB.trackState($translate.instant('SEPA_TREATMENTS_SAVE_TREATMENTS_TYPE'));
     ADB.trackState($translate.instant('SEPA_MY_TREATMENTS_ADDNEW_MEDICAMENT_TAB'));
        if($scope.treatmentArrayObj.medicineType>0){
           $scope.treatmentArrayObj.formepharma = $scope.treatmentlist[$scope.treatmentArrayObj.medicineType-1].listName;
           $scope.pharmaicontype = $scope.treatmentlist[$scope.treatmentArrayObj.medicineType-1].listType;
           $scope.modal.hide();
        }
    }

    $scope.loadTreatmentImage = function () {
//      ADB.trackState($translate.instant('SEPA_TREATMENT_CAMERA'));
        $scope.treatmentImage = $ionicPopup.show({
            templateUrl: 'templates/showImageUploadOptions.html',
            cssClass:'form-alert-popup image-popup',
            scope: $scope
        });
    };

    $scope.selectedOption = function(type){
        $scope.treatmentImage.close();
        if (type === 2) {
            $scope.getPhotofromGallery();
        } else {
            $scope.takePhotofromCamera();
        }
    };

    
    $scope.takePhotofromCamera = function() {
   //   ADB.trackState($translate.instant('SEPA_TAKE_PIC_FROMCAM'));
      var options = {
        quality: 75,
        destinationType: Camera.DestinationType.FILE_URI,
        sourceType: Camera.PictureSourceType.CAMERA,
        allowEdit: true,
        encodingType: Camera.EncodingType.JPEG,
        targetWidth: 300,
        targetHeight: 300,
        popoverOptions: CameraPopoverOptions,
        saveToPhotoAlbum: false,
        correctOrientation: true
      };
      $cordovaCamera.getPicture(options).then(function(imageData) {
        $scope.imgURI = "data:image/jpeg;base64," + imageData;
          onPhotoDataSuccess(imageData);
      });
    };
    
    $scope.getPhotofromGallery = function() {
    //  ADB.trackState($translate.instant('SEPA_TAKE_PIC_FROM_GALLERY'));
      var options = {
        quality: 75,
        destinationType: Camera.DestinationType.FILE_URI,
        sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
        allowEdit: true,
        encodingType: Camera.EncodingType.JPEG,
        targetWidth: 300,
        targetHeight: 300,
        popoverOptions: CameraPopoverOptions,
        saveToPhotoAlbum: false
      };
      $cordovaCamera.getPicture(options).then(function(imageData) {
          $scope.imgURI = "data:image/jpeg;base64," + imageData;
          onPhotoDataSuccess(imageData);
      }, function(error){
          console.log(error);
      });
    };
    
    
    function onPhotoDataSuccess(imageURI) {
        window.resolveLocalFileSystemURL(imageURI, copyFile, fail);
    }
    
    function makeid() {
        var text = "";
        var possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";

        for (var i = 0; i < 5; i++) {
            text += possible.charAt(Math.floor(Math.random() * possible.length));
        }
        return text;
    }

    function onFail() {
        console.log("ERROR");
    }

    function copyFile(fileEntry) {
        var name = fileEntry.fullPath.substr(fileEntry.fullPath.lastIndexOf('/') + 1);
        var newName = makeid() + name;

        window.resolveLocalFileSystemURL(cordova.file.dataDirectory, function(fileSystem2) {
            fileEntry.copyTo(fileSystem2, newName, onCopySuccess, fail);
        }, fail);
    }

    function onCopySuccess(entry) {
        $scope.treatmentArrayObj.fileName = entry.nativeURL;
        $scope.$apply();
    }

    function fail() {}
    
    $scope.showDurationOptions = function() {
        if($scope.treatmentArrayObj.durationType !== 1){
            $scope.loadEveryFrequencyPopup("DURATION_OPTIONS");  
        }
    };
    
    $scope.saveTreatment = function() {
        $scope.triggeredButton = false;
       // ADB.trackState($translate.instant('SEPA_MY_TREATMENTS_ADDNEW_AJOUTER'));
        $scope.treatmentArrayObj.doseHour=null;
        $scope.treatmentArrayObj.doseMinute=null;
        if($scope.timeSlots !== null && $scope.timeSlots !== undefined){
            if($scope.timeSlots.length > 0){
                $scope.reminderNotEntered = false;
                for(var iTime in $scope.timeSlots){
                    if($scope.timeSlots[iTime].value === ""){
                        $scope.reminderNotEntered = true;
                    }
                }
                $scope.treatmentArrayObj.reminderOther = JSON.stringify($scope.timeSlots);
            } else{
                $scope.treatmentArrayObj.reminderOther = "";
            }
        }
        
        if($scope.treatmentArrayObj.medicineType === 25){
            $scope.treatmentArrayObj.medicineType = "";
        }

        if($scope.changedTabValue === true){
             $scope.onAfterLeave();
        }

        if($scope.isTreatmentDataValid($scope.treatmentArrayObj)){
          $scope.triggeredButton = true;
            //return true;
            if($scope.treatmentArrayObj.id !== undefined && $scope.treatmentArrayObj.id !== ""){
                var treatmentDataForService = angular.copy($scope.treatmentArrayObj);
                treatmentService.updateTreatmentMedicine(treatmentDataForService).then(function(result){
				            if(localStorage.getItem('medicineToggle') === null ||localStorage.getItem('medicineToggle') === undefined || localStorage.getItem('medicineToggle') === true || localStorage.getItem('medicineToggle') === "true"){
                        $rootScope.showLoader();
                        setTimeout(function(){  
                            notificationutil.updateNotification(JSON.parse($scope.oldTreatmentObj),$scope.treatmentArrayObj);
                        }, 500);
                        
                    } else{
                        console.log("No updateNotification");
                    }
                    
                    if($scope.treatmentArrayObj.type === "0" || $scope.treatmentArrayObj.type === 0){
                        $state.go('app.mytreatments.longterm');
                    } else{
                        $state.go('app.mytreatments.symptoms');
                    }
                    
                },function(error){
                    console.log("Error Updating Treatment Data"+error);
                });
            } else {
                $scope.treatmentArrayObj.medicineStartDate = new Date($scope.treatmentArrayObj.lastBoxOpenedDate);
                var treatmentDataForService = angular.copy($scope.treatmentArrayObj);
                treatmentService.insertTreatmentMedicine(treatmentDataForService).then(function(result){
                    $scope.treatmentArrayObj['id']=result.insertId;
                    if(localStorage.getItem('medicineToggle') === null ||localStorage.getItem('medicineToggle') === undefined || localStorage.getItem('medicineToggle') === true || localStorage.getItem('medicineToggle') === "true"){
                        $rootScope.showLoader();
                        setTimeout(function(){  
                            notificationutil.addNotification($scope.treatmentArrayObj);
                        }, 500);
                    } else{
                        console.log("No addNotification");
                    }

					          if($scope.treatmentArrayObj.type === "0" || $scope.treatmentArrayObj.type === 0){
                        $state.go('app.mytreatments.longterm');
                    } else{
                        $state.go('app.mytreatments.symptoms');
                    }
                },function(error){
                    console.log("Error Adding Treatment Data"+error);
                });
            }
        } else{
          if($scope.treatmentArrayObj.medicineType === ""){
              $scope.treatmentArrayObj.medicineType = 25;
          } 
        } 
    }
    
    $scope.isTreatmentDataValid = function(treatmentObj) {
        if($scope.treatmentArrayObj.name== null || $scope.treatmentArrayObj.name==="" ){
            $scope.triggeredButton = false;
            $ionicPopup.show({
                cssClass:'form-alert-popup',
                        buttons: [
                                        { 
                                            text: 'OK', 
                                            type:'button-default first-button last-button',
                                            onTap: function(e) {

                                            }
                                        } 
                                 ],
                template: $translate.instant('TREATMENT_NAME_REQUIRED')
            });
            return false;
          } else if($scope.treatmentArrayObj.type== null || $scope.treatmentArrayObj.type==="" || $scope.treatmentArrayObj.type === 2){
            $scope.triggeredButton = false;
            $ionicPopup.show({
                cssClass:'form-alert-popup',
                        buttons: [
                                        { 
                                            text: 'OK', 
                                            type:'button-default first-button last-button',
                                            onTap: function(e) {

                                            }
                                        } 
                                 ],
                        template: $translate.instant('TREATMENT_TYPE_REQUIRED')
            });
            return false;
          }else if($scope.treatmentArrayObj.durationType===0 && ($scope.treatmentArrayObj.durationValue== null||$scope.treatmentArrayObj.durationValue==="") ){
            $scope.triggeredButton = false;
            $ionicPopup.show({
                cssClass:'form-alert-popup',
                        buttons: [
                                        { 
                                            text: 'OK', 
                                            type:'button-default first-button last-button',
                                            onTap: function(e) {

                                            }
                                        } 
                                 ],
                        template: $translate.instant('TREATMENT_DURATION_TYPE_REQUIRED')
            });
            return false;
          } else if($scope.treatmentArrayObj.doseFrequencyUnit== null || $scope.treatmentArrayObj.doseFrequencyUnit===""){
            $scope.triggeredButton = false;
            $ionicPopup.show({
                cssClass:'form-alert-popup',
                        buttons: [
                                        { 
                                            text: 'OK', 
                                            type:'button-default first-button last-button',
                                            onTap: function(e) {

                                            }
                                        } 
                                 ],
                        template: $translate.instant('TREATMENT_DOSE_FREQ_UNIT_REQUIRED')
            });
            return false;
          } else if($scope.treatmentArrayObj.doseFrequency== null || $scope.treatmentArrayObj.doseFrequency===""){
            $scope.triggeredButton = false;
            $ionicPopup.show({
                cssClass:'form-alert-popup',
                        buttons: [
                                        { 
                                            text: 'OK', 
                                            type:'button-default first-button last-button',
                                            onTap: function(e) {

                                            }
                                        } 
                                 ],
                        template: $translate.instant('TREATMENT_DOSE_FREQ_REQUIRED')
            });
            return false;
          } else if($scope.treatmentArrayObj.doseUnit== null || $scope.treatmentArrayObj.doseUnit===""){
            $scope.triggeredButton = false;
            $ionicPopup.show({
                cssClass:'form-alert-popup',
                        buttons: [
                                        { 
                                            text: 'OK', 
                                            type:'button-default first-button last-button',
                                            onTap: function(e) {

                                            }
                                        } 
                                 ],
                        template: $translate.instant('TREATMENT_DOSE_UNIT_REQUIRED')
            });
            return false;
          } else if($scope.reminderLength !== parseInt($scope.treatmentArrayObj.doseFrequency)){
            $scope.triggeredButton = false;
            $ionicPopup.show({
                cssClass:'form-alert-popup',
                        buttons: [
                                        { 
                                            text: 'OK', 
                                            type:'button-default first-button last-button',
                                            onTap: function(e) {

                                            }
                                        } 
                                 ],
                        template: $translate.instant('TREATMENT_HORAIRES_REQUIRED')//"either morning/afternoon/evening to be selected"
            });
            return false;
          } else if($scope.reminderNotEntered === true){
            $scope.triggeredButton = false;
            $ionicPopup.show({
                cssClass:'form-alert-popup',
                        buttons: [
                                        { 
                                            text: 'OK', 
                                            type:'button-default first-button last-button',
                                            onTap: function(e) {

                                            }
                                        } 
                                 ],
                        template: $translate.instant('TREATMENT_HORAIRES_REQUIRED')//"either morning/afternoon/evening to be selected"
            });
            return false;
          } else if(($scope.treatmentArrayObj.medicineIntake== null || $scope.treatmentArrayObj.medicineIntake==="" || $scope.treatmentArrayObj.medicineIntake === 0 || $scope.treatmentArrayObj.medicineIntake === "0") && $scope.defaultReminderLength > 0){
            $scope.triggeredButton = false;
            $ionicPopup.show({
                cssClass:'form-alert-popup',
                        buttons: [
                                        { 
                                            text: 'OK', 
                                            type:'button-default first-button last-button',
                                            onTap: function(e) {

                                            }
                                        } 
                                 ],
                        template: $translate.instant('TREATMENT_HORAIRES_REQUIRED')//"eithere after/during/before meals selected"
            });
            return false;
          } else if($scope.treatmentArrayObj.boxCapacity== null || $scope.treatmentArrayObj.boxCapacity===""){
            $scope.triggeredButton = false;
            $ionicPopup.show({
                cssClass:'form-alert-popup',
                        buttons: [
                                        { 
                                            text: 'OK', 
                                            type:'button-default first-button last-button',
                                            onTap: function(e) {

                                            }
                                        } 
                                 ],
                        template: $translate.instant('TREATMENT_BOX_CAPACITY_REQUIRED')
            });
            return false;
          } else if($scope.treatmentArrayObj.lastBoxOpenedDate== null || $scope.treatmentArrayObj.lastBoxOpenedDate===""){
            $scope.triggeredButton = false;
            $ionicPopup.show({
                cssClass:'form-alert-popup',
                        buttons: [
                                        { 
                                            text: 'OK', 
                                            type:'button-default first-button last-button',
                                            onTap: function(e) {

                                            }
                                        } 
                                 ],
                        template: $translate.instant('TREATMENT_BOX_OPEN_DATE_REQUIRED')
            });
            return false;
          } else {
            return true;
          }
    }
    
    $scope.cancelTreatment = function() {

        //ADB.trackState($translate.instant('SEPA_MY_TREATMENTS_ADDNEW_ANNULER'));
         if($rootScope.treatmentCallIntiate != undefined && $rootScope.treatmentCallIntiate == "DASHBOARD"){
             $rootScope.menuBackButtonDisplay = false;
             $state.go('app.dashboard');  
        } else if($rootScope.treatmentCallIntiate !== undefined && $rootScope.treatmentCallIntiate === "CALENDAR"){
             $state.go('app.agenda.calendar');
        } else if($rootScope.treatmentCallIntiate !== undefined && $rootScope.treatmentCallIntiate === "SYMPTOM"){
              $state.go('app.mytreatments.symptoms');
         } else {
              $state.go('app.mytreatments.longterm');
         }
    }

    $scope.fn_DateCompare = function (DateA, DateB) {
      var a = new Date(DateA);
      a.setHours(0);
        a.setMinutes(0);
        a.setSeconds(0);
      var b = new Date(DateB);
      b.setHours(0);
        b.setMinutes(0);
        b.setSeconds(0);
      var msDateA = Date.parse(a);//Date.UTC(a.getFullYear(), a.getMonth()+1, a.getDate());
      var msDateB = Date.parse(b);//Date.UTC(b.getFullYear(), b.getMonth()+1, b.getDate());
      if (parseFloat(msDateA) < parseFloat(msDateB))
        return -1;  // lt
      else if (parseFloat(msDateA) === parseFloat(msDateB))
        return 0;  // eq
      else if (parseFloat(msDateA) > parseFloat(msDateB))
        return 1;  // gt
      else
        return null;  // error
  }
    
    $scope.openStartDate = function() {
        var minDateObj = new Date();
        minDateObj.setDate(minDateObj.getDate() - 365);
        var maxDateObj = new Date();
        maxDateObj.setDate(maxDateObj.getDate() + 730);
        $scope.options = {
               date: ($scope.treatmentArrayObj.lastBoxOpenedDate==="")? new Date() : new Date($scope.treatmentArrayObj.lastBoxOpenedDate),
               minDate:Date.parse(minDateObj),
               maxDate:Date.parse(maxDateObj),
               /*allowOldDates: false,
               allowFutureDates: false,*/
               mode: 'date',
               androidTheme:1,
               locale: 'fr_FR',
               doneButtonLabel: "Valider",
               cancelButtonLabel: "Annuler",
               okText:"Valider",
               cancelText:"Annuler"
               };
        window.datePicker.show($scope.options, function(date){
            if(date && date !== "Invalid Date" ){
                if($scope.treatmentArrayObj.lastBoxOpenedDate !== "" && $scope.treatmentArrayObj.lastBoxOpenedDate !== null && $scope.treatmentArrayObj.lastBoxOpenedDate !== "null"){
                    if($scope.fn_DateCompare(date, $scope.treatmentArrayObj.lastBoxOpenedDate) > 0){
                        $scope.treatmentArrayObj.doseTakenCount = 0; 
                    } else{
                        $scope.treatmentArrayObj.doseTakenCount = $scope.oldTakenCount;
                    }
                }
                $scope.treatmentArrayObj.lastBoxOpenedDate = $filter('date')(date, $scope.dateformat);
                $scope.changedTabValue = true;
                $scope.onAfterLeave();
                var momentFormat = moment($scope.treatmentArrayObj.lastBoxOpenedDate);
                $scope.treatmentArrayObj.lastBoxOpenedDateDisplay = momentFormat.locale("fr").format('LL');
            }
            $scope.$digest();
        });
    }
    
    $scope.onAfterLeave = function(){
        if($scope.treatmentArrayObj.id !== "" && $scope.treatmentArrayObj.id !== undefined && $scope.treatmentArrayObj.id != null){
            localStorage.setItem("PRESC_TREATID_RENEWED"+$scope.treatmentArrayObj.id, false);
        }
        if( $scope.treatmentArrayObj.lastBoxOpenedDate && $scope.treatmentArrayObj.boxCapacity >= 0 && $scope.treatmentArrayObj.doseUnit && $scope.treatmentArrayObj.doseFrequency ){
            var frequencyType = parseInt($scope.treatmentArrayObj.doseFrequencyUnit);
            var frequencyValue = $scope.treatmentArrayObj.doseFrequencyUnitValue;
            var days = Math.floor($scope.treatmentArrayObj.boxCapacity/($scope.treatmentArrayObj.doseUnit * $scope.treatmentArrayObj.doseFrequency));

            var date = new Date($scope.treatmentArrayObj.lastBoxOpenedDate);
            var currentDate = new Date();
            var actualDays = 0;
            var dateToadd = 0;
            var endDate = null;
             switch(frequencyType){
                case 1: 
                        days--;
                        actualDays = days;
                        break;
                case 2: 
                        var seqObj = parseInt(frequencyValue);
                        if(seqObj === 7){
                            seqObj = 0;
                        }
                        var scheduleDay = parseInt(date.getDay());
                        /*for(var i=0; i<days; i++){
                            document.write("Date wise:"+new Date(date.setDate(date.getDate()+(i * 7)))+"<br/>");
                        }*/
                        if(scheduleDay !== seqObj){
                            if(seqObj > scheduleDay){
                                dateToadd = seqObj-scheduleDay;
                            } else{
                                dateToadd = (7-scheduleDay)+seqObj;
                            }
                            
                        } 
                        days--;
                        actualDays = days * 7;
                        break;
                case 3: 
                        var seqObj = parseInt(frequencyValue);
                        var scheduleDay = parseInt(date.getDate());
                        if(seqObj === scheduleDay) {
                            dateToadd = 0;
                            days--;
                        } else if(seqObj > scheduleDay) {
                            dateToadd = seqObj-scheduleDay;
                            days--;
                        } else {
                            console.log("Selected Less<br/>");
                        }
                        actualDays = days * 30;
                        break;
                case 4: 
                        var arraySeqObj = frequencyValue.split(",");
                        var noOfDays = 0;
                        days--;
                        if(parseInt(arraySeqObj[1]) === 1){
                            noOfDays = parseInt(arraySeqObj[0]); 
                        } else if(parseInt(arraySeqObj[1]) === 2){
                            noOfDays = parseInt(arraySeqObj[0]) * 7;
                        } else{
                            noOfDays = parseInt(arraySeqObj[0]) * 30;
                        }
                        actualDays = days * noOfDays
                        break;
                 default:
                        break;
            }
            date.setDate(date.getDate()+dateToadd);
            if(actualDays < 0){
              actualDays = 0;
            }
            endDate = new Date(date.setDate(date.getDate()+actualDays));
            if(frequencyType === 3){
                endDate.setDate(parseInt(frequencyValue));
            }
            $scope.treatmentArrayObj.newBoxScheduledDate = $filter('date')(endDate, $scope.dateformat);
            var momentFormat = moment($scope.treatmentArrayObj.newBoxScheduledDate);
            $scope.treatmentArrayObj.newBoxScheduledDateDisplay = momentFormat.locale("fr").format('LL');
            //$scope.treatmentArrayObj.doseTakenCount = 0;
            $scope.treatmentArrayObj.otherStatus = null;
        }
    }

    
    $scope.editTreatment = function() {
        //ADB.trackState($translate.instant('SEPA_MY_TREATMENTS_MODIFY'));
        $scope.editMode = false;
        $scope.fromEditMode = true;
        $scope.buttonName = $translate.instant('VALIDER');
        if($scope.treatmentArrayObj.doseFrequency !== "" && $scope.reminderLength === parseInt($scope.treatmentArrayObj.doseFrequency)){
            $scope.disableDefaultOptions(true);
        } else{
            $scope.disableDefaultOptions(false);
        }
    }

    $scope.moveToSettings = function(){
        if($scope.timeSlots !== null && $scope.timeSlots !== undefined){
            if($scope.timeSlots.length > 0){
                $scope.reminderNotEntered = false;
                for(var iTime in $scope.timeSlots){
                    if($scope.timeSlots[iTime].value === ""){
                        $scope.reminderNotEntered = true;
                    }
                }
                $scope.treatmentArrayObj.reminderOther = JSON.stringify($scope.timeSlots);
            } else{
                $scope.treatmentArrayObj.reminderOther = "";
            }
        }
        
        if($scope.treatmentArrayObj.medicineType === 25){
            $scope.treatmentArrayObj.medicineType = "";
        }
        TreatmentSharedProperties.setAddTreatment($scope.treatmentArrayObj);
        $state.go('settingsFromTreatment');
    }

    $scope.scrollToTop = function(){
        $ionicScrollDelegate.$getByHandle('addMasterTreatmentScroll').scrollTop(true);
    }

    $scope.openKeyboardForced = function(el){
        if(el !== undefined && el !== null && el !== 'undefined' && el !== 'null'){
          var elObj = document.getElementById(el);
          elObj.focus();
          var s = elObj.value;
          elObj.value = '';
          elObj.value = s;
        } 
        if(ionic.Platform.isAndroid()){
            cordova.plugins.Keyboard.show();
        }
    }

    $scope.focusInput = function(){
      document.getElementById("treatment-name").focus(); 
    }

    $scope.openCustomKeyboard = function(){
        $scope.oldBoiteDisplayValue = $scope.boiteDisplayValue;
        $scope.openCustomBoard = $ionicPopup.show({
            templateUrl:'templates/customkeyboard.html',
            cssClass:'form-alert-popup custom-keyboard',
            scope: $scope,
            animation: 'slide-in-up',
            buttons: [
                {
                    text: $translate.instant('ANNULER'),
                    type:'button-default first-button',
                    onTap: function(e) {
                        $scope.boiteDisplayValue = $scope.oldBoiteDisplayValue;
                        $scope.openCustomBoard.close();
                    }
                },
                { text: $translate.instant('VALIDER'),
                  type:'button-default last-button',
                  onTap: function(e) {
                        var currentValue = $scope.boiteDisplayValue.toString();
                        var actualBoiteCount = currentValue.replace(/,/g,"");
                        if(actualBoiteCount.length > 0){
                            $scope.treatmentArrayObj.boxCapacity = parseInt(actualBoiteCount);
                        } else{
                            $scope.treatmentArrayObj.boxCapacity = 0;
                        }
                        $scope.onAfterLeave();
                    }
                }
              ]
        });
    }

    $scope.addNumber = function(valueToAdd){
        var boiteDisplayValue = $scope.boiteDisplayValue.toString();
        if(boiteDisplayValue === "0"){
            boiteDisplayValue = "";
        }
        boiteDisplayValue = boiteDisplayValue+""+valueToAdd;  
        $scope.boiteDisplayValue = boiteDisplayValue;
    }

    $scope.deleteNumber = function(){
        var newBoiteValue = $scope.boiteDisplayValue.toString();
        var deletedNewValue = newBoiteValue.slice(0,newBoiteValue.length-1);
        if(deletedNewValue.length === 0){
            deletedNewValue = "0";
        }
        $scope.boiteDisplayValue = deletedNewValue;
    }

}).controller('mytreatmentsmedicationController', function($scope, $state, $translate, DB,treatmentService,TreatmentSharedList) {
    ADB.trackState($translate.instant('SEPA_MY_TREATMENTS_ADDNEW_MEDICAMENT_TAB'));
    
}).controller('mytreatmentsdosageController', function($scope, $state, $translate, DB,treatmentService,TreatmentSharedList) {
    ADB.trackState($translate.instant('SEPA_MY_TREATMENTS_ADDNEW_PRISES_TAB'));
    
}).controller('mytreatmentspackagingController', function($scope, $state, $translate, DB,treatmentService,TreatmentSharedList) {
   ADB.trackState($translate.instant('SEPA_MY_TREATMENTS_ADDNEW_BOITE_TAB'));
})

.service('TreatmentSharedProperties', function () {
    var property  = null;   
    var addProperty = null; 
    return {
        getTreatment: function () {
            return property;
        },
        setTreatment: function(value) {
            property = value;
        },
        getAddTreatment: function () {
            return addProperty;
        },
        setAddTreatment: function(value) {
            addProperty = value;
        },
        resetAddTreatment: function(value) {
            addProperty = null;
        },
        resetTreatment: function(){
            property  = {
          	  doseUnit : "",
              id : "",
              type : "",
              name : "",
              doseFrequency : "",
              doseFrequencyUnit : "",
              doseHour : "",
              doseMinute  : "",
              lastDoseTakenDate : "",
              boxCapacity : "",
              lastBoxOpenedDate : "",
              newBoxScheduledDate : "",
              doseTakenCount  : 0,
              medicineId : "",
              medicineType  : "",
              durationType  : 0,
              reminderMatin  : 0,
              reminderMidi  : 0,
              reminderSoir  : 0,
              boiteNote  : "",
              durationValue : "",
              fileName  : "./img/Camera@3x.png",
              medicineIntake : "",
              reminderOther: "",
              otherStatus:null
            };
        }
    };  

});

