app.controller('agendaaddresscontroller', function($scope, $state, $ionicModal, $ionicPopup, $translate, ProfessionalContactSharedProperties, AssociationSharedProperties, InternetSharedProperties, $filter, DB, $cordovaCalendar, $document) {
 ADB.trackState($translate.instant('SEPA_CONTACT_LIST'));
  $scope.address = {
    listoption : 0
  };
  $scope.choice = 0;
  $scope.showHealthNetwork = false;

  $scope.init = function() {
     /*healthContactService.init().then(function(result) {
      console.log("Health Contact Unit Testing : "+result);
     },
     function(error){
      console.log("Error reading health inserted data :"+error);
     });*/
  };

  $scope.navigateToList = function(pageName){
  	
    if(pageName === 'professionallist'){
      ADB.trackState($translate.instant('SEPA_CONTACT_LIST_PROFESSIONNELS_DE_SANTE'));
    }else if(pageName === 'associationlist'){
      ADB.trackState($translate.instant('SEPA_CONTACT_LIST_ASSOCIATIONS_DE_PATIENTS'));
    }else if(pageName === 'healthnetworklist'){
      ADB.trackState($translate.instant('SEPA_CONTACT_LIST_RESEAUX_SANTE'));
    }else if(pageName === 'internetlist'){
      ADB.trackState($translate.instant('SEPA_CONTACT_LIST_INTERNET'));
    }

    $state.go('app.'+pageName);
  };

  $scope.showOptionContacts = function(){
    ADB.trackState($translate.instant('SEPA_CONTACT_ADDNEW'));
     var contactListOptions = $ionicPopup.confirm({
          templateUrl: "templates/contactlistselect.html",
          cssClass: "form-alert-popup sepa-confirmation-popup contactlist-select address-add-select",
          okText:$translate.instant('VALIDER'),
          okType:"custom-button button-default last-button",
          cancelText:$translate.instant('ANNULER'),
          scope: $scope,
          cancelType:"custom-button button-default first-button"
      });

      contactListOptions.then(function(response){
          if(response){
           // ADB.trackState($translate.instant('SEPA_CONTACT_ADDNEW_VALIDER'));
              if($scope.address.listoption == 1){
                    ProfessionalContactSharedProperties.setProfessionalContact(null);
                    $state.go('app.addprofessionals.fromhome');
                    ADB.trackState($translate.instant('SEPA_CONTACT_PROFESSIONNELS_DE_SANTE_ADDNEW'));
                    
                } else if($scope.address.listoption == 2){
                    AssociationSharedProperties.setAssociation(null);
                    $state.go('app.addassociations.fromhome');
                    ADB.trackState($translate.instant('SEPA_CONTACT_ASSOCIATIONS_DE_PATIENTS_ADDNEW'));
                    
                } else {
                    InternetSharedProperties.setInternet(null);
                    $state.go('app.addinternet.fromhome');
                    ADB.trackState($translate.instant('SEPA_CONTACT_INTERNET_ADDNEW'));

                }
          } else{
           // ADB.trackState($translate.instant('SEPA_CONTACT_ADDNEW_ANNULER'));
              ADB.trackState($translate.instant('SEPA_CONTACT_LIST'));
              contactListOptions.close();
              $scope.address.listoption = 0;
          }
      });
  };

});