app.controller('appCtrl', function($scope, $rootScope, $state, $translate, $ionicPlatform,$ionicLoading, DB, $ionicHistory) {
               $rootScope.menuBackButtonDisplay = true;
               var menuHardwareBackUnRegister;
               $scope.settingsValue = function(){
                   
                    if(localStorage.getItem('pictoToggle') != undefined && (localStorage.getItem('pictoToggle') === false || localStorage.getItem('pictoToggle') === "false")){
                         $rootScope.disablePicto = true;
                         $rootScope.pictoStatus = "inactive-picto";
                    } else{
                         $rootScope.disablePicto = false;
                         $rootScope.pictoStatus = "active-picto";
                    }    
               }
               $scope.settingsValue();
               
               $scope.menuBackRegister = function() {
               menuHardwareBackUnRegister = $ionicPlatform.registerBackButtonAction(function(e) {
                                                                                    console.log("Back button on Menu Navigation");
                                                                                    e.preventDefault();
                                                                                    $scope.menuBack();
                                                                                    }, 101);
               };
               $scope.menuBackRegister();

               if ($state.current.name === 'app.dashboard') {
                    $rootScope.menuBackButtonDisplay = false;
               }

               $rootScope.openKeyboardManual = function(el){
                  if(el !== undefined && el !== null && el !== 'undefined' && el !== 'null'){
                    var elObj = document.getElementById(el);
                    elObj.focus();
                    var s = elObj.value;
                    elObj.value = '';
                    elObj.value = s;
                  } 
                  if(ionic.Platform.isAndroid()){
                      cordova.plugins.Keyboard.show();
                  }
               }

               $rootScope.showLoader = function() {
                    $ionicLoading.show({
                      template: '<ion-spinner icon="spiral"></ion-spinner>'
                    });
               };

               $rootScope.hideLoader = function(){
                    $ionicLoading.hide();
               };

               $rootScope.disableDoubleTapOption = function(e){
                    e.preventDefault();
                    return false;
               }

               $scope.goToSettings = function() {
                    $rootScope.menuBackButtonDisplay = true;
                    $state.go('app.settings');
                    menuHardwareBackUnRegister();
                    $scope.menuBackRegister();
               };
               $scope.goToRecommendations = function() {
                    $rootScope.menuBackButtonDisplay = true;
                    menuHardwareBackUnRegister();
                    $scope.menuBackRegister();
                    $state.go('app.recommendationhome');
               }
               $scope.goToAgenda = function() {
                    $rootScope.menuBackButtonDisplay = true;
                    $state.go('app.agenda');
                    menuHardwareBackUnRegister();
                    $scope.menuBackRegister();
               }
               $scope.goToPrepareMyRecomendations = function() {
                    $rootScope.menuBackButtonDisplay = true;
                    $state.go('app.preparemyconsultation');
                    menuHardwareBackUnRegister();
                    $scope.menuBackRegister();
               }
               $scope.goToTreatments = function() {
                    $rootScope.menuBackButtonDisplay = true;
                    $state.go('app.mytreatments');
                    menuHardwareBackUnRegister();
                    $scope.menuBackRegister();
               }
               $scope.goToDashBoard = function() {
                    $rootScope.menuBackButtonDisplay = false;
                    $state.go('app.dashboard');
                    menuHardwareBackUnRegister();
                    $scope.menuBackRegister();
               }
               $scope.goToInfo = function() {
                    $rootScope.menuBackButtonDisplay = true;
                    $state.go('app.info');
                    menuHardwareBackUnRegister();
                    $scope.menuBackRegister();
               }
               $scope.goToPictogram = function() {
                    $rootScope.menuBackButtonDisplay = true;
                    var completedDate = new Date(localStorage.pictogramCompleted);
                    completedDate.setHours(0);
                    completedDate.setMinutes(0);
                    completedDate.setSeconds(0);
                    var remaining =0;
                    if(completedDate.getDay()>0){
                         remaining =7-completedDate.getDay();
                    } 
                    var endDate= new Date(completedDate);
                    endDate.setDate(endDate.getDate()+remaining);
                    endDate.setHours(0);
                    endDate.setMinutes(0);
                    endDate.setSeconds(0);
                    var currentDate= new Date();
                    currentDate.setHours(0);
                    currentDate.setMinutes(0);
                    currentDate.setSeconds(0);
                    if(localStorage.pictogramCompleted != undefined && Date.parse(currentDate) <= Date.parse(endDate)){
                         ADB.trackState($translate.instant('SEPA_PICTOGRAM_COMPLETED_SCREEN'));
                         $state.go('app.pictogramcompleted');
                    }else{
                         ADB.trackState($translate.instant('SEPA_PICTOGRAM_LAUNCH_SCREEN'));
                         $state.go('pictogram');
                    }
                    menuHardwareBackUnRegister();
                    $scope.menuBackRegister();
               }


               $scope.menuBack = function() {
                    if ($state.current.name === 'app.dashboard') {
                         if($rootScope.showingDashboardRappelPopup === undefined || $rootScope.showingDashboardRappelPopup === false){
                              $rootScope.menuBackButtonDisplay = false;
                              menuHardwareBackUnRegister();
                              $state.go('home'); 
                         }

                    } else if ($state.current.name === 'app.settings' || $state.current.name === 'app.recommendationhome' || $state.current.name === 'app.agenda' || $state.current.name === 'app.preparemyconsultation') {
                         
                         $rootScope.menuBackButtonDisplay = false;
                         $state.go('app.dashboard');
                    } else if ($state.current.name === 'app.recommendationinfo') {
                         $scope.goToRecommendations();
                    } else if ($state.current.name === 'pictogramquestion') {
                         if($rootScope.showingPictoQuestionPopup === undefined || $rootScope.showingPictoQuestionPopup === false){
                              $rootScope.menuBackButtonDisplay = false;
                              $state.go('app.dashboard');     
                         }
                    } else if ($state.current.name === 'app.addevent') {
                         if($rootScope.showingEventSecondPopup === undefined || $rootScope.showingEventSecondPopup === false){
                              //ADB.trackState($translate.instant('SEPA_AGENDA_EVENT'));
                             $state.go('app.agenda.events');
                          }
                    } else if ($state.current.name === 'app.professionallist' || $state.current.name === 'app.associationlist' || $state.current.name === 'app.healthnetworklist' || $state.current.name === 'app.internetlist') {
                        //ADB.trackState($translate.instant('SEPA_CONTACT_LIST'));
                         $state.go('app.agenda.adress');
                    } else if ($state.current.name === 'app.addprofessionals') {
                         ADB.trackState($translate.instant('SEPA_CONTACT_LIST_PROFESSIONNELS_DE_SANTE'));
                         $state.go('app.professionallist');
                    } else if ($state.current.name === 'app.addassociations') {
                         ADB.trackState($translate.instant('SEPA_CONTACT_LIST_ASSOCIATIONS_DE_PATIENTS'));
                         $state.go('app.associationlist');
                    } else if ($state.current.name === 'app.addinternet') {
                         ADB.trackState($translate.instant('SEPA_CONTACT_LIST_INTERNET'));
                         $state.go('app.internetlist');
                    } else if ($state.current.name === 'app.addprofessionals.fromhome' || $state.current.name === 'app.addassociations.fromhome' || $state.current.name === 'app.addinternet.fromhome') {
                         $state.go('app.agenda.adress');
                         //ADB.trackState($translate.instant('SEPA_CONTACT_LIST'));
                    } else if ($state.current.name === 'app.addevent.fromCalendar') {
                         $state.go('app.agenda.calendar');
                         ADB.trackState($translate.instant('SEPA_CALENDAR'));
                    } else if($state.current.name === "app.addevent.fromDashboard"){
                         $rootScope.menuBackButtonDisplay = false;
                         $state.go('app.dashboard');
                    } else if ($state.current.name === 'home') {
                         ionic.Platform.exitApp();
                    } else if ($state.current.name === 'app.preparemyconsultationconceils') {
                         $state.go('app.preparemyconsultation');
                         // ADB.trackState($translate.instant('SEPA_PREPARE_MY_CONSULTATION'));
                    } else if ($state.current.name === 'app.pmcquestions' || $state.current.name === 'app.pmcdocuments') {
                          $state.go('app.preparemyconsultation');
                           ADB.trackState($translate.instant('SEPA_PREPARE_MY_CONSULTATION'));
                    } else if ($state.current.name === 'app.preparemyconsultinfo') {
                         ADB.trackState($translate.instant('SEPA_PREPARE_MY_CONSULTATION_TIPS'));
                         $state.go('app.preparemyconsultationconceils');
                    } else if ($state.current.name === 'app.guideinfo' || $state.current.name === 'app.cguinfo' ){
                         $state.go('app.info');
                    } else if ($state.current.name === 'settingsFromTreatment'){
                         $state.go('app.addtreatment.dosage');
                    } else if ($state.current.name === 'app.tipoftheweek'){
                         $rootScope.menuBackButtonDisplay = false;
                         $state.go('app.dashboard');
                    } else if ($state.current.name === 'app.addtreatment' || $state.current.name === 'app.addtreatment.medication' || $state.current.name === 'app.addtreatment.dosage' || $state.current.name === 'app.addtreatment.packaging') {
                        if($rootScope.showingTreatmentRappelPopup === undefined || $rootScope.showingTreatmentRappelPopup === false){
                              if($rootScope.treatmentCallIntiate != undefined && $rootScope.treatmentCallIntiate == "DASHBOARD"){
                                   $rootScope.menuBackButtonDisplay = false;
                                   $state.go('app.dashboard');  
                              } else if($rootScope.treatmentCallIntiate != undefined && $rootScope.treatmentCallIntiate == "CALENDAR"){
                                   $state.go('app.agenda.calendar');
                              }else if($rootScope.treatmentCallIntiate != undefined && $rootScope.treatmentCallIntiate == "SYMPTOM"){
                                   $state.go('app.mytreatments.symptoms');
                              } else {
                                   $state.go('app.mytreatments.longterm');
                              }
                         }
                    } else {
                              $rootScope.menuBackButtonDisplay = false;
                              $state.go('app.dashboard');
                    }
               }
               
 });