app.controller('internetcontroller', function($scope, $state, $translate, $ionicPlatform, UTIL_SERVICE, $ionicPopup, DB, InternetSharedProperties, websiteService) {
      $scope.items = [
      /*{
          refId: "1", contactName: "RDV avec", contactDesc:"MARTIN", contactDetails: [
              {name: "Fixe",data:"+(33) xx xx xxxxx",type:"LANDLINE",typeinfo:"LANDLINE_INFO"},
              {name: "Mobile",data:"+(33) xx xx xxxxx",type:"MOBILE",typeinfo:"MOBILE_INFO"},
              {name: "Adresse",data:"F2 Stepstones Meenas Plot No 1 Narayanasamy 4th street Shollinganallur Chennai Tamilnadu India 600 119",type:"ADDRESS",typeinfo:"ADDRESS_INFO"},
              {name: "E-mail",data:"anand.ramakrishnan.paramasivam@gmail.com",type:"EMAIL",typeinfo:"EMAIL_INFO"}
          ]
      },
      {
          refId: "1", contactName: "RDV avec", contactDesc:"MARTIN", contactDetails: [
             {name: "Fixe",data:"+(33) xx xx xxxxx",type:"LANDLINE",typeinfo:"LANDLINE_INFO"},
             {name: "Mobile",data:"+(33) xx xx xxxxx",type:"MOBILE",typeinfo:"MOBILE_INFO"},
             {name: "Adresse",data:"F2 Stepstones Meenas Plot No 1 Narayanasamy 4th street",type:"ADDRESS",typeinfo:"ADDRESS_INFO"},
             {name: "E-mail",data:"anand.ramakrishnan@gmail.com",type:"EMAIL",typeinfo:"EMAIL_INFO"}
          ]
      },
      {
          refId: "1", contactName: "RDV avec", contactDesc:"MARTIN", contactDetails: [
             {name: "Fixe",data:"+(33) xx xx xxxxx",type:"LANDLINE",typeinfo:"LANDLINE_INFO"},
             {name: "Mobile",data:"+(33) xx xx xxxxx",type:"MOBILE",typeinfo:"MOBILE_INFO"},
             {name: "Adresse",data:"N Rue. xxxxxx",type:"ADDRESS",typeinfo:"ADDRESS_INFO"},
             {name: "E-mail",data:"anand.rama@gmail.com",type:"EMAIL",typeinfo:"EMAIL_INFO"}
          ]
      }*/
    ];

    $scope.alertUser = function(internetobject) {
      ADB.trackState($translate.instant('SEPA_CONTACT_INTERNET_ITEM_CLICKED'));
      var webContentName = "<strong>"+internetobject.name+"</strong>";
      var webContent = '<div class="row event-popup padding-bottom">';
          //webContent+= '<div class="col col-20">'+internetobject.description+'</div>';
          webContent+= internetobject.link;
          webContent+= '</div>';
      
      var alertUserForAction = $ionicPopup.show({
                                        template: webContent,
                                        cssClass:'form-alert-popup',
                                        title: webContentName,
                                        scope: $scope,
                                        buttons: [
                                          { 
                                              text: $translate.instant('ANNULER'), 
                                              type:'button-default first-button',
                                              onTap: function(e) {
                                             //   ADB.trackState($translate.instant('SEPA_CONTACT_INTERNET_ITEM_CLICKED_ANN'));
                                             ADB.trackState($translate.instant('SEPA_CONTACT_LIST_INTERNET'));
                                                  alertUserForAction.close();
                                              }
                                          },
                                          { text: $translate.instant('MODIFY'),
                                            onTap: function(e) {
                                             // ADB.trackState($translate.instant('SEPA_CONTACT_INTERNET_ITEM_CLICKED_MOD'));
                                                  $scope.modifyInternet(internetobject);
                                              }
                                          },
                                          { text: $translate.instant('SUPPRIMER'), 
                                            type:'button-default last-button',
                                            onTap: function(e) {
                                             // ADB.trackState($translate.instant('SEPA_CONTACT_INTERNET_ITEM_CLICKED_SUP'));
                                                  $scope.deleteConfirmation(internetobject);
                                              }}
                                        ]
                                      });
    }

    $scope.modifyInternet = function(internetobject){
      if(internetobject.descriptionUi == undefined) {
          internetobject.descriptionUi = "";
      }
      
      if(internetobject.description == 'undefined') {
          internetobject.description = "";
      }

      internetobject.description = internetobject.name + "%SEPA%" + internetobject.descriptionUi;
      var res = internetobject.description.split("%SEPA%");
      if(res.length > 0) {
         var contactDesc = res[1];
         var contactName = res[0];
         internetobject.description = contactDesc; 
         internetobject.name = contactName;
         internetobject.descriptionUi = contactDesc;
      }
      InternetSharedProperties.setInternet(internetobject);
      ADB.trackState($translate.instant('SEPA_CONTACT_INTERNET_ADDNEW'));
      $state.go('app.addinternet');
    }

    $scope.deleteConfirmation = function(internetobject){
      ADB.trackState($translate.instant('SEPA_CONTACT_INTERNET_ITEM_DELETE_CONF'));
          var deleteConfirm = $ionicPopup.confirm({
          title: $translate.instant('LIST_DELETE_CONFIRM'),
          template: $translate.instant('LIST_DELETE_CONFIRM_2'),
          cssClass: "form-alert-popup sepa-confirmation-popup",
          okText:$translate.instant('SUPPRIMER'),
          okType:"custom-button button-default last-button",
          cancelText:$translate.instant('ANNULER'),
          cancelType:"custom-button button-default first-button"
      });

      deleteConfirm.then(function(response) {
          if(response){
          //  ADB.trackState($translate.instant('SEPA_CONTACT_INTERNET_ITEM_DELETE_SUP'));
           ADB.trackState($translate.instant('SEPA_CONTACT_LIST_INTERNET'));
              $scope.deleteInternet(internetobject);
          } else{
          //  ADB.trackState($translate.instant('SEPA_CONTACT_INTERNET_ITEM_DELETE_ANN'));
           ADB.trackState($translate.instant('SEPA_CONTACT_LIST_INTERNET'));
              deleteConfirm.close();
          }
      });
    }

    $scope.deleteInternet = function(internetobject) {
            websiteService.deleteWebDetails(internetobject).then(function(result){
            for(var i=0;i<$scope.items.length;i++){
                 if($scope.items[i].id === internetobject.id){
                     $scope.items.splice(i,1);
                 }
            }
            websiteService.webDetails=[];
            websiteService.webDetails=$scope.items;
        },function(error){
            console.log("Error deleting internet");
        });
    }

    $scope.showAllInternetContacts = function() {
        websiteService.selectAllWebSites().then(function(result){
            websiteService.webDetails = [];
                var internetCount = result.rows.length;
               
                if(internetCount>0){
                    
                    for(var i=0;i<internetCount;i++) {
                        var objectItem = result.rows.item(i);
                        objectItem.builtin = (objectItem.builtin == 1) ? true:false;
                        var res = objectItem.description.split("%SEPA%");
                        objectItem.name = "";
                        if(res.length > 0) {
                           var contactName = res[0];
                           var contactDesc = res[1];
                           objectItem.description = contactDesc; 
                           objectItem.name = contactName;
                           objectItem.descriptionUi = contactDesc;
                        }
                        
                        websiteService.webDetails.push(objectItem);
                        
                    }

                    $scope.items = websiteService.webDetails;

                }

        },function(error){
            console.log("Error Reading Websites Data : "+error);
            $scope.items = [];
        });
    }

    $scope.navigateToScreen = function(pageName){
      if(pageName === 'app.addinternet'){
        ADB.trackState($translate.instant('SEPA_CONTACT_INTERNET_ADDNEW'));
      }
      InternetSharedProperties.setInternet(null);
      $state.go(pageName);
    }

    $scope.callWebsite = function(redirectURL){
      UTIL_SERVICE.openWebsite(redirectURL,$scope);
    }

    $scope.showAllInternetContacts();
});