app.controller('preparemyconsultationcontroller', function($scope,$rootScope,$ionicPlatform, $state,$timeout, $ionicModal, $ionicPopup, $cordovaCalendar, $ionicScrollDelegate, $translate, $filter, UTIL_SERVICE, appntService, prepareMyConsultationService, $ionicLoading) {
    ADB.trackState($translate.instant('SEPA_PREPARE_MY_CONSULTATION'));
    $scope.bottomTextVisibility = false;
    $scope.showEventListInPmc = false;
    $scope.uniqueEventId = 0;
    $scope.eventItems = [];
    $scope.docEntryvisible = false;
    $scope.triggeredButton = false;
    $scope.dataQuesposition = {};
    $scope.dataDocposition = {};
    $scope.pmcContentStyle = {
        'opacity':'0'
    };
    $scope.docnewentry = {
        id: "",
        builtin: "",
        checked: "",
        description: ""
    };
    $scope.questnewentry = {
        id: "",
        builtin: "",
        checked: "",
        description: ""
    };
    $scope.questionitems = [{
        eventId: "",
        id: "",
        question: "",
        predefined: '',
        checkboxstatus: 0
    }];
    $scope.documentitems = [{
        eventId: "",
        id: "",
        documentname: "",
        predefined: '',
        checkboxstatus: 0
    }];

    $scope.pmcglobalitems = [{
        id: "",
        eventId: "",
        consultationQuestions: "",
        consultationDocuments: ""
    }];

    $scope.getPMCp1 = function() {
        return $translate.instant('PREPARE_MY_CONS_P1');
    };
    $scope.goToPMCConseils = function() {
        ADB.trackState($translate.instant('SEPA_PREPARE_MY_CONSULTATION_TIPS'));
        $state.go('app.preparemyconsultationconceils');
    };
    $scope.goToPMCMain = function() {
        $state.go('app.preparemyconsultation');
    };


    $scope.getBottomtext = function() {
        return $translate.instant('PMC_BOTTOM_LINK');
    }

    $scope.setUniqueEventId = function(id) {
        $scope.uniqueEventId = id;
    }

    $scope.getUniqueEventId = function() {
        return $scope.uniqueEventId;
    }

    $scope.setBottomTextVisible = function() {
        console.log("Called Function");
        $timeout.cancel($scope.setTimer);
        //document.getElementById("dynamicButtonShow").style.display = "block";
        $scope.pmcContentStyle = {
            '-webkit-transition':'0.7s linear all',
            'transition': '0.7s linear all',
            'opacity':'1'
        };
        $scope.setTimer = $timeout(function() {
            console.log("Called PMC");
            $scope.setBottomTextInVisible();
            //document.getElementById("dynamicButtonShow").style.display = "none";
        }, 10000);
    }

    $scope.setBottomTextInVisible = function() {
        $scope.pmcContentStyle = {
            '-webkit-transition':'0.9s linear all',
            'transition': '0.9s linear all',
            'opacity':'0'
        };
    }

    $ionicModal.fromTemplateUrl('templates/pmcquestions.html', {
        scope: $scope
    }).then(function(modal) {
        $scope.questionmodel = modal;
    });

    $scope.hideQuestionModel = function() {
        ADB.trackState($translate.instant('SEPA_PREPARE_MY_CONSULTATION'));
        $scope.questionmodel.hide();
        $scope.scrollListToTop();
    }

    $ionicModal.fromTemplateUrl('templates/pmcdocuments.html', {
        scope: $scope
    }).then(function(modal) {
        $scope.documentmodel = modal;
    });

    $scope.hideDocumentModel = function() {
        ADB.trackState($translate.instant('SEPA_PREPARE_MY_CONSULTATION'));
        $scope.documentmodel.hide();
        $scope.scrollListToTop();
    }

    $rootScope.hideModal = function(){
          if($scope.modal !== undefined){
              $scope.modal.hide();
          }
          if($scope.eventContactModel !== undefined){
              $scope.eventContactModel.hide();
          }
          if($scope.documentmodel !== undefined){
              $scope.documentmodel.hide();
          }
          if($scope.questionmodel !== undefined){
              $scope.questionmodel.hide();
          }
      }

    //Document new entry logic
    $scope.showDocumentEntry = function() {
        $ionicScrollDelegate.$getByHandle('mainPMCScroll').scrollBottom(true);
        $scope.docEntryvisible = true;
    }

    $scope.insertNewDocument = function() {
            if ($scope.docnewentry.description !== "" && $scope.docnewentry.description !== null && $scope.docnewentry.description !== "undefined" && $scope.questnewentry.description !== undefined) {
                $scope.docnewentry.builtin = 0;
                var docDataForService = angular.copy($scope.docnewentry);
                prepareMyConsultationService.insertDocument(docDataForService).then(function() {
                    var tempArr = [];
                    var objStrngDoc = "";
                    var currId = $scope.getUniqueEventId();
                    for (var i = 0; i < $scope.documentitems.length; i++) {
                        if ($scope.documentitems[i] !== undefined && $scope.documentitems[i] !== null && $scope.documentitems[i] !== "undefined") {
                            if ($scope.documentitems[i].checkboxstatus === 1) {
                                tempArr.push($scope.documentitems[i].id);
                            }
                        }
                    }
                    $scope.getAllDocuments(tempArr.join(","),"INSERT");
                }, function(error) {
                    console.log("Error Inserting document : " + error);
                });
            }
            $scope.docEntryvisible = false;
            $scope.docnewentry.description = "";
        }
        //Question new entry logic
    $scope.showQuestionEntry = function() {
        //scrollBottom([shouldAnimate])
        $ionicScrollDelegate.$getByHandle('mainPMCScroll').scrollBottom(true);
        $scope.questEntryvisible = true;
    }

    $scope.scrollListToTop = function(){
        $ionicScrollDelegate.$getByHandle('mainPMCScroll').scrollTop(true);
    }

    $scope.calculateCheckboxSelection = function() {
        var currId = $scope.getUniqueEventId();
        var tempArr = new Array();
        if ($scope.quesDocCollection[currId] != undefined && $scope.quesDocCollection[currId].consultationQuestions != undefined) {
            for (var i = 0; i < $scope.questionitems.length; i++) {
                if ($scope.questionitems[i].checkboxstatus === 1) {
                    tempArr.push($scope.questionitems[i].id);
                }
            }
            $scope.quesDocCollection[currId].consultationQuestions = tempArr.join();
        }
    }

    $scope.insertNewQuestion = function() {
        if ($scope.questnewentry.description !== "" && $scope.questnewentry.description !== null && $scope.questnewentry.description !== "undefined" && $scope.questnewentry.description !== undefined) {
            $scope.questnewentry.builtin = 0;
            var questionDataForService = angular.copy($scope.questnewentry);
            prepareMyConsultationService.insertQuestion(questionDataForService).then(function() {
                var objStrngQues = "";
                var tempArr = [];
                var currId = $scope.getUniqueEventId();
                for (var i = 0; i < $scope.questionitems.length; i++) {
                    if ($scope.questionitems[i] !== undefined && $scope.questionitems[i] !== null && $scope.questionitems[i] !== "undefined") {
                        if ($scope.questionitems[i].checkboxstatus === 1) {
                            tempArr.push($scope.questionitems[i].id);
                        }
                    }
                }
                $scope.getAllQuestions(tempArr.join(","),"INSERT");
            }, function(error) {
                console.log("Error Inserting question : " + error);
            });
        }
        $scope.questEntryvisible = false;
        $scope.questnewentry.description = "";
    }

    $scope.resetDocumentList = function(){
         for (var i = 0; i < $scope.documentitems.length; i++) {
            if ($scope.documentitems[i] !== undefined && $scope.documentitems[i] !== null && $scope.documentitems[i] !== "undefined") {
                $scope.documentitems[i].checkboxstatus = 0;
            }
        }
    }

    $scope.resetQuestionList = function(){
        for (var i = 0; i < $scope.questionitems.length; i++) {
            if ($scope.questionitems[i] !== undefined && $scope.questionitems[i] !== null && $scope.questionitems[i] !== "undefined") {
                $scope.questionitems[i].checkboxstatus = 0;
            }
        }
    }
    //////NAVIGATE TO DOCUMENT LIST PAGE

    $scope.goToDocumentsList = function(eventUniqueId) {
        ADB.trackState($translate.instant('SEPA_PREPARE_MY_CONSULTATION_DOC_PAGE'));
        $scope.resetDocumentList();
        $scope.setUniqueEventId(eventUniqueId);
        var idVar = $scope.getUniqueEventId();
        if ($scope.quesDocCollection[idVar] != undefined && $scope.quesDocCollection[idVar].consultationDocuments != undefined) {
            var str = $scope.quesDocCollection[idVar].consultationDocuments;
            if (str != "") {
                var arrObj = str.split(",");
                if (arrObj.length > 0) {
                    for (var i in arrObj) {
                        if ($scope.documentitems[$scope.dataDocposition[arrObj[i]]] !== undefined && $scope.documentitems[$scope.dataDocposition[arrObj[i]]] !== "undefined" && $scope.documentitems[$scope.dataDocposition[arrObj[i]]] !== null) {
                            $scope.documentitems[$scope.dataDocposition[arrObj[i]]].checkboxstatus = 1;
                        }
                    }
                }
            }
        }
        $scope.documentmodel.show();
    };

    ///NAVIGATE TO QUESTION LIST PAGE
    $scope.goToQuestionsList = function(eventUniqueId) {
        ADB.trackState($translate.instant('SEPA_PREPARE_MY_CONSULTATION_QUES_PAGE'));
        $scope.resetQuestionList();
        $scope.setUniqueEventId(eventUniqueId);
        var idVar = $scope.getUniqueEventId();
        if ($scope.quesDocCollection[idVar] != undefined && $scope.quesDocCollection[idVar].consultationQuestions != undefined) {
            var str = $scope.quesDocCollection[idVar].consultationQuestions;
            if (str != "") {
                var arrObj = str.split(",");
                if (arrObj.length > 0) {
                    for (var i in arrObj) {
                        if ($scope.questionitems[$scope.dataQuesposition[arrObj[i]]] !== undefined && $scope.questionitems[$scope.dataQuesposition[arrObj[i]]] !== "undefined" && $scope.questionitems[$scope.dataQuesposition[arrObj[i]]] !== null) {
                            $scope.questionitems[$scope.dataQuesposition[arrObj[i]]].checkboxstatus = 1;
                        }
                    }
                }
            }
        }
        $scope.questionmodel.show();
    };



    ///INSERTING QUESTION IF NOT EXIST / UPDATING QUESTION IF DATA EXISTS
    $scope.insertSelectedQuestions = function() {
//        ADB.trackState($translate.instant('SEPA_PREPARE_MY_CONSULTATION_QUES_PAGE_VAL'));
        ADB.trackState($translate.instant('SEPA_PREPARE_MY_CONSULTATION'));
        var tempArr = [];
        $scope.pmcObj = {
            eventId: "",
            consultationQuestions: "",
            consultationDocuments: ""
        };
        for (var i = 0; i < $scope.questionitems.length; i++) {
            if ($scope.questionitems[i] !== undefined && $scope.questionitems[i] !== null && $scope.questionitems[i] !== "undefined") {
                if ($scope.questionitems[i].checkboxstatus === 1) {
                    tempArr.push($scope.questionitems[i].id);
                }
            }
        }
        $scope.pmcObj.eventId = $scope.getUniqueEventId();
        if ($scope.quesDocCollection[$scope.pmcObj.eventId] == undefined) {
            $scope.quesDocCollection[$scope.pmcObj.eventId] = {};
        }
        if ($scope.quesDocCollection[$scope.pmcObj.eventId]["consultationQuestions"] == undefined) {
            $scope.quesDocCollection[$scope.pmcObj.eventId]["consultationQuestions"] = "";
        }
        //if (tempArr.join() != "") {
            $scope.quesDocCollection[$scope.pmcObj.eventId]["consultationQuestions"] = tempArr.join();
        //}
        $scope.pmcObj.consultationQuestions = tempArr.join();

        if ($scope.quesDocStatus[$scope.pmcObj.eventId] == false) {
            prepareMyConsultationService.updateQuestionEvent($scope.pmcObj).then(function() {
                $state.go('app.preparemyconsultation');
            }, function(error) {
                console.log("Error Inserting question : " + error);

            });
            for (var i = 0; i < $scope.eventItems.length; i++) {
                if ($scope.eventItems[i].eventId == $scope.pmcObj.eventId) {
                    $scope.eventItems[i].questionsMapped = $scope.getQuesDocNames($scope.pmcObj.consultationQuestions, "Q");
                }
            }
        } else {
            //insert logic
            //INSERT DATA FRESHLY
            prepareMyConsultationService.insertConsultationEvent($scope.pmcObj).then(function() {
                $scope.quesDocStatus[$scope.pmcObj.eventId] = true;
                $state.go('app.preparemyconsultation');
            }, function(error) {
                console.log("Error Inserting question : " + error);

            });
            for (var j = 0; j < $scope.eventItems.length; j++) {
                if ($scope.eventItems[j].eventId == $scope.pmcObj.eventId) {
                    $scope.eventItems[j].questionsMapped = $scope.getQuesDocNames($scope.pmcObj.consultationQuestions, "Q");
                }
            }
        }
        $scope.questionmodel.hide();
        $scope.scrollListToTop();
    }


    ///INSERTING QUESTION IF NOT EXIST / UPDATING QUESTION IF DATA EXISTS
    $scope.insertSelectedDocuments = function() {
//        ADB.trackState($translate.instant('SEPA_PREPARE_MY_CONSULTATION_DOC_PAGE_VAL'));
        ADB.trackState($translate.instant('SEPA_PREPARE_MY_CONSULTATION'));
        var tempArr = [];
        $scope.pmcObj = {
            eventId: "",
            consultationQuestions: "",
            consultationDocuments: ""
        };
        for (var i = 0; i < $scope.documentitems.length; i++) {
            if ($scope.documentitems[i] !== undefined && $scope.documentitems[i] !== null && $scope.documentitems[i] !== "undefined") {
                if ($scope.documentitems[i].checkboxstatus === 1) {
                    tempArr.push($scope.documentitems[i].id);
                }
            }
        }
        $scope.pmcObj.eventId = $scope.getUniqueEventId();
        if ($scope.quesDocCollection[$scope.pmcObj.eventId] == undefined) {
            $scope.quesDocCollection[$scope.pmcObj.eventId] = {};
        }
        if ($scope.quesDocCollection[$scope.pmcObj.eventId]["consultationDocuments"] == undefined) {
            $scope.quesDocCollection[$scope.pmcObj.eventId]["consultationDocuments"] = "";
        }
        //if (tempArr.join() != "") {
            $scope.quesDocCollection[$scope.pmcObj.eventId]["consultationDocuments"] = tempArr.join();
        //}
        $scope.pmcObj.consultationDocuments = tempArr.join();
        if ($scope.quesDocStatus[$scope.pmcObj.eventId] == false) {
            prepareMyConsultationService.updateDocumentEvent($scope.pmcObj).then(function(result) {
                $state.go('app.preparemyconsultation');
            }, function(error) {
                console.log("Error Inserting question : " + error);

            });
            for (var i = 0; i < $scope.eventItems.length; i++) {
                if ($scope.eventItems[i].eventId == $scope.pmcObj.eventId) {
                    $scope.eventItems[i].documentsMapped = $scope.getQuesDocNames($scope.pmcObj.consultationDocuments, "D");
                }
            }
        } else {
            //insert logic
            //INSERT DATA FRESHLY
            prepareMyConsultationService.insertConsultationEvent($scope.pmcObj).then(function(result) {
                $scope.quesDocStatus[$scope.pmcObj.eventId] = true;
                $state.go('app.preparemyconsultation');
            }, function(error) {
                console.log("Error Inserting question : " + error);

            });
            for (var i = 0; i < $scope.eventItems.length; i++) {
                if ($scope.eventItems[i].eventId == $scope.pmcObj.eventId) {
                    $scope.eventItems[i].documentsMapped = $scope.getQuesDocNames($scope.pmcObj.consultationDocuments, "D");
                }
            }
        }
        $scope.documentmodel.hide();
        $scope.scrollListToTop();
    }


    $scope.showQuestDeletePopup = function(questOrDocObj, callType) {
        ADB.trackState($translate.instant('SEPA_PREPARE_MY_CONSULTATION_DELETE'));
        var qobj = {
            id: "",
            builtin: "",
            checked: "",
            description: ""
        };
        var statusCall = 'SINGLE';
        var statusMsg = 'QUESTION_DELETE_MSG';
        //Populating the object with data
        qobj.id = questOrDocObj.id;
        if (questOrDocObj.predefined == true) {
            qobj.builtin = 1;
        } else {
            qobj.builtin = 0;
        }
        qobj.checked = questOrDocObj.checkboxstatus;
        qobj.description = questOrDocObj.question;

        $scope.deletePopup = $ionicPopup.show({
            cssClass: 'form-alert-popup',
            buttons: [{
                text: $translate.instant('ANNULER'),
                type: 'button-default first-button',
                onTap: function(e) {
                   // ADB.trackState($translate.instant('SEPA_PREPARE_MY_CONSULTATION_DELETE_ANNULER'));
                   ADB.trackState($translate.instant('SEPA_PREPARE_MY_CONSULTATION_QUES_PAGE'));
                    $scope.deletePopup.close();
                }
            }, {
                text: $translate.instant('VALIDER'),
                type: 'button-default last-button',
                onTap: function(e) {
                    $scope.deletePopup.close();
                   // ADB.trackState($translate.instant('SEPA_PREPARE_MY_CONSULTATION_DELETE_VALIDER'));
                    setTimeout(function(){ $scope.showDeleteConfirmationPopup(qobj, 1); }, 1000);
                }
            }],
            template: $translate.instant(statusMsg)
        });
    };

    $scope.showDocumentDeletePopup = function(questOrDocObj) {
        ADB.trackState($translate.instant('SEPA_PREPARE_MY_CONSULTATION_DELETE'));
        var dObj = {
            id: "",
            builtin: "",
            checked: "",
            description: ""
        };
        //Populating the object with data
        dObj.id = questOrDocObj.id;
        if (questOrDocObj.predefined == true) {
            dObj.builtin = 1;
        } else {
            dObj.builtin = 0;
        }
        dObj.checked = questOrDocObj.checkboxstatus;
        dObj.description = questOrDocObj.documentname;
        $scope.deletePopup = $ionicPopup.show({

            cssClass: 'form-alert-popup',
            buttons: [{
                text: $translate.instant('ANNULER'),
                type: 'button-default first-button',
                onTap: function(e) {
                //    ADB.trackState($translate.instant('SEPA_PREPARE_MY_CONSULTATION_DELETE_ANNULER'));
                ADB.trackState($translate.instant('SEPA_PREPARE_MY_CONSULTATION_DOC_PAGE'));
                    $scope.deletePopup.close();
                }
            }, {
                text: $translate.instant('VALIDER'),
                type: 'button-default last-button',
                onTap: function(e) {
                    $scope.deletePopup.close();
                   // ADB.trackState($translate.instant('SEPA_PREPARE_MY_CONSULTATION_DELETE_VALIDER'));
                   
                    setTimeout(function(){ $scope.showDeleteConfirmationPopup(dObj, 0); }, 1000);
                }
            }],
            template: $translate.instant('DOCUMENT_DELETE_MSG')
        });
    };


    $scope.showDeleteConfirmationPopup = function(obj, type) {
        ADB.trackState($translate.instant('SEPA_PREPARE_MY_CONSULTATION_DELETE_CONFIRMATION'));
        $scope.deletePopup.close();
        $scope.deleteConfirmationPopup = $ionicPopup.show({
            cssClass: 'form-alert-popup',
            buttons: [{
                text: $translate.instant('ANNULER'),
                type: 'button-default first-button',
                onTap: function(e) {
                    if(type == 0){
                        ADB.trackState($translate.instant('SEPA_PREPARE_MY_CONSULTATION_DOC_PAGE'));
                    }else {
                        ADB.trackState($translate.instant('SEPA_PREPARE_MY_CONSULTATION_QUES_PAGE'));
                    }
                    
                   // ADB.trackState($translate.instant('SEPA_PREPARE_MY_CONSULTATION_DELETE_CONFIRMATION_ANN'));
                    $scope.deleteConfirmationPopup.close();
                }
            }, {
                text: $translate.instant('SUPPRIMER'),
                type: 'button-default last-button',
                onTap: function(e) {
                   // ADB.trackState($translate.instant('SEPA_PREPARE_MY_CONSULTATION_DELETE_CONFIRMATION_SUP')); 
                   if(type == 0){
                        ADB.trackState($translate.instant('SEPA_PREPARE_MY_CONSULTATION_DOC_PAGE'));
                    }else {
                        ADB.trackState($translate.instant('SEPA_PREPARE_MY_CONSULTATION_QUES_PAGE'));
                    }
                    $scope.deleteConfirmationPopup.close();
                    $scope.deleteQuesOrDoc(obj, type);

                }
            }],
            template: $translate.instant('DOC_QUES_DELETE_CONFIRMATION')
        });
    };

    $scope.deleteQuesOrDoc = function(obj, type) {
        if (type == 1) {
            prepareMyConsultationService.deleteQuestion(obj).then(function(result) {
                //$scope.scrollListToTop();
                var tempArr = [];
                $scope.pmcObj = {
                    eventId: "",
                    consultationQuestions: "",
                    consultationDocuments: ""
                };
                for (var i = 0; i < $scope.questionitems.length; i++) {
                    if ($scope.questionitems[i] !== undefined && $scope.questionitems[i] !== null && $scope.questionitems[i] !== "undefined") {
                        if ($scope.questionitems[i].checkboxstatus === 1) {
                            tempArr.push($scope.questionitems[i].id);
                        }
                    }
                }
                $scope.pmcObj.eventId = $scope.getUniqueEventId();
                if ($scope.quesDocCollection[$scope.pmcObj.eventId] == undefined) {
                    $scope.quesDocCollection[$scope.pmcObj.eventId] = {};
                }
                if ($scope.quesDocCollection[$scope.pmcObj.eventId]["consultationQuestions"] == undefined) {
                    $scope.quesDocCollection[$scope.pmcObj.eventId]["consultationQuestions"] = "";
                }
                
                //if (tempArr.join() != "") {
                    $scope.quesDocCollection[$scope.pmcObj.eventId]["consultationQuestions"] = tempArr.join();
                //}
                $scope.pmcObj.consultationQuestions = tempArr.join();
                for (var i = 0; i < $scope.eventItems.length; i++) {
                    if ($scope.eventItems[i].eventId == obj.eventId) {
                        $scope.eventItems[i].questionsMapped = $scope.getQuesDocNames($scope.pmcObj.consultationQuestions, "Q");
                    }
                }
                $scope.getAllQuestions(tempArr.join(),"DELETE");
                $ionicScrollDelegate.$getByHandle('mainPMCScroll').scrollBottom(true);
            }, function(error) {
                console.log("Error deleting events");
            });
        } else {
            prepareMyConsultationService.deleteDocument(obj).then(function(result) {
                //$scope.scrollListToTop();
                var tempArr = [];
                $scope.pmcObj = {
                    eventId: "",
                    consultationQuestions: "",
                    consultationDocuments: ""
                };
                for (var i = 0; i < $scope.documentitems.length; i++) {
                    if ($scope.documentitems[i] !== undefined && $scope.documentitems[i] !== null && $scope.documentitems[i] !== "undefined") {
                        if ($scope.documentitems[i].checkboxstatus === 1) {
                            tempArr.push($scope.documentitems[i].id);
                        }
                    }
                }
                $scope.pmcObj.eventId = $scope.getUniqueEventId();
                if ($scope.quesDocCollection[$scope.pmcObj.eventId] == undefined) {
                    $scope.quesDocCollection[$scope.pmcObj.eventId] = {};
                }
                if ($scope.quesDocCollection[$scope.pmcObj.eventId]["consultationDocuments"] == undefined) {
                    $scope.quesDocCollection[$scope.pmcObj.eventId]["consultationDocuments"] = "";
                }
                //if (tempArr.join() != "") {
                    $scope.quesDocCollection[$scope.pmcObj.eventId]["consultationDocuments"] = tempArr.join();
                //}
                for (var i = 0; i < $scope.eventItems.length; i++) {
                    if ($scope.eventItems[i].eventId == obj.eventId) {
                        $scope.eventItems[i].documentsMapped = $scope.getQuesDocNames($scope.pmcObj.consultationDocuments, "D");
                    }
                }
                $scope.getAllDocuments(tempArr.join(),"DELETE");
                $ionicScrollDelegate.$getByHandle('mainPMCScroll').scrollBottom(true);
            }, function(error) {
                console.log("Error deleting events");
            });
            
        }
    }

    //Loading Questions 
    $scope.getAllQuestions = function(updateStrng, callType) {
        var checkArray = new Array();
        if (updateStrng != null && updateStrng != "") {
            checkArray = updateStrng.split(",")
        }
        prepareMyConsultationService.selectAllQuestions().then(function(result) {
            prepareMyConsultationService.questionDetails = [];
            var tempQuestionList = [];
            var questionCount = result.rows.length;
            if (questionCount > 0) {
                for (var i = 0; i < questionCount; i++) {
                    var questItem = {};
                    var a = result.rows.item(i);
                    a.description = aesUtil.decrypt(salt, iv, passPhrase, a.description);
                    prepareMyConsultationService.questionDetails.push(a);
                    questItem["id"] = a.id;
                    questItem["question"] = a.description;
                    var builtinvar = a.builtin;
                    if (builtinvar == "1") {
                        questItem["predefined"] = 'true';
                    } else {
                        questItem["predefined"] = 'false';
                    }
                    if (checkArray.length > 0 && checkArray.indexOf(a.id.toString()) >= 0) {
                        questItem["checkboxstatus"] = 1;
                    } else {
                        questItem["checkboxstatus"] = 0;
                    }
                    $scope.dataQuesposition[a.id] = tempQuestionList.length;
                    tempQuestionList.push(questItem);
                }
                if (callType === "INSERT") {
                    tempQuestionList[tempQuestionList.length-1].checkboxstatus = 1;
                }
                $scope.questionitems = tempQuestionList;
                $ionicScrollDelegate.$getByHandle('mainPMCScroll').resize();
            } else {
                console.log("no questions");
            }
        }, function(error) {
            console.log("Error reading Questions data : " + error);
            $scope.questionitems = [];
        });
    }
    $scope.getAllQuestions(null,"NONE");



    //Loading Questions 
    $scope.getAllDocuments = function(updateStrng, callType) {
        var checkArray = new Array();
        if (updateStrng != null && updateStrng != "") {
            checkArray = updateStrng.split(",")
        }
        prepareMyConsultationService.selectAllDocuments().then(function(result) {
            prepareMyConsultationService.documentDetails = [];
            var tempDocList = [];
            var docCount = result.rows.length;

            if (docCount > 0) {
                for (var i = 0; i < docCount; i++) {
                    var docItem = {};
                    var a = result.rows.item(i);
                    a.description = aesUtil.decrypt(salt, iv, passPhrase, a.description);
                    prepareMyConsultationService.documentDetails.push(a);                    

                    docItem["id"] = a.id;
                    docItem["documentname"] = a.description;
                    var builtinVar = a.builtin;
                    if (builtinVar == "1") {
                        docItem["predefined"] = 'true';
                    } else {
                        docItem["predefined"] = 'false';
                    }
                    if (checkArray.length > 0 && checkArray.indexOf(a.id.toString()) >= 0) {
                        docItem["checkboxstatus"] = 1;
                    } else {
                        docItem["checkboxstatus"] = 0;
                    }
                    //Finally pushing all the data to array
                    $scope.dataDocposition[a.id] = tempDocList.length;
                    tempDocList.push(docItem);
                }
                if (callType === "INSERT") {
                    tempDocList[tempDocList.length-1].checkboxstatus = 1;
                }
                $scope.documentitems = tempDocList;
                $ionicScrollDelegate.$getByHandle('mainPMCScroll').resize();
            } else {
                console.log("No documents");
            }
        }, function(error) {
            console.log("Error reading Questions data : " + error);
            $scope.documentitems = [];
        });
    }

    $scope.getAllDocuments(null,"NONE");


    $scope.getAllPmcEvents = function() {
        
        $scope.pmcglobalitems = [];
        $scope.quesDocCollection = {};
//        $ionicLoading.show({
//          template: '<ion-spinner icon="spiral"></ion-spinner>'
//        });
        prepareMyConsultationService.selectAllPCMEvents().then(function(result2) {
            prepareMyConsultationService.pmcDetails = [];
            var temppmcList = [];
            var count = result2.rows.length;
            if (count > 0) {
                for (var i = 0; i < count; i++) {
                    prepareMyConsultationService.pmcDetails.push(result2.rows.item(i));
                    var pmcItem = {};
                    var r = result2.rows.item(i);
                    pmcItem["id"] = r.id;
                    pmcItem["eventId"] = r.eventId;
                    pmcItem["consultationQuestions"] = r.consultationQuestions;
                    pmcItem["consultationDocuments"] = r.consultationDocuments;
                    temppmcList.push(pmcItem);
                    if ($scope.quesDocCollection[r.eventId] == undefined) {
                        $scope.quesDocCollection[r.eventId] = {};
                    }
                    if ($scope.quesDocCollection[r.eventId]["consultationQuestions"] == undefined) {
                        $scope.quesDocCollection[r.eventId]["consultationQuestions"] = "";
                    }
                    if (r.consultationQuestions != "") {
                        $scope.quesDocCollection[r.eventId]["consultationQuestions"] = r.consultationQuestions;
                    }
                    if ($scope.quesDocCollection[r.eventId]["consultationDocuments"] == undefined) {
                        $scope.quesDocCollection[r.eventId]["consultationDocuments"] = "";
                    }
                    if (r.consultationDocuments != "") {
                        $scope.quesDocCollection[r.eventId]["consultationDocuments"] = r.consultationDocuments;
                    }
                }
                $scope.pmcglobalitems = temppmcList;
            } else {
                console.log("no data");
            }
        });
        $scope.showAllEvents();
    }



    //Loading events 
    $scope.showAllEvents = function() {
        // $scope.items = appntService.eventsList;
        appntService.selectAllAppointments().then(function(result) {
            appntService.eventsList = [];
            var tembEventList = [];
            var eventsCount = result.rows.length;
            $scope.quesDocStatus = {};
            if (eventsCount > 0) {

                $scope.showEventListInPmc = true;
                //$scope.getAllPmcEvents();
                for (var i = 0; i < eventsCount; i++) {
                    appntService.eventsList.push(result.rows.item(i));
                    var eventItem = {};
                    var a = result.rows.item(i);
                    var objAptDate = new Date(a.aptdate);
                    var aptTime = $filter('date')(objAptDate, "HH 'h' mm");

                    var momentFormat = moment(objAptDate);
                    var aptDateDisp = momentFormat.locale("fr").format("dddd Do MMMM YYYY");

                    var aptDate = $filter('date')(objAptDate, "EEEE dd MMMM yyyy");
                    var pmcdataArr = null;

                    var appendString = ""
                    var appendContact = "";

                    a.contactName = aesUtil.decrypt(salt, iv, passPhrase,a.contactName);
                    if(a.contactName !== "" && a.contactName !== null && a.contactName !== "null"){
                        appendString = " avec ";   
                        appendContact = a.contactName;
                    }
                    
                    a.eventId = a.id;
                    eventItem["eventId"] = a.eventId;
                    eventItem["questionsMapped"] = "";
                    eventItem["documentsMapped"] = "";
                    eventItem["aptDescription"] = a.description
                    eventItem["appendString"] = appendString;
                    eventItem["aptContact"] = appendContact;

                    eventItem["aptTime"] = aptTime;
                    eventItem["aptDate"] = aptDate;
                    eventItem["aptDateDisp"] = aptDateDisp;

                    eventItem["contactName"] = a.contactName;

                    eventItem["id"] = a.id;

                    if ($scope.quesDocCollection[a.eventId] == undefined) {
                        $scope.quesDocStatus[a.eventId] = true;
                    } else {
                        $scope.quesDocStatus[a.eventId] = false;
                    }
                    var tempObj = prepareMyConsultationService.getPmcdataForEvent(a.eventId);
                    if (tempObj != undefined) {
                        pmcdataArr = tempObj;
                    }
                    if ($scope.quesDocCollection[a.eventId] != undefined) {
                        if ($scope.quesDocCollection[a.eventId].consultationDocuments != undefined)
                            eventItem["documentsMapped"] = $scope.getQuesDocNames($scope.quesDocCollection[a.eventId].consultationDocuments, "D");
                        if ($scope.quesDocCollection[a.eventId].consultationQuestions != undefined)
                            eventItem["questionsMapped"] = $scope.getQuesDocNames($scope.quesDocCollection[a.eventId].consultationQuestions, "Q");
                    }
                    tembEventList.push(eventItem);
                }
                $scope.eventItems = tembEventList;

            } else {
                $scope.showEventListInPmc = false;
            }
        }, function(error) {
            $scope.eventItems = [];
        });
//        setTimeout(function(){  
//            $ionicLoading.hide();
//        }, 2000);
    }
    $scope.showEventListInPmc = false;
    $scope.getAllPmcEvents();

    $scope.getQuesDocNames = function(string, type) {
        var listitem = [];
        var docstr = string;
        var arrObjd = docstr.split(",");
        if (docstr != "" && arrObjd.length > 0) {
            if (type == "Q") {
                for (var i in arrObjd) {
                    var templistitem = {}
                    if ($scope.dataQuesposition[arrObjd[i]] !== undefined && $scope.dataQuesposition[arrObjd[i]] !== "undefined" && $scope.dataQuesposition[arrObjd[i]] !== null) {
                        templistitem["name"] = $scope.questionitems[$scope.dataQuesposition[arrObjd[i]]].question;
                        listitem.push(templistitem);
                    }
                }
            } else {
                for (var i in arrObjd) {
                    var templistitem2 = {}
                    if ($scope.dataDocposition[arrObjd[i]] !== undefined && $scope.dataDocposition[arrObjd[i]] !== "undefined" && $scope.dataDocposition[arrObjd[i]] !== null) {
                        templistitem2["name"] = $scope.documentitems[$scope.dataDocposition[arrObjd[i]]].documentname;
                        listitem.push(templistitem2);
                    }
                }
            }
        }
        return listitem;
    }

    $scope.openURL = function(redirectURL) {
        ADB.trackState($translate.instant('SEPA_PREPARE_MY_CONSULTATION_LINK'));
        $scope.navigationPopup = $ionicPopup.show({
            cssClass: 'form-alert-popup pmc pmc_bottom_text_popup',
            buttons: [{
                text: $translate.instant('ANNULER'),
                type: 'button-default first-button',
                onTap: function(e) {
                   // ADB.trackState($translate.instant('SEPA_PREPARE_MY_CONSULTATION_LINK_CONFIRM_ANNULER'));
                   ADB.trackState($translate.instant('SEPA_PREPARE_MY_CONSULTATION'));
                    $scope.navigationPopup.close();
                }
            }, {
                text: $translate.instant('CONTINUER'),
                type: 'button-default last-button',
                onTap: function(e) {
                    $scope.navigationPopup.close();
                    //ADB.trackState($translate.instant('SEPA_PREPARE_MY_CONSULTATION_LINK_CONFIRM_CONTINUER'));
                    UTIL_SERVICE.openWebsite(redirectURL, $scope);

                }
            }],
            template: $translate.instant('MSG_LINK_LOAD')
        });
        
    };

    $scope.openKeyboardForced = function(){
        if(ionic.Platform.isAndroid()){
            cordova.plugins.Keyboard.show();
        }
        
        $ionicScrollDelegate.$getByHandle('mainPMCScroll').resize();
        setTimeout(function(){ 
            $ionicScrollDelegate.$getByHandle('mainPMCScroll').scrollBottom(true);
        }, 1000);
        
    }

    $ionicPlatform.onHardwareBackButton(function(event){
        $ionicScrollDelegate.$getByHandle('mainPMCScroll').resize();  
        setTimeout(function(){ 
            $ionicScrollDelegate.$getByHandle('mainPMCScroll').scrollBottom(true);
        }, 1000);   
    });

});