app.controller('settingscontroller', function($scope, $rootScope,$ionicLoading, $ionicNavBarDelegate, $state, $ionicPopup,$ionicPlatform, $filter, $translate, DB, appntService, $cordovaCalendar,notificationutil,treatmentService) {
  ADB.trackState($translate.instant('SEPA_SETTINGS'));
        $scope.settings={
            eventsToggle :true,
            medicineToggle :true,
            matinTime :"08h00",
            midiTime :"12h00",
            soirTime :"19h00",
            tipsToggle :true,
            pictoToggle :true
        };
        $scope.timeformat = "HH'h'mm";
        $scope.timeOptions = {1:"matin",2:"midi",3:"soir"};
        $scope.treatmentsCount = 0;
        $scope.treatmentArray = [];
        $scope.init = function() {
            
            if(localStorage.getItem('eventToggle') == undefined){
                localStorage.setItem('eventToggle',true);
            }
            if(localStorage.getItem('medicineToggle') == undefined){
                localStorage.setItem('medicineToggle',true);
            }
            if(localStorage.getItem('tipsToggle') == undefined){
                localStorage.setItem('tipsToggle',true);
            }
            if(localStorage.getItem('pictoToggle') == undefined){
                localStorage.setItem('pictoToggle',true);
            }
            if(localStorage.getItem('matinTime') == undefined){
                localStorage.setItem('matinTime',"08h00");
            }
            if(localStorage.getItem('midiTime') == undefined){
                localStorage.setItem('midiTime',"12h00");
            }
            if(localStorage.getItem('soirTime') == undefined){
                localStorage.setItem('soirTime',"19h00");
            }

            if(localStorage.getItem('eventToggle') == null && 
               localStorage.getItem('medicineToggle') == null && 
               localStorage.getItem('tipsToggle') == null && 
               localStorage.getItem('pictoToggle') == null){
                   localStorage.setItem('eventToggle',true);
                   localStorage.setItem('medicineToggle',true);
                   localStorage.setItem('tipsToggle',true);
                   localStorage.setItem('pictoToggle',true);
            }
            $scope.settings.eventsToggle = (localStorage.getItem('eventToggle') == "true")?true:false;
            $scope.settings.medicineToggle = (localStorage.getItem('medicineToggle') == "true")?true:false;
            $scope.settings.tipsToggle = (localStorage.getItem('tipsToggle') == "true")?true:false;
            $scope.settings.pictoToggle = (localStorage.getItem('pictoToggle') == "true")?true:false;
            $scope.settings.matinTime = localStorage.getItem('matinTime');
            $scope.settings.midiTime = localStorage.getItem('midiTime');
            $scope.settings.soirTime = localStorage.getItem('soirTime');
            $scope.fetchAllTreatments();
        }
        
        $scope.fetchAllTreatments = function(){
            treatmentService.selectAllTreatmentMedicines().then(function (result) {
            $scope.treatmentsCount = result.rows.length;
            $scope.treatmentArray = result.rows;
            $scope.masterArray = [];
            if($scope.treatmentsCount>0){
              for(var i=0;i<$scope.treatmentsCount;i++){
                  var treatment = $scope.treatmentArray.item(i);
                  treatment.name = aesUtil.decrypt(salt, iv, passPhrase, treatment.name);
                  treatment.boiteNote = aesUtil.decrypt(salt, iv, passPhrase, treatment.boiteNote);
                  $scope.masterArray.push(treatment);
              }
            }
            $scope.treatmentArray = $scope.masterArray;
           },function(error){});
        }
        //$scope.init();
        $scope.openTimerPopup = function(timeType) {
          /*switch(timeType){
            case 1: ADB.trackState($translate.instant('SEPA_SETTINGS_MATIN'));
                    break;
            case 2: ADB.trackState($translate.instant('SEPA_SETTIMGS_MIDI'));
                    break;
            case 3: ADB.trackState($translate.instant('SEPA_SETTINGS_SOIR'));
                    break;
            default: break;
          }*/

            $scope.options = {
                 date: ($scope.settings[$scope.timeOptions[timeType]+"Time"] ==="")? new Date() : new Date("01 January 2000 "+$scope.settings[$scope.timeOptions[timeType]+"Time"].replace("h",":")),
                 mode: 'time',
                 locale: 'fr_FR',
                 doneButtonLabel: "Valider",
                 cancelButtonLabel: "Annuler"
            };
            window.datePicker.show($scope.options, function(date){
              if(date && date !== "Invalid Date"){
                  $scope.settings[$scope.timeOptions[timeType]+"Time"] = $filter('date')(date, $scope.timeformat);
                  localStorage.setItem($scope.timeOptions[timeType]+"Time",$filter('date')(date, $scope.timeformat));
                    
                    if($scope.treatmentsCount>0 && $scope.settings.medicineToggle){
                      for(var i=0;i<$scope.treatmentsCount;i++){
                          var treatment = $scope.treatmentArray[i];
                          switch(timeType){
                            case 1: if(parseInt(treatment.reminderMatin) === 1){
                                        $rootScope.showLoader();
                                        notificationutil.updateNotification(treatment,treatment);
                                    }
                                    break;
                            case 2: if(parseInt(treatment.reminderMidi) === 1){
                                        $rootScope.showLoader();
                                        notificationutil.updateNotification(treatment,treatment);
                                    }
                                    break;
                            case 3: if(parseInt(treatment.reminderSoir) === 1){
                                        $rootScope.showLoader();
                                        notificationutil.updateNotification(treatment,treatment);
                                    }
                                    break;
                            default: break;
                          }
                      }
                   }
                  
              }
                $scope.$digest();
            });
        }    
               
       $scope.onToggleChange = function(toggleName){
            $ionicLoading.show({
              template: '<ion-spinner icon="spiral"></ion-spinner>'
            });
            switch (toggleName){
              case 'EVENT_TOGGLE': 
//                    ADB.trackState($translate.instant('SEPA_SETTINGS_EVENT_REMINDER')+" "+$scope.settings.eventsToggle.toString().toUpperCase());
                    localStorage.setItem('eventToggle',$scope.settings.eventsToggle);
                    if($scope.settings.eventsToggle){
                        $scope.activateRemindersforEvents(true);
                    } else {
                        $scope.activateRemindersforEvents(false);
                    }
                    $rootScope.hideLoader();
                    break;
              case 'MEDI_TOGGLE': 
              //ADB.trackState($translate.instant('SEPA_SETTINGS_MEDICATION_REMINDER')+" "+$scope.settings.medicineToggle.toString().toUpperCase());
                    localStorage.setItem('medicineToggle',$scope.settings.medicineToggle);
                    if($scope.settings.medicineToggle){
                        $scope.activateNotificationsforTreatments(true);
                    } else {
                        $scope.activateNotificationsforTreatments(false);
                    }
                    break;
              case 'CONSEILS_TOGGLE': 
              //ADB.trackState($translate.instant('SEPA_SETTINGS_CONSEILS_TOGGLE_SEP')+" "+$scope.settings.tipsToggle.toString().toUpperCase());
                    localStorage.setItem('tipsToggle',$scope.settings.tipsToggle);
                    $rootScope.hideLoader();
                    break;
              case 'PICTO_TOGGLE': 
              //ADB.trackState($translate.instant('SEPA_SETTINGS_PICTO_SEP')+" "+$scope.settings.pictoToggle.toString().toUpperCase());
                    localStorage.setItem('pictoToggle',$scope.settings.pictoToggle);
                    $rootScope.hideLoader();
                    break;  
              default : break;                              
            }
       }

       $scope.activateNotificationsforTreatments = function(activate){
           if($scope.treatmentsCount>0){
              if(activate){
                   $rootScope.showLoader();
                   setTimeout(function(){  
                      notificationutil.addAllNotification($scope.treatmentArray);
                   }, 500);
                   
              } else {
                   notificationutil.deleteAllNotification();
                   $rootScope.hideLoader();
              }
              /*for(var i=0;i<$scope.treatmentsCount;i++){
                  var treatment = $scope.treatmentArray.item(i);
                  if(activate){
                       notificationutil.addNotification(treatment);
                  } else {
                       notificationutil.deleteNotification(treatment);
                  }
              }*/
            } else{
                $rootScope.hideLoader();
            }
       }
       $scope.activateRemindersforEvents = function(activate){
           $scope.activeEventsList = [];
           $scope.activeEventNo = 0;
           appntService.selectAllAppointments().then(function(result){
               var eventsCount = result.rows.length;
               if(eventsCount>0){
                    for(var i=0;i<eventsCount;i++){
                        var event = result.rows.item(i);
                        // $scope.updateEvents(event,activate);
                        event.contactName = aesUtil.decrypt(salt, iv, passPhrase,event.contactName);
                        $scope.activeEventsList.push(event);
                    }
                    $scope.updateEvents($scope.activeEventsList[0],activate);
               }
           },function(error){
                console.log("Error reading Events Data : "+error);
            });
       }

       $scope.getEventEndDate=function(startDateTime){
          return new Date(startDateTime.getTime()+(60*60*1000));
      }
       
       $scope.updateEvents = function(event,activate){
            $scope.dateinfo = {};
            var date = new Date(event.aptdate);
            $scope.dateinfo.date = date.getDate();
            $scope.dateinfo.month = date.getMonth();
            $scope.dateinfo.fullyear = date.getFullYear();
            $scope.dateinfo.hours = date.getHours();
            $scope.dateinfo.minutes = date.getMinutes();
            var oldEventData=event;

            var startDateTime=new Date($scope.dateinfo.fullyear, $scope.dateinfo.month, $scope.dateinfo.date, $scope.dateinfo.hours, $scope.dateinfo.minutes, 0, 0, 0);
            var endDateTime = $scope.getEventEndDate(startDateTime);
            var contactName=oldEventData['contactName'];
            var strAvec=(contactName && contactName !== "null") ? " avec " +contactName:""; 
        
            var objOldEventJson={
              title: oldEventData.description + strAvec,//oldEventData.contactName,
              //location: oldEventData.apttype,
              notes: oldEventData.description,
              startDate:startDateTime, 
              endDate: endDateTime
           };
            $cordovaCalendar.deleteEvent(objOldEventJson).then(function (result) {
                var options1 = $scope.getEvent(event,activate);
                $cordovaCalendar.createEventWithOptions(options1).then(function (result) {
                    $scope.activeEventNo += 1;
                    if($scope.activeEventsList.length > $scope.activeEventNo){
                        $scope.updateEvents($scope.activeEventsList[$scope.activeEventNo],activate);
                    }
                },function(error){
                    console.log("error while updating in settings module"+error);
                });
            },function(error){
                console.log("error while updating in settings module"+error);
            });
       }
       
       $scope.getEvent=function(event,activateRemainders){
                var date = new Date(event.aptdate);
          
                var startDateTime=new Date(date.getFullYear(), date.getMonth(), date.getDate(), date.getHours(), date.getMinutes(), 0, 0, 0);
                var endDateTime = new Date(startDateTime.getTime()+(60*60*1000));


                var strAvec=(event.contactName!=="" && event.contactName !== null && event.contactName !== "null") ? " avec " +event.contactName:"";
                var objEventJson={
                    title: event.description+strAvec,
                    location: null,//event.apttype,
                    notes: event.description,
                    startDate: startDateTime,
                    endDate: endDateTime,
                    firstReminderMinutes: null,
                    secondReminderMinutes: null,
                    recurrence: null, // options are: 'daily', 'weekly', 'monthly', 'yearly'
                    recurrenceInterval: 1, // only used when recurrence is set
                    recurrenceEndDate: null,
                    calendarName: null,
                    calendarId: null,
                    url: null
                };

                    var slotTimeInMinutes = [10080, 1440, 120, 60];
                    var reminderSlotPosition = [event.reminder7, event.reminder1, event.reminder8, event.reminder0];
                    var selectedSlotTime = [];
                    for(var rSlot in reminderSlotPosition){
                        if(parseInt(reminderSlotPosition[rSlot]) === 1){
                            selectedSlotTime.push(slotTimeInMinutes[rSlot]);
                        }
                    }

                    if(selectedSlotTime[0] != undefined && activateRemainders === true){
                        objEventJson['firstReminderMinutes']=selectedSlotTime[0];
                    }
                    if(selectedSlotTime[1] != undefined && activateRemainders === true){
                        objEventJson['secondReminderMinutes']=selectedSlotTime[1];
                    }
                    
                    return objEventJson;
         }

    $scope.backToAddTreatment = function(){
        $state.go('app.addtreatment.dosage');
    }

    $ionicPlatform.onHardwareBackButton(function(event){

    });
});

