angular.module('HealthContacts.services', ['SEPAgenda.services','util.services']).factory('healthContactService', function($q,DB,UTIL_SERVICE) {

   var self = this;

   self.healthContacts = [];
     
   self.contactObj = {
      id : "",
      location : "",
      name : "",
      address : "",
      phone : "",
      phoneExtra : "",
      phone2  : "",
      phone2Extra : "",
      fax : "",
      email : "",
      website : "",
      prophone : "",
      email2 : ""
   };                                                                  
   
                                                                       
   /*self.init = function(){
    console.log("Initializing Health Contacts Data");
    self.countOfHealthContacts().then(
      function(result){
         var dbContactCount = result.rows.item(0).cnt;
          if(dbContactCount == 0){
             UTIL_SERVICE.jsonFileReader("modules/contacts/healthNetworkContacts.json").then(
             function(result){
               var jsonContactCount = result.data.healthcontacts.length;
               var contact = result.data.healthcontacts;
               for(var i=0;i<jsonContactCount;i++){
                 // self.setDefaultValues();
                  self.contactObj.location = contact[i].location;
                  self.contactObj.name = contact[i].name;
                  self.contactObj.address = contact[i].address;
                  self.contactObj.phone = contact[i].phone;
                  self.contactObj.phoneExtra = contact[i].phoneExtra;
                  self.contactObj.phone2  = contact[i].phone2;
                  self.contactObj.phone2Extra = contact[i].phone2Extra;
                  self.contactObj.fax = contact[i].fax;
                  self.contactObj.email = contact[i].email;
                  self.contactObj.website = contact[i].website;
                  self.contactObj.prophone = contact[i].prophone;
                  self.contactObj.email2 = contact[i].email2;
                  self.insertHealthContact(self.contactObj).then(function(result){
                    console.log("Health Contact "+i+" is inserted with Id : "+result.insertId);
                  },function(error){
                    console.log("Error inserting Health Contact at "+i+"  "+error);
                  });
               }
             },
             function(error){
                console.log("Error reading JSON Data :"+error);
             });
          }
      },
      function(error){dbContactCount = error;
             console.log("Error reading Health Contact Data ");
    });
   };*/

   self.countOfHealthContacts = function(){
        var sqlQuery = 'select count(*) as cnt from HealthNetwork';
        return DB.query(sqlQuery).then(function(result){
          return result;
        },function(error){
           console.log("Error retrieving data from Health Contacts"+error);
          return error;
        });
   };

   self.selectAllHealthContacts = function(){
        self.healthContacts = [];
        var sqlQuery = 'SELECT * FROM HealthNetwork ORDER BY name COLLATE NOCASE ASC';
        return DB.query(sqlQuery).then(function(result){
         /* var contactCount = result.rows.length;
          for(var i=0;i<contactCount;i++){
              self.healthContacts.push(result.rows.item(i));
          }
          return self.healthContacts; */
          return result;
        },function(error){
           console.log("Error retrieving data from Health Contacts : "+error);
          return error;
        });
   };
                                                                                          
   self.getHealthContact = function(id){
            var healthConCount = self.healthContacts.length;
            for(var i=0;i<healthConCount;i++){
              if(self.healthContacts[i].id === parseInt(id)){
                  return self.healthContacts[i]; 
              }
          }                                                                              
   };
                                                                       
  /* self.selectLocationSpecificContacts = function(locationId){
        var regionHealthContacts = [];
        var sqlQuery = 'select * from HealthNetwork where location = ? order by location ASC';
        var bindingvalues = ['locationId'];
        return DB.query(sqlQuery,bindingvalues).then(function(result){
          var contactCount = result.rows.length;
          for(int i=0;i<contactCount;i++){
              regionHealthContacts.push(result.rows.item(i));
          }
          return regionHealthContacts;
        },function(error){
           console.log("Error retrieving data from Health Contacts specific to a location");
          return error});
   }; */

   self.selectLocationSpecificContacts = function(locationId){
          var regionHealthContacts = [];
          var contactCount = self.healthContacts.length;
          for(var i=0;i<contactCount;i++){
              if(self.healthContacts[i].location === locationId){
                regionHealthContacts.push(self.healthContacts[i]);
              }
          }
          self.healthContacts = [];
          self.healthContacts = regionHealthContacts;
          return self.healthContacts;
        },function(error){
           console.log("Error retrieving data from Health Contacts specific to a location : "+error);
           self.healthContacts = [];
           return self.healthContacts;
   };

                                                                                                                                                                                              
    return self;
});