angular.module('PatientGroupContacts.services', ['SEPAgenda.services','util.services']).factory('patientGroupContactService', function($q,DB,UTIL_SERVICE) {
                                                                                          
          var self = this;
          
          self.patientGroupContacts = [];
          
          self.patientGroupContactObj = {
              id : "",
              builtin : "",
              icon : "",
              name : "",
              description : "",
              address : "",
              phone  : "",
              phoneExtra : "",
              cell : "",
              email : "",
              website : ""
          };
          
          
          /*self.init = function(){
          console.log("Initializing Patient Group Contacts Data");
          return self.countOfPatientGroupContacts().then(
                function(result){
                var dbContactCount = result.rows.item(0).cnt;
                if(dbContactCount == 0){
                UTIL_SERVICE.jsonFileReader("modules/contacts/patientGroupContacts.json").then(
                      function(result){
                      var jsonContactCount = result.data.patientgroupcontacts.length;
                      var contact = result.data.patientgroupcontacts;
                      for(var i=0;i<jsonContactCount;i++){
                      // self.setDefaultValues();
                      self.patientGroupContactObj.builtin = contact[i].builtin;
                      self.patientGroupContactObj.icon = contact[i].icon;
                      self.patientGroupContactObj.name = contact[i].name;
                      self.patientGroupContactObj.description = contact[i].description;
                      self.patientGroupContactObj.address  = contact[i].address;
                      self.patientGroupContactObj.phone = contact[i].phone;
                      self.patientGroupContactObj.phoneExtra = contact[i].phoneExtra;
                      self.patientGroupContactObj.cell = contact[i].cell;
                      self.patientGroupContactObj.email = contact[i].email;
                      self.patientGroupContactObj.website = contact[i].website;
                      
                      self.insertPatientGroupContact(self.patientGroupContactObj).then(function(result){
                             console.log("Patient Group Contact "+i+" is inserted with Id : "+result.insertId);
                             },function(error){
                             console.log("Error inserting Patient Group Contact at "+i+"  "+error);
                             });
                      }
                      },
                      function(error){
                        console.log("Error reading JSON Data :"+error);
                      });
                  }
                },
                function(error){dbContactCount = error;
                  console.log("Error reading Patient Group Contact Data ");
                });
          };*/
          
          self.insertPatientGroupContact = function(patientGroupContactObj) {
            patientGroupContactObj.phone = aesUtil.encrypt(salt, iv, passPhrase, patientGroupContactObj.phone);
            patientGroupContactObj.cell = aesUtil.encrypt(salt, iv, passPhrase, patientGroupContactObj.cell)
            patientGroupContactObj.email = aesUtil.encrypt(salt, iv, passPhrase, patientGroupContactObj.email);
            patientGroupContactObj.address = aesUtil.encrypt(salt, iv, passPhrase, patientGroupContactObj.address);
          var sqlQuery = 'insert or replace into PatientGroup(builtin, icon, name, description, address, phone, phoneExtra, cell, email, website) values (?,?,?,?,?,?,?,?,?,?)';
          var bindingvalues = [patientGroupContactObj.builtin,patientGroupContactObj.icon,patientGroupContactObj.name,patientGroupContactObj.description,patientGroupContactObj.address,patientGroupContactObj.phone,patientGroupContactObj.phoneExtra,patientGroupContactObj.cell,patientGroupContactObj.email,patientGroupContactObj.website];
          return DB.query(sqlQuery, bindingvalues).then(function(result) {
                        return result;
                        },function(error){
                        return error;
                        });
          };

          self.updatePatientGroupContact = function(patientGroupContactObj){
            patientGroupContactObj.phone = aesUtil.encrypt(salt, iv, passPhrase, patientGroupContactObj.phone);
            patientGroupContactObj.cell = aesUtil.encrypt(salt, iv, passPhrase, patientGroupContactObj.cell)
            patientGroupContactObj.email = aesUtil.encrypt(salt, iv, passPhrase, patientGroupContactObj.email);
            patientGroupContactObj.address = aesUtil.encrypt(salt, iv, passPhrase, patientGroupContactObj.address);
          var sqlQuery = 'update PatientGroup set builtin=?, icon=?, name=?, description=?, address=?, phone=?, phoneExtra=?, cell=?, email=?, website=? where id = ?';
          var bindingvalues = [patientGroupContactObj.builtin,patientGroupContactObj.icon,patientGroupContactObj.name,patientGroupContactObj.description,patientGroupContactObj.address,patientGroupContactObj.phone,patientGroupContactObj.phoneExtra,patientGroupContactObj.cell,patientGroupContactObj.email,patientGroupContactObj.website,patientGroupContactObj.id];
          return DB.query(sqlQuery, bindingvalues).then(function(result) {
                   return result;
                  },function(error){
                  return error;
                  });
          };
          
          self.countOfPatientGroupContacts = function(){
          var sqlQuery = 'select count(*) as cnt from PatientGroup';
          return DB.query(sqlQuery).then(function(result){
                       return result;
                     },function(error){
                       console.log("Error retrieving data from Patient Group Contacts"+error);
                       return error;
                     });
          };

          self.deletePatientGroupDetails = function(patientGroupContactObj){
            var sqlQuery = 'delete from PatientGroup where id=?';
            var bindingvalues = [patientGroupContactObj.id];
            return DB.query(sqlQuery,bindingvalues).then(function(result){
               return result;
            },function(error){
               return error
            });
          };
          
          self.selectAllpatientGroupContacts = function(){
          self.patientGroupContacts = [];
          var sqlQuery = 'SELECT * FROM PatientGroup ORDER BY name COLLATE NOCASE';
          return DB.query(sqlQuery).then(function(result){
                   /*  var contactCount = result.rows.length;
                     for(var i=0;i<contactCount;i++){
                      self.patientGroupContacts.push(result.rows.item(i));
                     }
                     return self.patientGroupContacts; */
                     return result;
                     },function(error){
                      console.log("Error retrieving data from Patient Group Contacts : "+error);
                     return error;});
          };
          
          self.getPatientGroupContact = function(id){
          var patientGroupConCount = self.patientGroupContacts.length;
          for(var i=0;i<patientGroupConCount;i++){
            if(self.patientGroupContacts[i].id === parseInt(id)){
              return self.patientGroupContacts[i]; 
            }
          }                                                                              
          };

    return self;
});