app.controller('addprofessionalscontroller', function($scope,$rootScope, $state, $ionicModal, $ionicPopup, $ionicScrollDelegate, $translate, $filter, professionalService, DB, $cordovaCalendar, ProfessionalContactSharedProperties, UTIL_SERVICE, $document) {
    $scope.professionalContactModel = {
            id : "",
            intitule :"",
            title : "",
            name : "",
            phone: "",
            phoneModel : [
                      { index:0, id:"1", value: "", displayNum:""}
                    ],
            cell : "",
            cellModel : [
                      { index:0, id:"1", value: "", displayNum:"" }
                    ],
            email : "",
            emailModel : [
                      { index:0, id:"1", value: "", displayNum:"" }
                    ],
            address : {
              street : "",
              ville : "",
              postalcode : ""
            },
            deviceId : ""
      };

      $scope.event={
        apttype : 25
      };

    $scope.editMode = false;
    $scope.triggeredButton = false;
    $scope.apttypename="";
    $scope.buttonName = $translate.instant('SAVE');
    $scope.headerTitle = $translate.instant('ADD_PROF_TITLE');


    $scope.intitulelistitems = [
    {listId: "0", listName: $translate.instant('ADDEVENT_LIST_ITEM1')},
    {listId: "1", listName: $translate.instant('ADDEVENT_LIST_ITEM2')},
    {listId: "2", listName: $translate.instant('ADDEVENT_LIST_ITEM3')},
    {listId: "3", listName: $translate.instant('ADDEVENT_LIST_ITEM4')},
    {listId: "4", listName: $translate.instant('ADDEVENT_LIST_ITEM5')},
    {listId: "5", listName: $translate.instant('ADDEVENT_LIST_ITEM6')},
    {listId: "6", listName: $translate.instant('ADDEVENT_LIST_ITEM7')},
    {listId: "7", listName: $translate.instant('ADDEVENT_LIST_ITEM8')},
    {listId: "8", listName: $translate.instant('ADDEVENT_LIST_ITEM9')},
    {listId: "9", listName: $translate.instant('ADDEVENT_LIST_ITEM10')},
    {listId: "10", listName: $translate.instant('ADDEVENT_LIST_ITEM11')},
    {listId: "11", listName: $translate.instant('ADDEVENT_LIST_ITEM12')},
    {listId: "12", listName: $translate.instant('ADDEVENT_LIST_ITEM13')},
    {listId: "13", listName: $translate.instant('ADDEVENT_LIST_ITEM14')},
    {listId: "14", listName: $translate.instant('ADDEVENT_LIST_ITEM15')},
    {listId: "15", listName: $translate.instant('ADDEVENT_LIST_ITEM16')},
    {listId: "16", listName: $translate.instant('ADDEVENT_LIST_ITEM17')},
    {listId: "17", listName: ""}
    ];

    $ionicModal.fromTemplateUrl('templates/intitulelist.html', {
          scope: $scope
      }).then(function(modal) {
          $scope.modal = modal;
      });

      $rootScope.hideModal = function(){
          if($scope.modal !== undefined){
              $scope.modal.hide();
          }
          if($scope.eventContactModel !== undefined){
              $scope.eventContactModel.hide();
          }
          if($scope.documentmodel !== undefined){
              $scope.documentmodel.hide();
          }
          if($scope.questionmodel !== undefined){
              $scope.questionmodel.hide();
          }
      }

      $scope.addPhoneNumbers = function(callType) {
          var newItemNo = $scope.professionalContactModel[callType].length+1;
          var displayNumber = "("+parseInt(newItemNo)+")"
          $scope.professionalContactModel[callType].push({index:$scope.professionalContactModel[callType].length, id:newItemNo, value: "", displayNum: displayNumber});
      };

      $scope.deletePhoneNumbers = function(dataObj, callType) {
          for(var i=0; i< $scope.professionalContactModel[callType].length; i++){
              if(dataObj.id === $scope.professionalContactModel[callType][i].id){
                  $scope.professionalContactModel[callType].splice(i, 1);
              }
          }
          for(var i=0; i< $scope.professionalContactModel[callType].length; i++){
              $scope.professionalContactModel[callType][i].index = i;
              $scope.professionalContactModel[callType][i].displayNum = (i==0)?"":"("+(parseInt(i)+1)+")";
          }
      };

      $scope.showAddButton = function(dataObj, callType){
          return dataObj.id === $scope.professionalContactModel[callType][0].id;
      }

      $scope.showDeleteButton = function(dataObj, callType){
          if(dataObj.id != $scope.professionalContactModel[callType][0].id){
              return true;
          } else{
              return false;
          }
      }

      $scope.listTitles = function(){
        ADB.trackState($translate.instant('SEPA_PROFESSIONNELS_DE_SANTE_INTITULE'));
          $scope.oldAptType = $scope.event.apttype;
          $scope.modal.show();
      }

       $scope.blurAllFormInput = function(){
        //ionic.DomUtil.blurAll()
    }

      $scope.saveIntituleOption = function(){
      //  ADB.trackState($translate.instant('SEPA_SAVE_INTITULE_LIST'));
      ADB.trackState($translate.instant('SEPA_CONTACT_PROFESSIONNELS_DE_SANTE_ADDNEW'));
        if(parseInt($scope.event.apttype) >= 0 && parseInt($scope.event.apttype) <= ($scope.intitulelistitems.length - 2)){
            $scope.professionalContactModel.intitule=$scope.intitulelistitems[$scope.event.apttype].listName;
            $scope.professionalContactModel.title=$scope.event.apttype;
            $scope.modal.hide();
        } else{
            console.log("Failed Seelcting Intitule");
        }
      }

      $scope.cancelIntitulelist = function(){
        //ADB.trackState($translate.instant('SEPA_CANCEL_INTITULE_LIST'));
        ADB.trackState($translate.instant('SEPA_CONTACT_PROFESSIONNELS_DE_SANTE_ADDNEW'));
            $scope.event.apttype = $scope.oldAptType;
            $ionicScrollDelegate.$getByHandle('intitulescroll').scrollTop();
            $scope.modal.hide();
      }

      $scope.navigateToScreen = function(pageName){
        $state.go(pageName);
      }

       $scope.init = function(){
        
        var selProfessionalContactObj = ProfessionalContactSharedProperties.getProfessionalContact();
        if(selProfessionalContactObj != null){

            $scope.professionalContactModel = selProfessionalContactObj;
            
            try {
              $scope.professionalContactModel.address = JSON.parse(selProfessionalContactObj.address);
            } catch(error){
              $scope.professionalContactModel.address.street = selProfessionalContactObj.address;
            }
            
            var phoneList = ($scope.professionalContactModel.phone == null || $scope.professionalContactModel.phone == 'null')?"":$scope.professionalContactModel.phone;
            phoneListObj = [];
            if(phoneList != ""){
              phoneListObj = phoneList.split(",");
            }
            $scope.professionalContactModel.phoneModel = [];
            if(phoneListObj.length > 0){
              for(var i=0; i<phoneListObj.length; i++){
                  var newItemNo = i+1;
                  var displayNumber = "";
                  if(i != 0)
                    displayNumber = "("+parseInt(newItemNo)+")";
                  $scope.professionalContactModel.phoneModel.push({"index":i, "id":newItemNo, "value": phoneListObj[i], "displayNum":displayNumber});
              }
            } else {
              $scope.professionalContactModel.phoneModel.push({"index":0, "id":"1", "value": ""});
            }

            var cellList = ($scope.professionalContactModel.cell == null || $scope.professionalContactModel.cell == 'null')?"":$scope.professionalContactModel.cell;
            cellListObj = [];
            if(cellList != ""){
              cellListObj = cellList.split(",");
            }
            $scope.professionalContactModel.cellModel = [];
            if(cellListObj.length > 0){
              for(var i=0; i<cellListObj.length; i++){
                  var newItemNo = i+1;
                  var displayNumber = "";
                  if(i != 0)
                    displayNumber = "("+parseInt(newItemNo)+")";
                  $scope.professionalContactModel.cellModel.push({"index":i, "id":newItemNo, "value": cellListObj[i], "displayNum":displayNumber});
              }
            } else {
              $scope.professionalContactModel.cellModel.push({"index":0, "id":"1", "value": ""});
            }
            
            var emailList = ($scope.professionalContactModel.email == null || $scope.professionalContactModel.email == 'null')?"":$scope.professionalContactModel.email;
            emailListObj = [];
            if(emailList != ""){
              emailListObj = emailList.split(",");
            }
            $scope.professionalContactModel.emailModel = [];
            if(emailListObj.length > 0){
              for(var i=0; i<emailListObj.length; i++){
                  var newItemNo = i+1;
                  var displayNumber = "";
                  if(i != 0)
                    displayNumber = "("+parseInt(newItemNo)+")";
                  $scope.professionalContactModel.emailModel.push({"index":i, "id":newItemNo, "value": emailListObj[i], "displayNum":displayNumber});
              }
            } else {
              $scope.professionalContactModel.emailModel.push({"index":0, "id":"1", "value": ""});
            }
            
            $scope.event.apttype=selProfessionalContactObj.title;
            //$scope.apttypename = $scope.intitulelistitems[evnt.title-1].listName;
            $scope.editMode = true;
            $scope.headerTitle = $translate.instant('EDIT_PROF_TITLE');
        }else{
            $scope.editMode = false;
        }
      }

    $scope.saveProfessionalContact=function(){
      $scope.triggeredButton = true;
      //ADB.trackState($translate.instant('SEPA_PROFESSIONNELS_DE_SANTE_DETAILS_MODIFYSTATE_VALIDER'));
       ADB.trackState($translate.instant('SEPA_CONTACT_LIST_PROFESSIONNELS_DE_SANTE'));

      if(parseInt($scope.event.apttype) === 25 || $scope.event.apttype==="25"){
            $scope.event.apttype = "";
        }

      if($scope.isValidInput()){
          var tempPhoneArr = new Array();
          for(var i = 0; i < $scope.professionalContactModel.phoneModel.length; i++){
              if($scope.professionalContactModel.phoneModel[i].value != ""){
                  tempPhoneArr.push($scope.professionalContactModel.phoneModel[i].value);
              }
          }
          $scope.professionalContactModel.phone = tempPhoneArr.join(",");

          var tempMobileArr = new Array();
          for(var i = 0; i < $scope.professionalContactModel.cellModel.length; i++){
              if($scope.professionalContactModel.cellModel[i].value != ""){
                  tempMobileArr.push($scope.professionalContactModel.cellModel[i].value);
              }
          }
          $scope.professionalContactModel.cell = tempMobileArr.join(",");

          var tempEmailArr = new Array();
          for(var i = 0; i < $scope.professionalContactModel.emailModel.length; i++){
              if($scope.professionalContactModel.emailModel[i].value != ""){
                  tempEmailArr.push($scope.professionalContactModel.emailModel[i].value);
              }
          }
          $scope.professionalContactModel.email = tempEmailArr.join(",");

          var selProfessionalContactObj = ProfessionalContactSharedProperties.getProfessionalContact();

        if(selProfessionalContactObj != null){
           //  add new
           $scope.updateProfessionalContact();
        } else {
          // modifiy
          $scope.insertProfessionalContact();
        }
    }
  }

 $scope.isValidInput=function(){
      var phoneFormat=", Valid format +XX XXXX XXXX , XX XXXX XXXX";
      /*if($scope.professionalContactModel.title===null || $scope.professionalContactModel.title==="" ){
        console.log("addprofessionalscontroller - Enter valid title");
        $ionicPopup.alert({
          title: $translate.instant('CON_TITLE_1'),
          template: $translate.instant('MSG_INTITULE_REQUIRED')
        });
        //alert($translate.instant('MSG_INTITULE_REQUIRED'));
        return false;
      } else */
      if($scope.professionalContactModel.name===null || $scope.professionalContactModel.name==="" ){
        $scope.triggeredButton = false;
        $ionicPopup.show({
          //title: $translate.instant('CON_TITLE_1'),
          cssClass:'form-alert-popup',
                            buttons: [
                                            { 
                                                text: 'OK', 
                                                type:'button-default first-button last-button',
                                                onTap: function(e) {
                                                    
                                                }
                                            } 
                                     ],
          template: $translate.instant('MSG_NOM_REQUIRED')
        });
        //alert($translate.instant('MSG_NOM_REQUIRED'));
        return false;
      }
      if($scope.professionalContactModel.phoneModel.length > 0){
          for(var i=0; i < $scope.professionalContactModel.phoneModel.length; i++){
              if($scope.professionalContactModel.phoneModel[i].value!==null && $scope.professionalContactModel.phoneModel[i].value!=="" && !UTIL_SERVICE.isValidPhoneNo($scope.professionalContactModel.phoneModel[i].value)){
                  $scope.triggeredButton = false;    
                  $ionicPopup.show({
                    //title: $translate.instant('CON_TITLE_1'),
                    cssClass:'form-alert-popup',
                                      buttons: [
                                                      { 
                                                          text: 'OK', 
                                                          type:'button-default first-button last-button',
                                                          onTap: function(e) {
                                                              
                                                          }
                                                      } 
                                               ],
                    template: $translate.instant('MSG_INVALID_FIXE')
                  });
                 // alert($translate.instant('MSG_INVALID_FIXE')+phoneFormat);
                return false;
              }
          }
      }
      if($scope.professionalContactModel.cellModel.length > 0){
          for(var i=0; i < $scope.professionalContactModel.cellModel.length; i++){
            if($scope.professionalContactModel.cellModel[i].value!==null && $scope.professionalContactModel.cellModel[i].value!=="" && !UTIL_SERVICE.isValidPhoneNo($scope.professionalContactModel.cellModel[i].value)){
                  $scope.triggeredButton = false;
                  $ionicPopup.show({
                    //title: $translate.instant('CON_TITLE_1'),
                    cssClass:'form-alert-popup',
                                      buttons: [
                                                      { 
                                                          text: 'OK', 
                                                          type:'button-default first-button last-button',
                                                          onTap: function(e) {
                                                              
                                                          }
                                                      } 
                                               ],
                    template: $translate.instant('MSG_INVALID_MOBILE')
                  });
                  //alert($translate.instant('MSG_INVALID_CELL')+phoneFormat);
                  return false;
            }
          }
      }
      if($scope.professionalContactModel.address.postalcode!==null && $scope.professionalContactModel.address.postalcode!=="" && !UTIL_SERVICE.isValidPostalCode($scope.professionalContactModel.address.postalcode)){
        $scope.triggeredButton = false;
        $ionicPopup.show({
          //title: $translate.instant('CON_TITLE_1'),
          cssClass:'form-alert-popup',
                            buttons: [
                                            { 
                                                text: 'OK', 
                                                type:'button-default first-button last-button',
                                                onTap: function(e) {
                                                    
                                                }
                                            } 
                                     ],
          template: $translate.instant('MSG_INVALID_POSTALCODE')
        });
        //alert($translate.instant('MSG_INVALID_POSTALCODE'));
        return false;
      }

      if($scope.professionalContactModel.emailModel.length > 0){
          for(var i=0; i < $scope.professionalContactModel.emailModel.length; i++){
                if($scope.professionalContactModel.emailModel[i].value!==null && $scope.professionalContactModel.emailModel[i].value!=="" && !UTIL_SERVICE.isValidEmail($scope.professionalContactModel.emailModel[i].value)){
                  $scope.triggeredButton = false;
                  $ionicPopup.show({
                    //title: $translate.instant('CON_TITLE_1'),
                    cssClass:'form-alert-popup',
                                      buttons: [
                                                      { 
                                                          text: 'OK', 
                                                          type:'button-default first-button last-button',
                                                          onTap: function(e) {
                                                              
                                                          }
                                                      } 
                                               ],
                    template: $translate.instant('MSG_INVALID_EMAIL')
                  });
                  //alert($translate.instant('MSG_INVALID_EMAIL'));
                  return false;
                }
          }
      }
      return true;
    }


    $scope.insertProfessionalContact=function(){
        var newProfessionalContact=$scope.professionalContactModel;
        newProfessionalContact.address=JSON.stringify($scope.professionalContactModel.address);
        var profContactForService = angular.copy(newProfessionalContact);
        professionalService.insertProfessionalContact(profContactForService).then(function(result){
          $state.go('app.professionallist'); 
          //Check whether these lines have to be removed
         professionalService.selectAllprofessionalContacts().then(function(result){
          }, function(error){
              console.log("addprofessionalscontroller selectAllprofessionalContacts error="+JSON.stringify(error));
          })
        }, function(error){
          console.log("addprofessionalscontroller insertProfessionalContact error="+JSON.stringify(error));
        })
    }

    $scope.updateProfessionalContact=function(){
       var modifitedProfessionalContact=$scope.professionalContactModel;
        modifitedProfessionalContact.address=JSON.stringify($scope.professionalContactModel.address);
        var profContactForService = angular.copy(modifitedProfessionalContact);
        professionalService.updateProfessionalContact(profContactForService).then(function(result){
          $state.go('app.professionallist'); 
          /*professionalService.selectAllprofessionalContacts().then(function(result){
              console.log("addprofessionalscontroller selectAllprofessionalContacts result="+JSON.stringify(result));
          }, function(error){
              console.log("addprofessionalscontroller selectAllprofessionalContacts error="+JSON.stringify(error));
          })*/
        }, function(error){
          console.log("addprofessionalscontroller editProfessionalContact error="+JSON.stringify(error));
        })
    }

      $scope.editProfessionalContactScreen=function(){
//        ADB.trackState($translate.instant('SEPA_PROFESSIONNELS_DE_SANTE_DETAILS_MODIFY_BUTTON'));
        $scope.buttonName = $translate.instant('VALIDER');
        $scope.editMode = false;
      }

    $scope.cancelProfessionalContact=function(){
      //ADB.trackState($translate.instant('SEPA_PROFESSIONNELS_DE_SANTE_DETAILS_MODIFYSTATE_ANNULER'));
       ADB.trackState($translate.instant('SEPA_CONTACT_LIST_PROFESSIONNELS_DE_SANTE'));
      $state.go('app.professionallist'); 
    }
      
})
.directive('focusMe', function($timeout) {
   return {
        restrict : "C",
        link: function(scope, element, attrs) {
            if( scope.focusValue ) {
                $timeout(function() {
                    element[0].focus();
                });
            }
        }
    };
})  

.service('ProfessionalContactSharedProperties', function () {
    var property = null;

    return {
        getProfessionalContact: function () {
            return property;
        },
        setProfessionalContact: function(value) {
            property = value;
        }
    };
});

