app.controller('agendaeventscontroller', function($scope, $rootScope, $ionicNavBarDelegate, $state, $ionicPlatform, $ionicPopup, $translate, DB,UTIL_SERVICE,appInfoService,EventSharedProperties) {
  ADB.trackState($translate.instant('SEPA_AGENDA_EVENT'));
});

app.controller('MyCtrl', function($scope, $translate, $cordovaCalendar, $ionicPopup, $state, $filter, appntService,EventSharedProperties) {
   ADB.trackState($translate.instant('SEPA_AGENDA_EVENT'));
  $scope.shouldShowDelete = false;
  $scope.shouldShowReorder = false;
  $scope.listCanSwipe = true;
  $scope.showEventList = false;
  $scope.items = [
    /*{eventId: "1", aptType: "RDV avec", aptContact:"MARTIN", aptTime:"10 h 30", aptDate:"Thrusday 10 September 2015"},
    {eventId: "2", aptType: "Event 2", aptContact:"JOHN", aptTime:"22 h 15", aptDate:"Friday 24 April 2015"},
    {eventId: "3", aptType: "Event 3", aptContact:"DATA", aptTime:"22 h 15", aptDate:"Thrusday 10 November 2015"},
    {eventId: "4", aptType: "Event 4", aptContact:"TETS", aptTime:"22 h 15", aptDate:"Thrusday 31 February 2015"},
    {eventId: "5", aptType: "Event 5", aptContact:"DR Bond", aptTime:"22 h 15", aptDate:"Thrusday 31 December 2015"},
    {eventId: "6", aptType: "Event 6", aptContact:"Dr Scott", aptTime:"DD MOM", aptDate:"DD MOM"},
    {eventId: "7", aptType: "Event 7", aptContact:"Dr  MOMO", aptTime:"DD MOM", aptDate:"DD MOM"},
    {eventId: "8", aptType: "Event 8", aptContact:"Dr RAMOM", aptTime:"DD MOM", aptDate:"DD MOM"}*/
  ];

  $scope.addEventsScreen = function() {
    //ADB.trackState($translate.instant('SEPA_AGENDA_ADDNEW'));
      EventSharedProperties.setEvent(null);
      $state.go('app.addevent');
  }
 

  $scope.alertUser = function(eventobject) {
    ADB.trackState($translate.instant('SEPA_AGENDA_EVENT_ENTRY_CLICKED'));
        var aptContentName = eventobject.description+ ((eventobject.aptContact!="" && eventobject.aptContact!=null)?" avec  <strong>"+eventobject.aptContact+"</strong>":"");
        var aptContent = '<div class="row event-popup padding-bottom">';
            aptContent+= '<div class="col col-20">'+eventobject.aptTime+'</div>';
            aptContent+= '<div class="col col-80">'+eventobject.aptDateDisp+'</div>';
            aptContent+= '</div>';
        var alertUserForAction = $ionicPopup.show({
                                          template: aptContent,
                                          cssClass:'form-alert-popup',
                                          title: aptContentName,
                                          scope: $scope,
                                          buttons: [
                                            { 
                                                text: 'Annuler', 
                                                type:'button-default first-button',
                                                onTap: function(e) {
                                                 // ADB.trackState($translate.instant('SEPA_AGENDA_EVENT_ENTRY_ANNULER_CLICKED'));
                                                 ADB.trackState($translate.instant('SEPA_AGENDA_EVENT'));
                                                    alertUserForAction.close();
                                                }
                                            },
                                            { text: 'Modifier',
                                              onTap: function(e) {
                                                //ADB.trackState($translate.instant('SEPA_AGENDA_EVENT_ENTRY_MODIFIER_CLICKED'));
                                                    $scope.modifyEvent(eventobject);
                                                }
                                            },
                                            { text: 'Supprimer', 
                                              type:'button-default last-button',
                                              onTap: function(e) {
                                                //ADB.trackState($translate.instant('SEPA_AGENDA_EVENT_ENTRY_SUPPRIMER_CLICKED'));
                                                    $scope.deleteConfirmation(eventobject);
                                                }}
                                          ]
                                        });
    }


$scope.modifyEvent = function(eventobject){
//ADB.trackState($translate.instant('SEPA_MODIFY_EVENT'));
    EventSharedProperties.setEvent(eventobject);
    $state.go('app.addevent');
}

$scope.deleteConfirmation = function(eventobject){
  ADB.trackState($translate.instant('SEPA_AGENDA_EVENT_ENTRY_DELETE_CONFIRMATION'));
    var deleteConfirm = $ionicPopup.confirm({
        title: $translate.instant('LIST_DELETE_CONFIRM'),
        template: $translate.instant('LIST_DELETE_CONFIRM_2'),
        cssClass: "form-alert-popup sepa-confirmation-popup",
        okText:$translate.instant('SUPPRIMER'),
        okType:"custom-button button-default last-button",
        cancelText:$translate.instant('ANNULER'),
        cancelType:"custom-button button-default first-button"
    });

    deleteConfirm.then(function(response){
        if(response){
          //ADB.trackState($translate.instant('SEPA_AGENDA_EVENT_ENTRY_DELETE_CONFIRMATION_SUP'));
          ADB.trackState($translate.instant('SEPA_AGENDA_EVENT'));
            $scope.deleteEvent(eventobject);
        } else{
          //ADB.trackState($translate.instant('SEPA_AGENDA_EVENT_ENTRY_DELETE_CONFIRMATION_ANN'));
          ADB.trackState($translate.instant('SEPA_AGENDA_EVENT'));
            deleteConfirm.close();
        }
    });
}

$scope.deleteEvent = function(eventobject){
    appntService.deleteEvent(eventobject).then(function(result){
        for(var i=0;i<$scope.items.length;i++){
             if($scope.items[i].id === eventobject.id){
                 $scope.items.splice(i,1);
             }
        }
        if($scope.items.length === 0){
            $scope.showEventList = false;
            if (!$scope.$$phase) {
                $scope.$apply();
            }
        }
        appntService.eventsList=[];
        appntService.eventsList=$scope.items;
        $scope.deleteEventInDevice(eventobject);
    },function(error){
            console.log("Error deleting events");
    });
}
$scope.getEventEndDate=function(startDateTime){
        return new Date(startDateTime.getTime()+(60*60*1000));
    }
$scope.deleteEventInDevice=function(oldEventRec){
  var date = new Date(oldEventRec.aptDate+" "+oldEventRec.aptTime.replace(" h ",":"));
  var dateinfo={};
            dateinfo.date = date.getDate();
            dateinfo.month = date.getMonth();
            dateinfo.fullyear = date.getFullYear();
            dateinfo.hours = date.getHours();
            dateinfo.minutes = date.getMinutes();
            var oldEventData=oldEventRec;

            var startDateTime=new Date(dateinfo.fullyear, dateinfo.month, dateinfo.date, dateinfo.hours, dateinfo.minutes, 0, 0, 0);
            var endDateTime = $scope.getEventEndDate(startDateTime);
            var strAvec=(oldEventRec.contactName!=="" && oldEventRec.contactName!==null)? "avec " +oldEventRec.contactName:"";
            
            var objOldEventJson={
            title: oldEventData.description+ strAvec,//oldEventData.contactName,
            location: null,
            notes: oldEventData.description,
            startDate: startDateTime,
            endDate: endDateTime
            };
            $cordovaCalendar.deleteEvent(objOldEventJson).then(function (result) {
            },function(error){
                  console.log("Event  not deleted in Device Calendar Error:"+error);
            });
}

$scope.showAllAppointments = function(){
 // $scope.items = appntService.eventsList;
    appntService.selectAllAppointments().then(function(result){
        appntService.eventsList = [];
        var tembEventList=[];
        var eventsCount = result.rows.length;
        if(eventsCount>0){
            for(var i=0;i<eventsCount;i++){
                appntService.eventsList.push(result.rows.item(i));
                var eventItem={};
                var a=result.rows.item(i);
                var objAptDate=new Date(a.aptdate);
                var aptTime=$filter('date')(objAptDate, "HH 'h' mm");
                  
                var momentFormat = moment(objAptDate);
                var aptDateDisp = momentFormat.locale("fr").format("dddd Do MMMM YYYY");
                  
                var aptDate=$filter('date')(objAptDate, "EEEE dd MMMM yyyy");

                eventItem["eventId"]= a.eventId;
                eventItem["apttype"]=a.apttype;
                a.contactName = aesUtil.decrypt(salt, iv, passPhrase,a.contactName);
                eventItem["aptContact"]=a.contactName;

                eventItem["aptTime"]=aptTime;
                eventItem["aptDate"]=aptDate;
                eventItem["aptDateDisp"]=aptDateDisp;
                  
                eventItem["contactName"]=a.contactName;
                eventItem["description"]=a.description;
                eventItem["descriptionCustom"]= a.description;
                if(a.contactName != "" && a.contactName != null){
                    eventItem["descriptionCustom"] += " avec ";
                }
                eventItem["id"]=a.id;
                eventItem["reminder0"]=a.reminder0;
                eventItem["reminder1"]=a.reminder1;
                eventItem["reminder7"]=a.reminder7;
                eventItem["reminder8"]=a.reminder8;
                tembEventList.push(eventItem);
            }
            $scope.items = tembEventList;
            $scope.showEventList = true;
        }else{
            $scope.showEventList = false;
        }
    },function(error){
        console.log("Error reading Events Data : "+error);
        $scope.items = [];
    });
}

 $scope.showAllAppointments();

 
  /* $cordovaCalendar.createCalendar({
      calendarName: $translate.instant('SEP_AGENDA'),
      calendarColor: '#FF0000'
    }).then(function (result) {
      // success
      console.log("Calendar created successfully result:"+result);
    }, function (err) {
      // error
      console.log("Calendar not created Error :"+err);
    });
    */
  //$scope.listEventsInRange=function(){
/*
var d = new Date(2015, 1, 1, 9,30,0,0,0);
var d1 = new Date(2015, 12, 30, 10,30,0,0,0);
  $cordovaCalendar.listEventsInRange(
      d,d1
    /*  , function(eventList){
      $scope.items =eventList;
         console.log("Event listEventsInRange result:"+JSON.stringify(eventList));
      }, 
      function(error){
      console.log("Event listEventsInRange Error:"+JSON.stringify(error));
      } 
    );*/
/*
  ).then(function (result) {
      // success
        //$scope.items =result;
      console.log("Event listEventsInRange result:"+JSON.stringify(result));
      
    }, function (err) {
      // error
      console.log("Event listEventsInRange Error:"+JSON.stringify(err));
    });*/
  //};

/*$cordovaCalendar.findEvent({
    title: '',
    location: '',
    notes: '',
    startDate: d,
    endDate: d1
}).then(function (result) {
    console.log('results', JSON.stringify(result, null, '\t'));
    console.log(new Date());
    console.log(d, d1);
}, function (err) {
    console.error('err', err);
});
*/
/*
  $scope.createEvent = function(eventObj) {
var startdate= new Date(2015, 0, 15, 18, 30, 0, 0, 0);
var  endDate= new Date(2015, 1, 17, 12, 0, 0, 0, 0);

if(eventObj)
var eventObj = {
      id : "",
      aptType : "1",
      aptDateTime :"12 Dec 2015",
      description : "Test event",
      reminder0 : "0",
      reminder1 : "1",
      reminder7 : "7",
      contactName : "Jay",
      eventId : ""
    };

//var eventid= appntService.insertEvent(eventObj);//insertAppointment(eventObj);

//var eventlist=appntService.selectAllAppointments();

//console.log("After createEvent new eventid="+eventid);
//console.log("After createEvent eventlist:"+JSON.stringify(eventlist));

        $cordovaCalendar.createEvent({
            title: 'Space Race',
            location: 'The Moon',
            notes: 'Bring sandwiches',
            startDate: new Date(2015, 0, 15, 18, 30, 0, 0, 0),
            endDate: new Date(2015, 1, 17, 12, 0, 0, 0, 0)
        }).then(function (result) {
            console.log("Event created successfully");
        }, function (err) {
            console.error("There was an error: " + err);
        });
    }*/
});