app.controller('associationlistcontroller', function($scope, $state, $translate, DB,$ionicPopup, patientGroupContactService, UTIL_SERVICE, AssociationSharedProperties) {
    $scope.items = [];
    $scope.onload = function(){
                patientGroupContactService.selectAllpatientGroupContacts().then(function(result){
                     var contactCount = result.rows.length;
                     for(var countI=0;countI<contactCount;countI++){
                         var object = result.rows.item(countI);
                         object.address = aesUtil.decrypt(salt, iv, passPhrase, object.address);
                         object.phone = aesUtil.decrypt(salt, iv, passPhrase, object.phone);
                         object.cell = aesUtil.decrypt(salt, iv, passPhrase, object.cell);
                         object.email = aesUtil.decrypt(salt, iv, passPhrase, object.email);
                         var address = object.address;
                         var strAddress = "";
                         try{
                            var jsonObj = JSON.parse(object.address);
                            
                            var strAddressArray = new Array();
                             if(jsonObj.address1 != undefined && jsonObj.address1 != "")
                                strAddressArray.push(jsonObj.address1);
                             if(jsonObj.address3 != undefined && jsonObj.address3 != "")
                                strAddressArray.push(jsonObj.address3);
                             if(jsonObj.address2 != undefined && jsonObj.address2 != "")
                                strAddressArray.push(jsonObj.address2);
                             
                             if(strAddressArray.length > 0)
                                strAddress = strAddressArray.join(", ");
                         }catch(e){
                          strAddress = object.address;
                         }

                         var listDescArray = [];

                         if(object.description !== null && object.description !== undefined){
                           var listObj = object.description.split("%#LINEBREAK#%");
                           for(var i in listObj){
                              listDescArray.push(listObj[i]); 
                           }
                         }

                         var item = {
                             name: object.name,
                             description: listDescArray,
                             refId: object.id,
                             builtin: (object.builtin == 1)?true:false,
                             jsonAddress: object.address,
                             phone: object.phone,
                             phoneExtra: object.phoneExtra,
                             email:object.email,
                             cell: object.cell,
                             contactDetails: [
                                /*{name: "Fixe",data:object.phone,type:"LANDLINE",typeinfo:"LANDLINE_INFO"},
                                {name: "Mobile",data:object.phoneExtra,type:"MOBILE",typeinfo:"MOBILE_INFO"},
                                {name: "Adresse",data:address,type:"ADDRESS-D",typeinfo:""},
                                {name: "E-mail",data:object.email,type:"EMAIL",typeinfo:"EMAIL_INFO"},
                                {name: "Web",data:object.website,type:"WEBSITE",typeinfo:"WEBSITE_INFO"}*/
                            ],
                            website: object.website
                         };

                         if(object.phone!="" && object.phone!== null && object.phone!== 'null' && object.phone != undefined){
                            var phoneObj = object.phone.split(",");
                            for(var i in phoneObj){
                                var suffix = (i != 0)?"("+(parseInt(i)+1)+")":"";
                                item.contactDetails.push({name: "Fixe "+suffix,data:phoneObj[i],type:"LANDLINE",typeinfo:"LANDLINE_INFO"});
                            }
                         }
                         if(object.cell!="" && object.cell!== null && object.cell!== 'null' && object.cell!= undefined){
                            var cellObj = object.cell.split(",");
                            for(var i in cellObj){
                                var suffix = (i != 0)?"("+(parseInt(i)+1)+")":"";
                                item.contactDetails.push({name: "Mobile "+suffix,data:cellObj[i],type:"MOBILE",typeinfo:"MOBILE_INFO"});
                            }
                         }
                         if(strAddress!="" && strAddress!== null && strAddress != undefined) 
                            item.contactDetails.push({name: "Adresse",data:strAddress, type:"ADDRESS-D",typeinfo:""});

                         if(object.email!="" && object.email!== null && object.email!== 'null' && object.email != undefined){
                            var emailObj = object.email.split(",");
                            for(var i in emailObj){
                                var suffix = (i != 0)?"("+(parseInt(i)+1)+")":"";
                                item.contactDetails.push({name: "E-mail "+suffix,data:emailObj[i],type:"EMAIL",typeinfo:"EMAIL_INFO"});
                            }
                         }
                         if(object.website != "" && object.website!= null && object.website!= 'null' && object.website != undefined )
                            item.contactDetails.push({name: "Web",data:object.website,type:"WEBSITE",typeinfo:"WEBSITE_INFO"});
                        
                        $scope.items.push(item);
                     }

                },function(failure){
                    $scope.items = [];
                });
        
    };
    $scope.onClickAssociateContact = function(assoContact){
      ADB.trackState($translate.instant('SEPA_CONTACT_ASSOCIATIONS_DE_PATIENTS_ITEM_CLICKED'));
        var aptContentName = "<strong>"+assoContact.name+"</strong>";
        var aptContent = '<div class="row event-popup padding-bottom">'+assoContact.description+'</div>';

        var alertUserForAction = $ionicPopup.show({
                                          template: aptContent,
                                          cssClass:'form-alert-popup',
                                          title: aptContentName,
                                          scope: $scope,
                                          buttons: [
                                            { 
                                                text: $translate.instant('ANNULER'), 
                                                type:'button-default first-button',
                                                onTap: function(e) {
                                                  //ADB.trackState($translate.instant('SEPA_CONTACT_ASSOCIATIONS_DE_PATIENTS_ITEM_CLICKED_ANN'));
                                                 ADB.trackState($translate.instant('SEPA_CONTACT_LIST_ASSOCIATIONS_DE_PATIENTS')); 
                                                    alertUserForAction.close();
                                                }
                                            },
                                            { text: $translate.instant('MODIFY'),
                                              onTap: function(e) {
                                               // ADB.trackState($translate.instant('SEPA_CONTACT_ASSOCIATIONS_DE_PATIENTS_ITEM_CLICKED_MOD'));
                                                    $scope.modifyAssociateContact(assoContact);
                                                }
                                            },
                                            { text: $translate.instant('SUPPRIMER'), 
                                              type:'button-default last-button',
                                              onTap: function(e) {
                                                //ADB.trackState($translate.instant('SEPA_CONTACT_ASSOCIATIONS_DE_PATIENTS_ITEM_CLICKED_SUP'));
                                                    $scope.deleteConfirmation(assoContact);
                                                }
                                            }
                                        ]
                                });
    };
    
    $scope.deleteConfirmation = function(assoContact){
    ADB.trackState($translate.instant('SEPA_CONTACT_ASSOCIATIONS_DE_PATIENTS_ITEM_DELETE_CONF'));
          var deleteConfirm = $ionicPopup.confirm({
              title: $translate.instant('LIST_DELETE_CONFIRM'),
              template: $translate.instant('LIST_DELETE_CONFIRM_2'),
              cssClass: "form-alert-popup sepa-confirmation-popup",
              okText:$translate.instant('SUPPRIMER'),
              okType:"custom-button button-default last-button",
              cancelText:$translate.instant('ANNULER'),
              cancelType:"custom-button button-default first-button"
          });

         

        deleteConfirm.then(function(response){
            if(response){
             // ADB.trackState($translate.instant('SEPA_CONTACT_ASSOCIATIONS_DE_PATIENTS_ITEM_DELETE_SUP'));
             ADB.trackState($translate.instant('SEPA_CONTACT_LIST_ASSOCIATIONS_DE_PATIENTS')); 
                assoContact.id = assoContact.refId;
                $scope.deleteAssociationContact(assoContact);
            } else{
              //ADB.trackState($translate.instant('SEPA_CONTACT_ASSOCIATIONS_DE_PATIENTS_ITEM_DELETE_ANN'));
              ADB.trackState($translate.instant('SEPA_CONTACT_LIST_ASSOCIATIONS_DE_PATIENTS')); 
                deleteConfirm.close();
            }
        });
    };
    
    $scope.deleteAssociationContact = function(assoContact){
        patientGroupContactService.deletePatientGroupDetails(assoContact).then(function(result){
            for(var i=0;i<$scope.items.length;i++){
                 if($scope.items[i].refId === assoContact.refId){
                     $scope.items.splice(i,1);
                 }
            }
        },function(error){
                console.log("Error deleting events");
        });
    }
    
    
//        $scope.items = [
//        {
//            refId: "1", contactName: "RDV avec", contactDesc:"MARTIN", contactDetails: [
//                {name: "Fixe",data:"+(33) xx xx xxxxx",type:"LANDLINE",typeinfo:"LANDLINE_INFO"},
//                {name: "Mobile",data:"+(33) xx xx xxxxx",type:"MOBILE",typeinfo:"MOBILE_INFO"},
//                {name: "Adresse",data:"F2 Stepstones Meenas Plot No 1 Narayanasamy 4th street Shollinganallur Chennai Tamilnadu India 600 119",type:"ADDRESS",typeinfo:"ADDRESS_INFO"},
//                {name: "E-mail",data:"anand.ramakrishnan.paramasivam@gmail.com",type:"EMAIL",typeinfo:"EMAIL_INFO"},
//                {name: "Web",data:"www.anandramakrishnan.com",type:"WEBSITE",typeinfo:"WEBSITE_INFO"}
//            ]
//        }
//      ];

      

      $scope.openNewAssociateContact = function(){
        ADB.trackState($translate.instant('SEPA_CONTACT_ASSOCIATIONS_DE_PATIENTS_ADDNEW'));
          AssociationSharedProperties.setAssociation(null);
          $scope.navigateToScreen('app.addassociations');
      }
      
      $scope.modifyAssociateContact = function(assocContact){
      ADB.trackState($translate.instant('SEPA_CONTACT_ASSOCIATIONS_DE_PATIENTS_ADDNEW'));
          AssociationSharedProperties.setAssociation(assocContact);
          $scope.navigateToScreen('app.addassociations');
      }
      
      $scope.navigateToScreen = function(pageName){
        $state.go(pageName);
      }

      $scope.callUtilService = function(P1, P2){
        if(P2 == 'WEBSITE') {
         // ADB.trackState($translate.instant('SEPA_CONTACT_ASSOCIATIONS_DE_PATIENTS_WEBSITE'));
          UTIL_SERVICE.openWebsite(P1,$scope);
        } else if(P2 == 'EMAIL') {
          //ADB.trackState($translate.instant('SEPA_CONTACT_ASSOCIATIONS_DE_PATIENTS_EMAIL'));
          UTIL_SERVICE.shareToMail(P1);
        } else if(P2 == 'MOBILE') {
          //ADB.trackState($translate.instant('SEPA_CONTACT_ASSOCIATIONS_DE_PATIENTS_MOBILE'));
          UTIL_SERVICE.dailNumber(P1,$scope);
        } else if(P2 == 'LANDLINE') {
          //ADB.trackState($translate.instant('SEPA_CONTACT_ASSOCIATIONS_DE_PATIENTS_LANDLINE'));
          UTIL_SERVICE.dailNumber(P1,$scope);
        }
      }

});