app.controller('calendarcontrol', function($scope, $rootScope, $state, $translate, $filter, DB,EventSharedProperties, TreatmentSharedProperties) {
    ADB.trackState($translate.instant('SEPA_CALENDAR'));
    $scope.changeMode = function(mode) {
      $scope.mode = mode;
    };
    $scope.today = function() {
      $scope.currentDate = new Date();
    };
    $scope.goToMainScreen = function() {
        $state.go('homescreen');
    };


    $scope.loadAddEvents = function(){
        //ADB.trackState($translate.instant('SEPA_AGENDA_ADDNEW'));
        EventSharedProperties.setEvent(null);
        $state.go('app.addevent.fromCalendar');
    }

    $scope.openEventDetails = function(eventObj){
//        ADB.trackState($translate.instant('SEPA_CALENDAR_EVENTS_MEDI_CLICKED'));
        EventSharedProperties.setEvent(eventObj);
        var objAptDate=new Date(eventObj.aptdate);
        var aptTime=$filter('date')(objAptDate, "HH 'h' mm");
          
        var momentFormat = moment(objAptDate);
        var aptDateDisp = momentFormat.locale("fr").format("dddd Do MMMM YYYY");
          
        var aptDate=$filter('date')(objAptDate, "EEEE dd MMMM yyyy");

        eventObj["aptContact"]=eventObj.contactName;
        eventObj["aptTime"]=aptTime;
        eventObj["aptDate"]=aptDate;
        eventObj["aptDateDisp"]=aptDateDisp;
        $state.go('app.addevent.fromCalendar');
    }
    $scope.listItems = [];

    $scope.openTreatmentDetails = function(trtmntObj){
       // ADB.trackState($translate.instant('SEPA_CALENDAR_EVENTS_MEDI_CLICKED'));
        TreatmentSharedProperties.setTreatment(trtmntObj);
        $rootScope.treatmentCallIntiate = "CALENDAR";
        $state.go('app.addtreatment');
    }

    $scope.scrollEvent = function(){
        console.log("On Scroll")
    }
});