app.controller('dashboardcontroller', function($scope,$rootScope, $ionicPopup,$ionicPlatform, $state, $translate, $cordovaCalendar, $filter, DB, appntService, treatmentService, EventSharedProperties, TreatmentSharedProperties, notificationutil, UTIL_SERVICE) {

	ADB.trackState($translate.instant('SEPA_DASHBOARD'));
    $rootScope.menuBackButtonDisplay = false;
    $rootScope.showingDashboardRappelPopup = false;
    $scope.naviagteFromCurrentDate = false;
    $scope.currentDateNav = 0;
    $scope.remindLateError = 0;
    $scope.remindmelaterErrorShow = false;
    $rootScope.notificationCount = 0;
    $scope.remindLateErrorMsgs = {
    	EMPTYFIELD:"Veuillez entrer un numéro valide (1-30)",
    	EMPTYFIELDOTHERS:"Veuillez entrer un numéro valide",
    	EMPTYRADIO:"Veuillez saisir une option pour pouvoir continuer",
    	INVALID:"Veuillez entrer un numéro valide (1-30)",
    	INVALIDOTHERS:"Veuillez entrer un numéro valide",
    	INVALIDSELECT:"Cannot postpone after next frequency",
    	MINUTESGRT:"Le rappel ne peut être décalé de plus de 30 minutes."
    };
    $scope.displayError = "";
    $scope.remindmelateroption = {remindmelatertype:0,remindmelatervalue:""};
    $scope.showDashboardList = true;
    $scope.showEventNoticeBoard = false;
    $scope.showTreatmentNoticeBoard = false;
    $scope.dashBoardDate = new Date(/*"January 8, 2016"*/);
    $scope.frenchMoment =  moment.localeData('fr');
    $scope.treatmentIntime = "0";
    $scope.medicineTakePlace = [$translate.instant('AVANT_LE_REPAS'),$translate.instant('PENDANT_LE_REPAS'),$translate.instant('APRES_LE_REPAS')];
    $scope.treatmentDosageList = [
        {listId: "1", listType:"tablet",  listName: $translate.instant('TREATMENTS_LIST_ITEM1')},
        {listId: "2", listType:"effervescent",  listName: $translate.instant('TREATMENTS_LIST_ITEM2')},
        {listId: "3", listType:"capsule", listName: $translate.instant('TREATMENTS_LIST_ITEM3')},
        {listId: "4", listType:"granules",  listName: $translate.instant('TREATMENTS_LIST_ITEM4')},
        {listId: "5", listType:"syrup",  listName: $translate.instant('TREATMENTS_LIST_ITEM5')},
        {listId: "6", listType:"oinment",  listName: $translate.instant('TREATMENTS_LIST_ITEM6')},
        {listId: "7", listType:"patch",  listName: $translate.instant('TREATMENTS_LIST_ITEM7')},
        {listId: "8", listType:"injection",  listName: $translate.instant('TREATMENTS_LIST_ITEM8')},
        {listId: "9", listType:"inhalation", listName: $translate.instant('TREATMENTS_LIST_ITEM9')},
        {listId: "10", listType:"suppository", listName: $translate.instant('TREATMENTS_LIST_ITEM10')},
        {listId: "11", listType:"bulb", listName: $translate.instant('TREATMENTS_LIST_ITEM11')},
        {listId: "12", listType:"drops", listName: $translate.instant('TREATMENTS_LIST_ITEM12')}
    ];

    $scope.treatmentitems = [];
	$scope.prescriptionfillitems = [];
	$scope.eventitems = [];
	$scope.migratedTreatmentitems = [];
	$scope.showConseil = true;

	$ionicPlatform.onHardwareBackButton(function(event){
		  if($rootScope.reminderPopup !== undefined){
		       $rootScope.reminderPopup.close();
		       $rootScope.showingDashboardRappelPopup = false;
		  }
		  if($rootScope.reminderEventPopup !== undefined){
		       $rootScope.reminderEventPopup.close();
		       $rootScope.showingDashboardRappelPopup = false;
		  }
		  if($rootScope.reminderPrescPopup !== undefined){
		       $rootScope.reminderPrescPopup.close();
		       $rootScope.showingDashboardRappelPopup = false;
		  }
		  if($scope.naviagteFromCurrentDate === true){
		  	   $scope.showPrevDay();
		  }
    });

	  

	$scope.updateDate = function(){
		if(localStorage.getItem('tipsToggle') !== undefined && (localStorage.getItem('tipsToggle') === false || localStorage.getItem('tipsToggle') === "false")){
			$scope.disableConseil = true;
			$scope.conseilStatus = "inactive";
		} else{
			$scope.disableConseil = false;
			$scope.conseilStatus = "active";
		}
		$scope.displayDate = $scope.dashBoardDate.getDate();
	    $scope.displayDay = $scope.frenchMoment._weekdays[$scope.dashBoardDate.getDay()].charAt(0).toUpperCase()+$scope.frenchMoment._weekdays[$scope.dashBoardDate.getDay()].slice(1);
	    $scope.displayMonth = $scope.frenchMoment._months[$scope.dashBoardDate.getMonth()].charAt(0).toUpperCase()+$scope.frenchMoment._months[$scope.dashBoardDate.getMonth()].slice(1);
	    $scope.displayYear = $scope.dashBoardDate.getFullYear();
	}

  	$scope.updateEventItemList = function(initialCall){
  		var filterData = appntService.selectAppointmentsOnDate($scope.dashBoardDate);
        var eventsLength = filterData.length;
        $scope.eventitems = [];
        var tempItem = [];
        if(eventsLength > 0){
        	for(var i=0;i<eventsLength;i++){
	        	var eventItem={};
	            var a=filterData[i];
	            var objAptDate=new Date(a.aptdate);
	            var aptTime=$filter('date')(objAptDate, "HH 'h' mm");
	            var momentFormat = moment(objAptDate);
	            var aptDateDisp = momentFormat.locale("fr").format("dddd Do MMMM YYYY");
	            var aptDate=$filter('date')(objAptDate, "EEEE dd MMMM yyyy");
	            var eventFlag = true;
          		var eventDeleted =  localStorage.getItem("DashBoardEventDeleted"+a.id);
          		if(eventDeleted !== undefined && (eventDeleted === true ||eventDeleted === "true")){
          			eventFlag = false;
          		}

	            eventItem["eventId"]= a.eventId;
	            eventItem["aptdate"]= a.aptdate;
	            eventItem["apttype"]=a.apttype;
                a.contactName = aesUtil.decrypt(salt, iv, passPhrase,a.contactName);
	            eventItem["aptContact"]=a.contactName;

	            eventItem["aptTime"]=aptTime;
	            eventItem["aptDate"]=aptDate;
	            eventItem["aptDateDisp"]=aptDateDisp;
	              
	            eventItem["contactName"]=a.contactName;
	            eventItem["description"]=a.description;
	            eventItem["descriptionCustom"]= a.description;

	            if(a.contactName !== null && a.contactName !== "null" && a.contactName !== ""){
	                eventItem["descriptionCustom"] += " avec ";
	            }
	            
	            eventItem["id"]=a.id;
	            eventItem["reminder0"]=a.reminder0;
	            eventItem["reminder1"]=a.reminder1;
	            eventItem["reminder7"]=a.reminder7;
	            eventItem["reminder8"]=a.reminder8;
	            if(eventFlag === true){
          			tempItem.push(eventItem);
          		}
	            
	        }
	        $scope.eventitems = tempItem;
	        if(initialCall !== undefined && initialCall !== null && initialCall === "FIRSTCALL")
	        	$rootScope.notificationCount += tempItem.length;
	        if($scope.eventitems.length > 0){
	        	$scope.showEventNoticeBoard = true;
        		$scope.showDashboardList = true;
	        } else {
	        	$scope.showEventNoticeBoard = false;
	        	if($scope.showTreatmentNoticeBoard === false && $scope.showEventNoticeBoard === false){
	  				$scope.showDashboardList = false;
	  			}
	        }
        	
        } else {
        	$scope.showEventNoticeBoard = false;
        	if($scope.showTreatmentNoticeBoard === false && $scope.showEventNoticeBoard === false){
  				$scope.showDashboardList = false;
  			}
        }
  	}


  	$scope.updateTreatmentItemList = function(initialCall){
  		var treatmentListLength = treatmentService.treatmentArray.length;
  		$scope.treatmentitems = treatmentService.treatmentArray;
  		if(treatmentListLength > 0){
  			var tempTreatmentList = [];
  			var prescriptionRefillList = [];
  			for(var i=0;i<$scope.treatmentitems.length;i++){
  				/* Logic for Treatment */
  				var frequencyType = $scope.treatmentitems[i].doseFrequencyUnit;
  				var trtObjTemp = $scope.treatmentitems[i];
		    	var treatmentStartDate = new Date(trtObjTemp.medicineStartDate);
		    	var currentDate = $scope.dashBoardDate;
		    	var resultDate = $scope.fn_DateCompare(treatmentStartDate,currentDate);
		    	var durationType = $scope.treatmentitems[i].durationType;
		    	var durationValue = null; var durationNo = null; var durationValueType = null;
		    	var noOfDurationDays = 0;
		    	var currentSetDate = new Date($scope.dashBoardDate);
		    	currentSetDate.setHours(0);
		        currentSetDate.setMinutes(0);
		        currentSetDate.setSeconds(0);
		        var boxEndDate = new Date($scope.treatmentitems[i].newBoxScheduledDate);
		    	boxEndDate.setHours(0);
		        boxEndDate.setMinutes(0);
		        boxEndDate.setSeconds(0);
		        //Get 1 day in milliseconds
   				var oneDay=1000*60*60*24;
   				var availableDays = Math.round((Date.parse(boxEndDate) - Date.parse(currentSetDate))/oneDay);
		    	var treatmentEndDate = new Date();
		    	if(durationType === 0 || durationType === "0"){
		    		durationValue = $scope.treatmentitems[i].durationValue.split(",");
		    		durationNo = parseInt(durationValue[0]);
		    		durationValueType = parseInt(durationValue[1]);
		    		switch(durationValueType){
		    			case 1: noOfDurationDays = durationNo;
		    					if(durationNo > 1){
		    						durationNo--;	
		    					}
		    					break;
		    			case 2: noOfDurationDays = durationNo * 7;
		    					noOfDurationDays--;
		    					break;
		    			case 3: noOfDurationDays = durationNo * 30;
		    					noOfDurationDays--;
		    					break;
		    		}
		    		treatmentEndDate = new Date(treatmentStartDate.getTime() + (noOfDurationDays * 24 * 60 * 60 * 1000));
		    	} else{
		    		treatmentEndDate = new Date(treatmentEndDate.getTime() + (730 * 24 * 60 * 60 * 1000));
		    	}
		    	var resultEndDate = $scope.fn_DateCompare(treatmentEndDate,currentDate);
  				switch(frequencyType) {
				    case 1:
				    	var objList = $scope.treatmentitems[i];
				    	if(resultDate <= 0 && resultEndDate>=0){
				    		var checkPostponed = $scope.dashBoardDate;
				    		checkPostponed.setHours(0);
					        checkPostponed.setMinutes(0);
					        checkPostponed.setSeconds(0);
				    		var checkFlag = false;
				    		var currDateSecs = Date.parse(checkPostponed);
					    	objList.dataPosition = tempTreatmentList.length;
					        //objList.dayRemaining = Math.floor((objList.boxCapacity - objList.doseTakenCount)/(objList.doseUnit * objList.doseFrequency));
					        objList.dayRemaining = availableDays;
					        if(objList.dayRemaining < 0){
					        	objList.dayRemaining = 0;
					        }
					        tempTreatmentList.push(objList);
					        prescriptionRefillList.push(objList);
				    	}
				        break;
				    case 2:
				    	var dayObjCount = $scope.dashBoardDate.getDay();
				    	var objList = $scope.treatmentitems[i];
				    	if(dayObjCount === 0)
				    		dayObjCount = 7;
				        if(dayObjCount === parseInt(objList.doseFrequencyUnitValue) && resultDate <= 0 &&  resultEndDate>=0){
				        	objList.dataPosition = tempTreatmentList.length;
				        	//objList.dayRemaining = Math.floor((objList.boxCapacity - objList.doseTakenCount)/(objList.doseUnit * objList.doseFrequency));
				        	objList.dayRemaining = availableDays;
				        	if(objList.dayRemaining < 0){
					        	objList.dayRemaining = 0;
					        }
				        	tempTreatmentList.push(objList);
				        	prescriptionRefillList.push(objList);
				        }
				        break;
				    case 3:
				    	var objList = $scope.treatmentitems[i];
				    	if($scope.dashBoardDate.getDate() === parseInt(objList.doseFrequencyUnitValue) && resultDate <= 0 &&  resultEndDate>=0){
				    		objList.dataPosition = tempTreatmentList.length;
				    		//objList.dayRemaining = Math.floor((objList.boxCapacity - objList.doseTakenCount)/(objList.doseUnit * objList.doseFrequency));
				    		objList.dayRemaining = availableDays;
				    		if(objList.dayRemaining < 0){
					        	objList.dayRemaining = 0;
					        }
				    		tempTreatmentList.push(objList);
				    		prescriptionRefillList.push(objList);
				    	}
				    	break;
				    case 4:
				    	var objList = $scope.treatmentitems[i];
				    	var arraySeqObj = $scope.treatmentitems[i].doseFrequencyUnitValue.split(",");
				    	var noOfDays = 0;
				    	if(parseInt(arraySeqObj[1]) === 1){
				    		noOfDays = parseInt(arraySeqObj[0]); 
				    	} else if(parseInt(arraySeqObj[1]) === 2){
				    		noOfDays = parseInt(arraySeqObj[0]) * 7;
				    	} else{
				    		noOfDays = parseInt(arraySeqObj[0]) * 30;
				    	}
				    	var daysinMilliSeconds = noOfDays * 24 * 60 * 60 * 1000;
				    	var approxDate = new Date(treatmentStartDate.getTime() + daysinMilliSeconds);
				    	var nextDateResult = null; 
                        var breakFlag = true;
                        var checkFlag = true;
                        var dayCounter = 0;
                        while(breakFlag){
                            approxDate = new Date(treatmentStartDate.getTime() + (daysinMilliSeconds * dayCounter));
                            nextDateResult = $scope.fn_DateCompare(approxDate,currentDate);
                            if(nextDateResult === 0 && resultDate <= 0 &&  resultEndDate>=0){
                                breakFlag = false;
                                checkFlag = false;
                                trtObjTemp.dataPosition = tempTreatmentList.length;
					    		//trtObjTemp.dayRemaining = Math.floor((trtObjTemp.boxCapacity - trtObjTemp.doseTakenCount)/(trtObjTemp.doseUnit * trtObjTemp.doseFrequency));
					    		trtObjTemp.dayRemaining = availableDays;
					    		if(trtObjTemp.dayRemaining < 0){
						        	trtObjTemp.dayRemaining = 0;
						        }
					    		tempTreatmentList.push(trtObjTemp);
					    		prescriptionRefillList.push(trtObjTemp);
                            }
                            if(nextDateResult === 1){
                                breakFlag = false;
                            }
                            dayCounter++;
                        }
				    	break;
				}
  			}
  			$scope.treatmentitems = tempTreatmentList;
  			if(initialCall !== undefined && initialCall !== null && initialCall === "FIRSTCALL")
  				$rootScope.notificationCount += tempTreatmentList.length;
  			$scope.prescriptionfillitems = prescriptionRefillList;
  			if($scope.treatmentitems.length > 0){
	  			$scope.showTreatmentNoticeBoard = true;
	  			$scope.showDashboardList = true;
  			} else{
  				$scope.showTreatmentNoticeBoard = false;
	  			if($scope.showTreatmentNoticeBoard === false && $scope.showEventNoticeBoard === false){
	  				$scope.showDashboardList = false
	  			}
  			}
  		} else {
  			$scope.showTreatmentNoticeBoard = false;
  			if($scope.showTreatmentNoticeBoard === false && $scope.showEventNoticeBoard === false){
  				$scope.showDashboardList = false
  			}
  		}
  	}

  	$scope.fetchEventList = function(initialCall) {
	    appntService.selectAllAppointments().then(function(result){
	    	appntService.eventsList = [];
            var eventsCount = result.rows.length;
          	if(eventsCount>0){
              	for(var i=0;i<eventsCount;i++){
              		result.rows.item(i).aptDate = result.rows.item(i).aptdate; 
              		appntService.eventsList.push(result.rows.item(i));
              	}
              	$scope.updateEventItemList(initialCall);
          	} else{
          		$scope.showEventNoticeBoard = false;
          		if($scope.showTreatmentNoticeBoard === false && $scope.showEventNoticeBoard === false){
	  				$scope.showDashboardList = false
	  			}
          	}
        },function(error){
	        console.log("Error reading Events Data : "+error);
	    });
  	};

  	$scope.fetchDashboardList = function(initialCall){
  		treatmentService.selectAllTreatmentMedicines().then(function(result){
  			treatmentService.treatmentArray = [];
  			var treatmentCount = result.rows.length;
  			if(treatmentCount>0){
              	for(var i=0;i<treatmentCount;i++){
              		var objList = result.rows.item(i);
                    objList.name = aesUtil.decrypt(salt, iv, passPhrase, objList.name);
                    objList.boiteNote = aesUtil.decrypt(salt, iv, passPhrase, objList.boiteNote);
              		var dosageItemNo = parseInt(result.rows.item(i).medicineType) - 1;
              		var medicineTakeType = parseInt(result.rows.item(i).medicineIntake) - 1;
              		var currentDate = $scope.dashBoardDate;
					currentDate.setHours(0);
			        currentDate.setMinutes(0);
			        currentDate.setSeconds(0);
			        var currDateSecs = Date.parse(currentDate);
              		if(objList.medicineIntake == null){
              			objList.medicineIntake = 1;
              		}
              		if(objList.doseTakenCount === null || objList.doseTakenCount === "null" || objList.doseTakenCount === "" || objList.doseTakenCount === undefined || objList.doseTakenCount === "undefined"){
                          	objList.doseTakenCount = 0;
                    }
              		objList.dataPosition = i;
              		objList.treatmentTypeName = (!isNaN(dosageItemNo))?$scope.treatmentDosageList[dosageItemNo].listName+"(s)":"";
              		objList.treatmentTypeIcon = (!isNaN(dosageItemNo))?$scope.treatmentDosageList[dosageItemNo].listType:"";
              		objList.medicineTakeName = (medicineTakeType !== undefined)?$scope.medicineTakePlace[medicineTakeType]:"";
              		var matinCurrStatus = null, midiCurrStatus = null, soirCurrStatus = null;
              		var matinCurrStatus1 = null, midiCurrStatus1 = null, soirCurrStatus1 = null;
              		var comparePresFill = new Date();
              		if($scope.naviagteFromCurrentDate === true){
              			comparePresFill = new Date(comparePresFill.getTime() + 86400000);
              		}
              		objList.showPrescriptionRefill = 1;
          			if($scope.naviagteFromCurrentDate === false && localStorage.getItem("PRESC_TREATID_POSTPONE"+objList.id) !== undefined && Date.parse(comparePresFill) >= Date.parse(localStorage.getItem("PRESC_TREATID_POSTPONE"+objList.id))){
          				objList.showPrescriptionRefill = 1;
          				localStorage.setItem("PRESC_TREATID_RENEWED"+objList.id, false);
          			}


              		if(localStorage.getItem("PRESC_TREATID_RENEWED"+objList.id) !== undefined && localStorage.getItem("PRESC_TREATID_RENEWED"+objList.id) === "true"){
              			objList.showPrescriptionRefill = 0;
              		} else{
              			objList.showPrescriptionRefill = 1;
              		}
              		if(localStorage.getItem("PRESC_TREATID_RENEWED"+objList.id) ==  null){
              			objList.showPrescriptionRefill = 1;	
              		}

              		if($scope.naviagteFromCurrentDate === true && localStorage.getItem("PRESC_TREATID_POSTPONE"+objList.id) !== undefined && Date.parse(comparePresFill) >= Date.parse(localStorage.getItem("PRESC_TREATID_POSTPONE"+objList.id))){
              			objList.showPrescriptionRefill = 1;
              		}	

              		
              		objList.reminderMatinShow = objList.reminderMatin;
              		if(objList.matinStatus != null){
              			var matinJsonObj = JSON.parse(objList.matinStatus);
              			if(matinJsonObj[currDateSecs] !== undefined && matinJsonObj[currDateSecs]["tablettaken"] !== undefined)
              				matinCurrStatus = $scope.fn_DateCompare($scope.dashBoardDate,matinJsonObj[currDateSecs]["tablettaken"]);

              			if(matinJsonObj[currDateSecs] !== undefined && matinJsonObj[currDateSecs]["newTime"] !== undefined &&  parseFloat(Date.parse(new Date())) < parseFloat(matinJsonObj[currDateSecs]["newTime"]))
		              		objList.reminderMatinShow = 0;

              			if(matinJsonObj[currDateSecs] !== undefined && matinJsonObj[currDateSecs]["deleted"] !== undefined && matinJsonObj[currDateSecs]["deleted"] === true){
              				objList.reminderMatinShow = 0;
              			}              			
              		} 
              		objList.reminderMidiShow = objList.reminderMidi;
              		if(objList.midiStatus != null){
              			var midiJsonObj = JSON.parse(objList.midiStatus);
              			if(midiJsonObj[currDateSecs] !== undefined && midiJsonObj[currDateSecs]["tablettaken"] !== undefined)
              				midiCurrStatus = $scope.fn_DateCompare($scope.dashBoardDate,midiJsonObj[currDateSecs]["tablettaken"]);

              			if(midiJsonObj[currDateSecs] !== undefined && midiJsonObj[currDateSecs]["newTime"] !== undefined &&  parseFloat(Date.parse(new Date())) < parseFloat(midiJsonObj[currDateSecs]["newTime"]))
		              		objList.reminderMidiShow = 0;

              			if(midiJsonObj[currDateSecs] !== undefined && midiJsonObj[currDateSecs]["deleted"] !== undefined &&  midiJsonObj[currDateSecs]["deleted"] === true)
              				objList.reminderMidiShow = 0;
              		}
              		objList.reminderSoirShow = objList.reminderSoir;
              		if(objList.soirStatus != null){
              			var soirJsonObj = JSON.parse(objList.soirStatus);
              			if(soirJsonObj[currDateSecs] !== undefined && soirJsonObj[currDateSecs]["tablettaken"] !== undefined)
              				soirCurrStatus = $scope.fn_DateCompare($scope.dashBoardDate,soirJsonObj[currDateSecs]["tablettaken"]);

              			if(soirJsonObj[currDateSecs] !== undefined && soirJsonObj[currDateSecs]["newTime"] !== undefined &&  parseFloat(Date.parse(new Date())) < parseFloat(soirJsonObj[currDateSecs]["newTime"]))
		              		objList.reminderSoirShow = 0;

              			if(soirJsonObj[currDateSecs] !== undefined && soirJsonObj[currDateSecs]["deleted"] !== undefined &&  soirJsonObj[currDateSecs]["deleted"] === true)
              				objList.reminderSoirShow = 0;
              		}
					
              		objList.trackTakenCount = objList.doseTakenCount;

              		var timeSlots = [];
                    var timeSlotLength = 0;
                    if(parseInt(objList.reminderMatin)===1){
                        timeSlots.push({index:timeSlotLength, id:parseInt(timeSlotLength)+1, customId:0, value: $translate.instant('MATIN'), meal:objList.medicineTakeName, type:"matin", showlist:objList.reminderMatinShow, treatmentStatus:(matinCurrStatus != null && matinCurrStatus === 0)?"inactive":"active"});
                        timeSlotLength += 1;
                      }

                      if(parseInt(objList.reminderMidi)===1){
                        timeSlots.push({index:timeSlotLength, id:parseInt(timeSlotLength)+1, customId:0, value: $translate.instant('MIDI'), meal:objList.medicineTakeName, type:"midi", showlist:objList.reminderMidiShow, treatmentStatus:(midiCurrStatus != null && midiCurrStatus === 0)?"inactive":"active"});
                        timeSlotLength += 1;
                      }

                      if(parseInt(objList.reminderSoir)===1){
                        timeSlots.push({index:timeSlotLength, id:parseInt(timeSlotLength)+1, customId:0, value: $translate.instant('SOIR'), meal:objList.medicineTakeName,type:"soir", showlist:objList.reminderSoirShow, treatmentStatus:(soirCurrStatus != null && soirCurrStatus === 0)?"inactive":"active"});
                        timeSlotLength += 1;
                      }

                      if(objList.reminderOther !== ""){
                          var slotListObj = JSON.parse(objList.reminderOther);
                          for(var iSlot in slotListObj){
                          	  var customListId = parseInt(iSlot)+1;
                          	  var customCurrStatus = null;
                          	  var customListShow = 1;
                          	  if(objList.otherStatus !== "" && objList.otherStatus != null){
                          	  	var otherJsonObj = JSON.parse(objList.otherStatus);
                          	  	if(otherJsonObj["OTHERID"+customListId] !== undefined && otherJsonObj["OTHERID"+customListId][currDateSecs] !== undefined && otherJsonObj["OTHERID"+customListId][currDateSecs]["tablettaken"] !== undefined)
		              				customCurrStatus = $scope.fn_DateCompare($scope.dashBoardDate,otherJsonObj["OTHERID"+customListId][currDateSecs]["tablettaken"]);

		              			if(otherJsonObj["OTHERID"+customListId] !== undefined && otherJsonObj["OTHERID"+customListId][currDateSecs] !== undefined && otherJsonObj["OTHERID"+customListId][currDateSecs]["newTime"] !== undefined){
		              				if(parseFloat(Date.parse(new Date())) < parseFloat(otherJsonObj["OTHERID"+customListId][currDateSecs]["newTime"]))
		              					customListShow = 0;
		              			}	

		              			if(otherJsonObj["OTHERID"+customListId] !== undefined && otherJsonObj["OTHERID"+customListId][currDateSecs] !== undefined && otherJsonObj["OTHERID"+customListId][currDateSecs]["deleted"] !== undefined &&  otherJsonObj["OTHERID"+customListId][currDateSecs]["deleted"] === true)
		              				customListShow = 0;
                          	  }
                              timeSlots.push({index:timeSlotLength, id:parseInt(timeSlotLength)+1, customId:parseInt(iSlot)+1, value: slotListObj[iSlot].value, meal:"",type:"other", showlist:customListShow, treatmentStatus:(customCurrStatus != null && customCurrStatus === 0)?"inactive":"active"});
                              timeSlotLength += 1; 
                          }
                      }

                      if(objList.medicineStartDate === null || objList.medicineStartDate === "null"){
                      		objList.medicineStartDate = objList.lastBoxOpenedDate;
                      }

                      if(objList.doseHour != null && objList.doseMinute != null) {
                          objList.durationType = 1;
                          var doseHourArray = objList.doseHour.split("!");
                          var doseMinuteArray = objList.doseMinute.split("!");
                          var countSlot = 0;
                          for(var iSlot in doseHourArray) {
                              if(!isNaN(doseHourArray[iSlot])) {
                              		var customListId = parseInt(countSlot)+1;
                              	    var customCurrStatus = null;
                          	  		var customListShow = 1;
	                          	  if(objList.otherStatus !== "" && objList.otherStatus != null){
	                          	  	var otherJsonObj = JSON.parse(objList.otherStatus);
	                          	  	if(otherJsonObj["OTHERID"+customListId] !== undefined && otherJsonObj["OTHERID"+customListId][currDateSecs] !== undefined && otherJsonObj["OTHERID"+customListId][currDateSecs]["tablettaken"] !== undefined)
			              				customCurrStatus = $scope.fn_DateCompare($scope.dashBoardDate,otherJsonObj["OTHERID"+customListId][currDateSecs]["tablettaken"]);

			              			if(otherJsonObj["OTHERID"+customListId] !== undefined && otherJsonObj["OTHERID"+customListId][currDateSecs] !== undefined && otherJsonObj["OTHERID"+customListId][currDateSecs]["newTime"] !== undefined){
			              				if(parseFloat(Date.parse(new Date())) < parseFloat(otherJsonObj["OTHERID"+customListId][currDateSecs]["newTime"]))
			              					customListShow = 0;
			              			}	

			              			if(otherJsonObj["OTHERID"+customListId] !== undefined && otherJsonObj["OTHERID"+customListId][currDateSecs] !== undefined && otherJsonObj["OTHERID"+customListId][currDateSecs]["deleted"] !== undefined &&  otherJsonObj["OTHERID"+customListId][currDateSecs]["deleted"] === true)
			              				customListShow = 0;
	                          	  }
                                  var timeSlotValue;
                                  timeSlotValue = ((doseHourArray[iSlot]) < 10) ? "0"+doseHourArray[iSlot]+ " h " : doseHourArray[iSlot]+ " h ";
                                  timeSlotValue += ((doseMinuteArray[iSlot]) < 10) ? "0"+doseMinuteArray[iSlot] : doseMinuteArray[iSlot];
                                  timeSlots.push({index:timeSlotLength, id:parseInt(timeSlotLength)+1, customId:customListId, value: timeSlotValue, meal:"",type:"other", showlist:customListShow, treatmentStatus:(customCurrStatus != null && customCurrStatus === 0)?"inactive":"active"});
                                  timeSlotLength += 1;
                                  countSlot += 1;
                              } 
                          }

                          var doseFrequenceUnit = objList.doseFrequencyUnit;
                          var lastBoxDate = new Date();
                          if(objList.lastBoxOpenedDate !== null){
                          	lastBoxDate = new Date(objList.lastBoxOpenedDate);
                          } 
                          objList.medicineStartDate = lastBoxDate;
                          if(objList.doseTakenCount === null || objList.doseTakenCount === "null" || objList.doseTakenCount === "" || objList.doseTakenCount === undefined || objList.doseTakenCount === "undefined"){
                          	objList.doseTakenCount = 0;
                          	objList.trackTakenCount = 0;
                          }
                          if(doseFrequenceUnit == 2) {
                            
                            objList.doseFrequencyUnit = 4;
                            objList.doseFrequencyUnitValue = "2,1";

                          } else if(doseFrequenceUnit == 3) {
                            
                            objList.doseFrequencyUnit = 2;
                            var treatmentDay = parseInt(lastBoxDate.getDay());
                            objList.doseFrequencyUnitValue = (treatmentDay == 0) ? 7 : treatmentDay;                            


                          } else if(doseFrequenceUnit == 4) {
                            
                            objList.doseFrequencyUnit = 3;
                            objList.doseFrequencyUnitValue = parseInt(lastBoxDate.getDate());;

                          }
                      }

                    objList.timeSlotsList = timeSlots;
              		treatmentService.treatmentArray.push(objList);
              	}
              	$scope.updateTreatmentItemList(initialCall);
              	
          	} else{
          		$scope.showTreatmentNoticeBoard = false;
          		if($scope.showTreatmentNoticeBoard === false && $scope.showEventNoticeBoard === false){
	  				$scope.showDashboardList = false
	  			}
          	}
  		} ,function(error){
	        console.log(error);
	    });
  	}
  	$scope.updateDate();
  	$scope.fetchDashboardList("FIRSTCALL");
  	$scope.fetchEventList("FIRSTCALL");

  	$scope.showNextDay = function(){
  		ADB.trackState($translate.instant('SEPA_DASHBOARD_NEXT_DAY'));
  		$scope.dashBoardDate = new Date($scope.dashBoardDate.getTime() + 86400000);//new Date("January 8, 2016");
  		$scope.naviagteFromCurrentDate = true;
  		$scope.updateDate()
  		$scope.fetchDashboardList();
  		$scope.updateEventItemList();
  		$rootScope.showingDashboardRappelPopup = true;
    	$scope.currentDateNav += 1;
    	document.getElementById('prevDayOption').style.visibility = "initial";
    	document.getElementById('nextDayOption').style.visibility = "hidden";
  	}

  	$scope.showPrevDay = function(){
		ADB.trackState($translate.instant('SEPA_DASHBOARD_PREV_DAY'));
  		$scope.dashBoardDate = new Date($scope.dashBoardDate.getTime() - 86400000);
  		$scope.naviagteFromCurrentDate = false;
  		$scope.updateDate();
  		$scope.fetchDashboardList();
  		$scope.updateEventItemList();
		$scope.currentDateNav -= 1;
		$rootScope.showingDashboardRappelPopup = false;
		document.getElementById('prevDayOption').style.visibility = "hidden";
		document.getElementById('nextDayOption').style.visibility = "initial";
  	}

  	$scope.openTreatmentPopup =function(objectData,reminderType, reminderValue, customId){
  		reminderType = reminderType.toLowerCase();
  		if($scope.naviagteFromCurrentDate === true){
  			return true;
  		}

  		var timeValue = "";
  		var remtype = 0;
  		if(reminderType === "matin"){
  			remtype = 1;
  			timeValue = (localStorage.getItem('matinTime') === undefined || localStorage.getItem('matinTime') === null)?"08h00":localStorage.getItem('matinTime');
  		} else if(reminderType === "midi"){
  			remtype = 2;
  			timeValue = (localStorage.getItem('midiTime') === undefined || localStorage.getItem('midiTime') === null)?"12h00":localStorage.getItem('midiTime');
  		} else if(reminderType === "soir"){
  			timeValue = (localStorage.getItem('soirTime') === undefined || localStorage.getItem('soirTime') === null)?"19h00":localStorage.getItem('soirTime');
  			remtype = 3;
  		} else{
  			timeValue = reminderValue;
  		}
  		
  		var timeValueObj = timeValue.split("h");
  		var treatmentTime = new Date();
  		treatmentTime.setHours(parseInt(timeValueObj[0]));
        treatmentTime.setMinutes(parseInt(timeValueObj[1]));
        treatmentTime.setSeconds(0);
        var nextSlotDate = new Date(treatmentTime.getTime() + (30 * 60 * 1000));
  		var currentDate = new Date();
  		var validCurrentDate = $scope.dashBoardDate;
  		validCurrentDate.setHours(0);
        validCurrentDate.setMinutes(0);
        validCurrentDate.setSeconds(0);

  		var currentDateTime = new Date();
  		currentDateTime.setHours(0);
        currentDateTime.setMinutes(0);
        currentDateTime.setSeconds(0);
  		
  		var currDateSecs = Date.parse(currentDateTime);
  		var popupShowStatus = null;
  		var tabletTaken = null;
  		if(objectData[reminderType+"Status"] != null && objectData[reminderType+"Status"] !== ""){
  			var jsonObj = JSON.parse(objectData[reminderType+"Status"]);
  			if(reminderType == "other"){
  				if(jsonObj["OTHERID"+customId] !== undefined){
  					if(jsonObj["OTHERID"+customId][currDateSecs] !== undefined && jsonObj["OTHERID"+customId][currDateSecs]["ignoredetails"] !== undefined){
		  				if(parseFloat(jsonObj["OTHERID"+customId][currDateSecs]["ignoredetails"]) > parseFloat(Date.parse(treatmentTime))){
		  					popupShowStatus = true;
		  				}
		  			}
		  			if(jsonObj["OTHERID"+customId][currDateSecs] !== undefined && jsonObj["OTHERID"+customId][currDateSecs]["tablettaken"] !== undefined){
		  				if($scope.fn_DateCompare(currentDateTime,jsonObj["OTHERID"+customId][currDateSecs]["tablettaken"]) === 0){
		  					tabletTaken = true;
		  				}	
	  				}	
  				}
  			} else{
  				if(jsonObj[currDateSecs] !== undefined && jsonObj[currDateSecs]["ignoredetails"] !== undefined){
  					if(parseFloat(jsonObj[currDateSecs]["ignoredetails"]) > parseFloat(Date.parse(treatmentTime))){
	  					popupShowStatus = true;
	  				}
	  			}
	  			if(jsonObj[currDateSecs] !== undefined && jsonObj[currDateSecs]["tablettaken"] !== undefined){
	  				if($scope.fn_DateCompare(currentDateTime,jsonObj[currDateSecs]["tablettaken"]) === 0){
	  					tabletTaken = true;
	  				}	
	  			}
  			}
  		}

  		$scope.checkTimeElapsed = false;
  		$scope.setTimeElapsed = "active";

  		if(Date.parse(new Date()) > Date.parse(treatmentTime)){
  			$scope.checkTimeElapsed = true;
  			$scope.setTimeElapsed = "inactive";
  		}
  		
  		if(tabletTaken != null && tabletTaken === true){
  			return true;
  		}

  		if(popupShowStatus != null && popupShowStatus === true) {
  			$scope.treatmentConfirmationPopUp(objectData, reminderType, reminderValue, customId);
  			return true;
  		}

  		$scope.popupmessage1 = $translate.instant('ADD_TREATMENTS_TAB_1') +' '+ objectData.name;
  		if(reminderType === "other"){
  			$scope.popupmessage2 = objectData.doseUnit + ' ' + objectData.treatmentTypeName + ' ' + $translate.instant('THE') + ' ' + reminderValue;
  		} else{
  			$scope.popupmessage2 = objectData.doseUnit + ' ' + objectData.treatmentTypeName + ' ' + $translate.instant('THE') + ' ' + reminderType + ' ' + $scope.medicineTakePlace[parseInt(objectData.medicineIntake)-1];
  		}
  		$scope.showpopupmessage2 = true;
  		$scope.icontype = objectData.treatmentTypeIcon+"active";
  		$scope.treatmentPopup = $ionicPopup.show({
            templateUrl:'templates/dashboardmessage.html',
            cssClass:'form-alert-popup',
            scope: $scope,
            animation: 'slide-in-up',
            buttons: [
	            { 
	                text: $translate.instant('TAKE'), 
	                type:'button-default first-button',
	                onTap: function(e) {
	                	//ADB.trackState($translate.instant('SEPA_DASHBOARD_PRENDRE'));
	                    $scope.treatmentPopup.close();
	                    $scope.takenMedicine(objectData,reminderType, reminderValue, customId);
	                }
	            },
	            { 
	                text: $translate.instant('LATER'), 
	                type:'button-default '+$scope.setTimeElapsed,
	                onTap: function(e) {
	                	//ADB.trackState($translate.instant('SEPA_DASHBOARD_RAPPELER'));
	                	if($scope.checkTimeElapsed === false){
	                		$scope.treatmentPopup.close();
	                		$rootScope.showingDashboardRappelPopup = true;
	                    	$scope.openReminderPopup(objectData, timeValue, reminderType, customId);	
	                	} else{
	                		e.preventDefault();
	                		console.log("Time Elapsed");
	                	}
	                }
	            },
	            { 
	            	text: $translate.instant('IGNORE'), 
	              	type:'button-default last-button',
	              	onTap: function(e) {
	              	//	ADB.trackState($translate.instant('SEPA_DASHBOARD_IGNORER'));
	              		if(Date.parse(currentDate) > Date.parse(treatmentTime)){
				  			var currentDateTime = new Date();
							currentDateTime.setHours(0);
					        currentDateTime.setMinutes(0);
					        currentDateTime.setSeconds(0);

							var reminderTypeObj = objectData[reminderType+"Status"];

							if(reminderTypeObj == null){
								reminderTypeObj = new Object();
							} else {
								reminderTypeObj = JSON.parse(reminderTypeObj);
							}
							if(reminderType === "other"){
								if(reminderTypeObj["OTHERID"+customId] == null){
									reminderTypeObj["OTHERID"+customId] = new Object();
								}
								
								if(reminderTypeObj["OTHERID"+customId][Date.parse(currentDateTime)] == null){
									reminderTypeObj["OTHERID"+customId][Date.parse(currentDateTime)] = new Object();
								}
								reminderTypeObj["OTHERID"+customId][Date.parse(currentDateTime)]["ignoredetails"] = Date.parse(new Date());	
							}else{
								if(reminderTypeObj[Date.parse(currentDateTime)] == null){
									reminderTypeObj[Date.parse(currentDateTime)] = new Object();
								}
								reminderTypeObj[Date.parse(currentDateTime)]["ignoredetails"] = Date.parse(new Date());;
							}
							
							$scope.treatmentPopup.close();
							treatmentService.updateDosageIgnoreDetails(reminderType, objectData.id, JSON.stringify(reminderTypeObj)).then(function(result){
								$scope.fetchDashboardList();
							},function(error){
						        console.log(error);
						    });
				  		}
	                }
	            }
	          ]
        });
  	}

  	$scope.treatmentConfirmationPopUp = function(treatmentObj, reminderType, reminderValue, customId) {
        var aptContentName = "<div class='treatment-popup-opt'><i class='icon ion-"+treatmentObj.treatmentTypeIcon+"active'></i> <strong>"+treatmentObj.name+"</strong></div>";
        var aptContent = '';

        if(reminderType === "matin")
        	aptContent+= '<div class="row event-popup padding-bottom"><div class="col">'+treatmentObj.doseUnit+' l '+$translate.instant('MATIN')+' l '+treatmentObj.medicineTakeName+'</div></div>';
        else if(reminderType === "midi")
        	aptContent+= '<div class="row event-popup padding-bottom"><div class="col">'+treatmentObj.doseUnit+' l '+$translate.instant('MIDI')+' l '+treatmentObj.medicineTakeName+'</div></div>';
        else if(reminderType === "soir")
        	aptContent+= '<div class="row event-popup padding-bottom"><div class="col">'+treatmentObj.doseUnit+' l '+$translate.instant('SOIR')+' l '+treatmentObj.medicineTakeName+'</div></div>';
        else if(reminderType === "other")
        	aptContent+= '<div class="row event-popup padding-bottom"><div class="col">'+treatmentObj.doseUnit+' l '+reminderValue+'</div></div>';
       
        var alertUserForAction = $ionicPopup.show({
                                          template: aptContent,
                                          cssClass:'form-alert-popup',
                                          title: aptContentName,
                                          scope: $scope,
                                          buttons: [
                                            { 
                                                text: $translate.instant('ANNULER'), 
                                                type:'button-default first-button',
                                                onTap: function(e) {
                                                	//ADB.trackState($translate.instant('SEPA_DASHBOARD_TREATMENT_ANNULER'));
                                                    alertUserForAction.close();
                                                }
                                            },
                                            { text: $translate.instant('MODIFY'),
                                              onTap: function(e) {
                                                    /* Perform Modify Option */
                                                   // ADB.trackState($translate.instant('SEPA_DASHBOARD_TREATMENT_MODIFIER'));
                                                   TreatmentSharedProperties.setTreatment(treatmentObj);
    	                                           $rootScope.menuBackButtonDisplay = true;
    	                                           $rootScope.treatmentCallIntiate = "DASHBOARD";
    	                                           $state.go('app.addtreatment');
                                                }
                                            },
                                            { text: $translate.instant('SUPPRIMER'), 
                                              type:'button-default last-button',
                                              onTap: function(e) {
                                              	//ADB.trackState($translate.instant('SEPA_DASHBOARD_TREATMENT_SUPPRIMER'));
										  			alertUserForAction.close();
										  			$scope.showTreatmentDeleteConfirmationPopup(treatmentObj, reminderType, reminderValue, customId);
                                                }}
                                          ]
                                        });
    }

    $scope.showTreatmentDeleteConfirmationPopup = function(treatmentObj, reminderType, reminderValue, customId) {
    	//ADB.trackState($translate.instant('SEPA_DASHBOARD_TREATMENT_DELETE_CONFIRMATION'));

        $scope.deleteTreatmentConfirmationPopup = $ionicPopup.show({
            cssClass: 'form-alert-popup',
            buttons: [{
                text: $translate.instant('ANNULER'),
                type: 'button-default first-button',
                onTap: function(e) {
                	//ADB.trackState($translate.instant('SEPA_DASHBOARD_TREATMENT_DELETE_CONFIRMATION_ANN'));
                    $scope.deleteTreatmentConfirmationPopup.close();
                }
            }, {
                text: $translate.instant('SUPPRIMER'),
                type: 'button-default last-button',
                onTap: function(e) {
                	//ADB.trackState($translate.instant('SEPA_DASHBOARD_TREATMENT_DELETE_CONFIRMATION_SUP'));
                	var currentDateTime = new Date();
					currentDateTime.setHours(0);
			        currentDateTime.setMinutes(0);
			        currentDateTime.setSeconds(0);

					var reminderTypeObj = treatmentObj[reminderType+"Status"];
					
					if(reminderTypeObj == null || reminderTypeObj === ""){
						reminderTypeObj = new Object();
					} else {
						reminderTypeObj = JSON.parse(reminderTypeObj);
					}

					if(reminderType === "other"){
						if(reminderTypeObj["OTHERID"+customId] == null){
							reminderTypeObj["OTHERID"+customId] = new Object();
						}

						if(reminderTypeObj["OTHERID"+customId][Date.parse(currentDateTime)] == null){
							reminderTypeObj["OTHERID"+customId][Date.parse(currentDateTime)] = new Object();
						}
						reminderTypeObj["OTHERID"+customId][Date.parse(currentDateTime)]["deleted"] = true;	
					} else{
						if(reminderTypeObj[Date.parse(currentDateTime)] == null){
							reminderTypeObj[Date.parse(currentDateTime)] = new Object();
						}
						reminderTypeObj[Date.parse(currentDateTime)]["deleted"] = true;	
					}
					$scope.deleteTreatmentConfirmationPopup.close();
					treatmentService.updateDosageIgnoreDetails(reminderType, treatmentObj.id, JSON.stringify(reminderTypeObj)).then(function(result){
						$scope.fetchDashboardList();
					},function(error){
				        console.log(error);
				    });
                }
            }],
            template: $translate.instant('DOC_QUES_DELETE_CONFIRMATION')
        });
    };

  	$scope.fn_DateCompare = function (DateA, DateB) {
	    var a = new Date(DateA);
	    a.setHours(0);
        a.setMinutes(0);
        a.setSeconds(0);
	    var b = new Date(DateB);
	    b.setHours(0);
        b.setMinutes(0);
        b.setSeconds(0);
	    var msDateA = Date.parse(a);//Date.UTC(a.getFullYear(), a.getMonth()+1, a.getDate());
	    var msDateB = Date.parse(b);//Date.UTC(b.getFullYear(), b.getMonth()+1, b.getDate());
	    if (parseFloat(msDateA) < parseFloat(msDateB))
	      return -1;  // lt
	    else if (parseFloat(msDateA) === parseFloat(msDateB))
	      return 0;  // eq
	    else if (parseFloat(msDateA) > parseFloat(msDateB))
	      return 1;  // gt
	    else
	      return null;  // error
	}

	$scope.takenMedicine = function(objectData,reminderType, reminderValue, customId){
		var takenCount = $scope.treatmentitems[objectData.dataPosition].trackTakenCount + objectData.doseUnit;
		
		var reminderTypeObj = objectData[reminderType+"Status"];
		if(reminderTypeObj == null){
			reminderTypeObj = new Object();
		} else {
			reminderTypeObj = JSON.parse(reminderTypeObj);
		}
		var currentDate = new Date();
		currentDate.setHours(0);
        currentDate.setMinutes(0);
        currentDate.setSeconds(0);

		if(reminderType === "other"){
			if(reminderTypeObj["OTHERID"+customId] == null){
				reminderTypeObj["OTHERID"+customId] = new Object();
			}
			
			if(reminderTypeObj["OTHERID"+customId][Date.parse(currentDate)] == null){
				reminderTypeObj["OTHERID"+customId][Date.parse(currentDate)] = new Object();
			}
			reminderTypeObj["OTHERID"+customId][Date.parse(currentDate)]["tablettaken"] = Date.parse(currentDate);	
		}else{
			if(reminderTypeObj[Date.parse(currentDate)] == null){
				reminderTypeObj[Date.parse(currentDate)] = new Object();
			}
			reminderTypeObj[Date.parse(currentDate)]["tablettaken"] = Date.parse(currentDate);
		}

		//return true;
		treatmentService.updateTabletTakenCount(reminderType, objectData.id, JSON.stringify(reminderTypeObj), takenCount).then(function(result){
			$scope.fetchDashboardList();
		},function(error){
	        console.log(error);
	    });
	}  	

  	$scope.openEventPopup =function(objectData){
  		if($scope.naviagteFromCurrentDate === true){
  			return true;
  		}

  		var eventTime = new Date(objectData.aptdate);
  		var currentDate = new Date();

  		if(Date.parse(currentDate) > Date.parse(eventTime)){
  			$scope.eventConfirmationPopUp(objectData);
  			return true;
  		}


  		$scope.popupmessage1 = objectData.descriptionCustom + ' ' + objectData.aptContact + ' à ' + objectData.aptTime;
  		$scope.showpopupmessage2 = false;
  		$scope.icontype = "eventactive";
  		$scope.eventPopup = $ionicPopup.show({
            templateUrl:'templates/dashboardmessage.html',
            cssClass:'form-alert-popup',
            scope: $scope,
            animation: 'slide-in-up',
            buttons: [
	            { 
	            	text: $translate.instant('IGNORE'), 
	              	type:'button-default first-button',
	              	onTap: function(e) {
	              		//ADB.trackState($translate.instant('SEPA_DASHBOARD_EVENT_IGNORER'));
	              		$scope.eventPopup.close();
	                }
	            },
	            { 
	                text: $translate.instant('LATER'), 
	                type:'button-default last-button',
	                onTap: function(e) {
	                	//ADB.trackState($translate.instant('SEPA_DASHBOARD_EVENT_RAPPELER'));
	                    $scope.eventPopup.close();
	                    $scope.openEventReminderPopup(objectData, 'EVENT');
	                    $rootScope.showingDashboardRappelPopup = true;
	                }
	            }
	          ]
        });
  	}

  	$scope.eventConfirmationPopUp = function(eventobject) {
        var aptContentName = eventobject.description+ ((eventobject.aptContact!=="" && eventobject.aptContact!=null)?" avec  <strong>"+eventobject.aptContact+"</strong>":"");
        var aptContent = '<div class="row event-popup padding-bottom">';
            aptContent+= '<div class="col col-20">'+eventobject.aptTime+'</div>';
            aptContent+= '<div class="col col-80">'+eventobject.aptDateDisp+'</div>';
            aptContent+= '</div>';
        var alertUserForAction = $ionicPopup.show({
                                          template: aptContent,
                                          cssClass:'form-alert-popup',
                                          title: aptContentName,
                                          scope: $scope,
                                          buttons: [
                                            { 
                                                text: 'Annuler', 
                                                type:'button-default first-button',
                                                onTap: function(e) {
                                                	//ADB.trackState($translate.instant('SEPA_DASHBOARD_EVENT_ANNULER'));
                                                    alertUserForAction.close();
                                                }
                                            },
                                            { text: 'Modifier',
                                              onTap: function(e) {
                                              	//ADB.trackState($translate.instant('SEPA_DASHBOARD_EVENT_MODIFIER'));
                                                    $scope.modifyEvent(eventobject);
                                                }
                                            },
                                            { text: 'Supprimer', 
                                              type:'button-default last-button',
                                              onTap: function(e) {
                                              	//ADB.trackState($translate.instant('SEPA_DASHBOARD_EVENT_SUPPRIMER'));
                                                    $scope.deleteConfirmation(eventobject);
                                                }}
                                          ]
                                        });
    }


	$scope.modifyEvent = function(eventobject){
		//ADB.trackState($translate.instant('SEPA_DASHBOARD_MODIFY_EVENT'));
	    EventSharedProperties.setEvent(eventobject);
	    $rootScope.menuBackButtonDisplay = true;
	    $state.go('app.addevent.fromDashboard');
	}

	$scope.deleteConfirmation = function(eventobject){
		//ADB.trackState($translate.instant('SEPA_DASHBOARD_EVENT_DELETE_CONFIRMATION'));
	    var deleteConfirm = $ionicPopup.confirm({
	        title: $translate.instant('LIST_DELETE_CONFIRM'),
	        template: $translate.instant('LIST_DELETE_CONFIRM_2'),
	        cssClass: "form-alert-popup sepa-confirmation-popup",
	        okText:$translate.instant('SUPPRIMER'),
	        okType:"custom-button button-default last-button",
	        cancelText:$translate.instant('ANNULER'),
	        cancelType:"custom-button button-default first-button"
	    });

	    deleteConfirm.then(function(response){
	        if(response){
	        	//ADB.trackState($translate.instant('SEPA_DASHBOARD_EVENT_DELETE_CONFIRMATION_SUP'));
	            localStorage.setItem("DashBoardEventDeleted"+eventobject.id,true);
	        	$scope.fetchEventList();

	        } else{
	        	//ADB.trackState($translate.instant('SEPA_DASHBOARD_EVENT_DELETE_CONFIRMATION_ANN'));
	            deleteConfirm.close();
	        }
	    });
	}
	
	$scope.getEventEndDate=function(startDateTime){
        return new Date(startDateTime.getTime()+(60*60*1000));
    }

	$scope.deleteEventInDevice=function(oldEventRec){
		var date = new Date(oldEventRec.aptDate+" "+oldEventRec.aptTime.replace(" h ",":"));
		var dateinfo={};
        dateinfo.date = date.getDate();
        dateinfo.month = date.getMonth();
        dateinfo.fullyear = date.getFullYear();
        dateinfo.hours = date.getHours();
        dateinfo.minutes = date.getMinutes();
        var oldEventData=oldEventRec;

        var startDateTime=new Date(dateinfo.fullyear, dateinfo.month, dateinfo.date, dateinfo.hours, dateinfo.minutes, 0, 0, 0);
        var endDateTime = $scope.getEventEndDate(startDateTime);
        var strAvec=oldEventRec.contactName!==""? "avec " +oldEventRec.contactName:"";
        
        var objOldEventJson={
	        title: oldEventData.description+ strAvec,//oldEventData.contactName,
	        location: null,
	        notes: oldEventData.description,
	        startDate: startDateTime,
	        endDate: endDateTime
        };

        $cordovaCalendar.deleteEvent(objOldEventJson).then(function (result) {
        },function(error){
            console.log("Event  not deleted in Device Calendar Error:"+error);
        });
	}

  	$scope.openPrescriptionPopup =function(objectData){
  		if($scope.naviagteFromCurrentDate === true){
  			return true;
  		}
  		// <h3><span class="energized-color">{{item.dayRemaining}} jours</span> avant le renouvellement de la boite {{item.name}}</h3>
  		$scope.eventPopup = $ionicPopup.show({
            template: '<span class="energized-color">'+objectData.dayRemaining+' jours</span> avant le renouvellement de la boite  '+objectData.name+'</span>',
            cssClass:'form-alert-popup',
            scope: $scope,
            animation: 'slide-in-up',
            buttons: [
	            { 
	                text: $translate.instant('REMIND_ME_LATER'), 
	                type:'button-default first-button',
	                onTap: function(e) {
	                	//ADB.trackState($translate.instant('SEPA_DASHBOARD_BOITE_REMINDLATER'));
	                    $scope.eventPopup.close();
	                    $scope.openPrescReminderPopup(objectData, 'PRESCRIPTION');
	                    $rootScope.showingDashboardRappelPopup = true;
	                }
	            },
	            { 
	            	text: $translate.instant('PRESCRIPTION_REFILL'), 
	              	type:'button-default last-button',
	              	onTap: function(e) {
	              		//ADB.trackState($translate.instant('SEPA_DASHBOARD_BOITE_RENOUVELEE'));
	              		$scope.eventPopup.close();
	              		localStorage.setItem("PRESC_TREATID_RENEWED"+objectData.id, true);
	                }
	            }
	          ]
        });
  	}

  	$scope.openPrescReminderPopup = function(objectData,callType){
  		$scope.dontShowOtherOptions = false;
  		$rootScope.reminderPrescPopup = $ionicPopup.show({
  			title: $translate.instant('REMIND_ME_IN'),
            templateUrl:'templates/remindmelater.html',
            cssClass:'form-alert-popup remindmelater-popup',
            scope: $scope,
            animation: 'slide-in-up',
            buttons: [
	            { 
	                text: $translate.instant('ANNULER'), 
	                type:'button-default first-button',
	                onTap: function(e) {
	                	//ADB.trackState($translate.instant('SEPA_DASHBOARD_PRESCRIPTION_REMIND_ANNULER'));
	                    $rootScope.reminderPrescPopup.close();
	                    $scope.remindmelateroption.remindmelatertype = 0;
	                    $scope.remindmelateroption.remindmelatervalue = "";
	                    $scope.remindmelaterErrorShow = false;
	                    $rootScope.showingDashboardRappelPopup = false;
	                    cordova.plugins.Keyboard.close();
	                }
	            },
	            { 
	            	text: $translate.instant('VALIDER'), 
	              	type:'button-default last-button',
	              	onTap: function(e) {
	              		//ADB.trackState($translate.instant('SEPA_DASHBOARD_PRESCRIPTION_REMIND_VALIDER'));
	              		if($scope.remindmelateroption.remindmelatertype === 0){
	              			$scope.remindmelaterErrorShow = true;
	              			$scope.displayError = $scope.remindLateErrorMsgs.EMPTYRADIO;
	              			e.preventDefault();
	              			return false;
	              		}
	              		if($scope.remindmelateroption.remindmelatervalue ===  ""){
	              			$scope.remindmelaterErrorShow = true;
	              			$scope.displayError = $scope.remindLateErrorMsgs.EMPTYFIELDOTHERS;
	              			e.preventDefault();
	              			return false;
	              		}
	              		if(isNaN($scope.remindmelateroption.remindmelatervalue) === true){
	              			$scope.remindmelaterErrorShow = true;
	              			$scope.displayError = $scope.remindLateErrorMsgs.INVALIDOTHERS;
	              			e.preventDefault();
	              			return false;
	              		}
	              		var currentSlot = new Date();
	              		var remindmelaterValue = $scope.remindmelateroption.remindmelatervalue; 
				    	var remindmelaterType = $scope.remindmelateroption.remindmelatertype;
				    	var requestSlotTemp = null; var requestSlot= null;
				        if(remindmelaterType === 1){
				            requestSlotTemp = remindmelaterValue * 60 * 1000; 
				        } else if(remindmelaterType === 2){
				            requestSlotTemp = remindmelaterValue * 60 * 60 * 1000;
				        } else if(remindmelaterType === 3){
				            requestSlotTemp = remindmelaterValue * 24 * 60 * 60 * 1000;
				        } else {
				            requestSlotTemp = remindmelaterValue * 7 * 24 * 60 * 60 * 1000;
				        }
				        requestSlot = new Date(currentSlot.getTime() +requestSlotTemp);
				        localStorage.setItem("PRESC_TREATID_POSTPONE"+objectData.id, requestSlot);
				        localStorage.setItem("PRESC_TREATID_RENEWED"+objectData.id, true);
				        var strMsg = objectData.dayRemaining+' jours avant le renouvellement de la boite '+objectData.name;
						//notificationutil.addSingleNotification(objectData.id, requestSlot, strMsg);
				        $scope.remindmelateroption.remindmelatertype = 0;
	                    $scope.remindmelateroption.remindmelatervalue = "";
	                    $scope.remindmelaterErrorShow = false;
	                    $rootScope.showingDashboardRappelPopup = false;
	                    cordova.plugins.Keyboard.close();
	                }
	            }
	          ]
        });
  	}

  	$scope.openEventReminderPopup = function(objectData,callType){
  		$scope.dontShowOtherOptions = false;
  		$rootScope.reminderEventPopup = $ionicPopup.show({
  			title: $translate.instant('REMIND_ME_IN'),
            templateUrl:'templates/remindmelater.html',
            cssClass:'form-alert-popup remindmelater-popup',
            scope: $scope,
            animation: 'slide-in-up',
            buttons: [
	            { 
	                text: $translate.instant('ANNULER'), 
	                type:'button-default first-button',
	                onTap: function(e) {
	                	//ADB.trackState($translate.instant('SEPA_DASHBOARD_EVENT_REMIND_ANNULER'));
	                    $rootScope.reminderEventPopup.close();
	                    $scope.remindmelateroption.remindmelatertype = 0;
	                    $scope.remindmelateroption.remindmelatervalue = "";
	                    $scope.remindmelaterErrorShow = false;
	                    $rootScope.showingDashboardRappelPopup = false;
	                    cordova.plugins.Keyboard.close();
	                }
	            },
	            { 
	            	text: $translate.instant('VALIDER'), 
	              	type:'button-default last-button',
	              	onTap: function(e) {
	              		//ADB.trackState($translate.instant('SEPA_DASHBOARD_EVENT_REMIND_VALIDER'));
	              		if($scope.remindmelateroption.remindmelatertype === 0){
	              			$scope.remindmelaterErrorShow = true;
	              			$scope.displayError = $scope.remindLateErrorMsgs.EMPTYRADIO;
	              			e.preventDefault();
	              			return false;
	              		}
	              		if($scope.remindmelateroption.remindmelatervalue ===  ""){
	              			$scope.remindmelaterErrorShow = true;
	              			$scope.displayError = $scope.remindLateErrorMsgs.EMPTYFIELDOTHERS;
	              			e.preventDefault();
	              			return false;
	              		}
	              		if(isNaN($scope.remindmelateroption.remindmelatervalue) === true){
	              			$scope.remindmelaterErrorShow = true;
	              			$scope.displayError = $scope.remindLateErrorMsgs.INVALIDOTHERS;
	              			e.preventDefault();
	              			return false;
	              		}
	              		var currentSlot = new Date(objectData.aptdate);
	              		var remindmelaterValue = $scope.remindmelateroption.remindmelatervalue; 
				    	var remindmelaterType = $scope.remindmelateroption.remindmelatertype;
				    	var requestSlotTemp = null; var requestSlot= null;
				        if(remindmelaterType === 1){
				            requestSlotTemp = remindmelaterValue * 60 * 1000; 
				        } else if(remindmelaterType === 2){
				            requestSlotTemp = remindmelaterValue * 60 * 60 * 1000;
				        } else if(remindmelaterType === 3){
				            requestSlotTemp = remindmelaterValue * 24 * 60 * 60 * 1000;
				        } else {
				            requestSlotTemp = remindmelaterValue * 7 * 24 * 60 * 60 * 1000;
				        }
				        requestSlot = new Date(currentSlot.getTime() +requestSlotTemp);
				        objectData.oldaptdate = objectData.aptdate;
				        objectData.aptdate = $filter('date')(new Date(requestSlot), "dd MMMM yyyy HH:mm");
				        $scope.updateEvent(objectData);
				        $scope.remindmelateroption.remindmelatertype = 0;
	                    $scope.remindmelateroption.remindmelatervalue = "";
	                    $scope.remindmelaterErrorShow = false;
	                    $rootScope.showingDashboardRappelPopup = false;
	                    $rootScope.reminderEventPopup.close();
	                    cordova.plugins.Keyboard.close();
	              		e.preventDefault();
	                }
	            }
	          ]
        });
  	}

  	$scope.getEvent=function(oldEventRec){

       $scope.dateinfo = {};
       var date = new Date(oldEventRec.aptdate);
                    $scope.dateinfo.date = date.getDate();
                    $scope.dateinfo.month = date.getMonth();
                    $scope.dateinfo.fullyear = date.getFullYear();
                    $scope.dateinfo.hours = date.getHours();
                    $scope.dateinfo.minutes = date.getMinutes();

            var startDateTime=new Date($scope.dateinfo.fullyear, $scope.dateinfo.month, $scope.dateinfo.date, $scope.dateinfo.hours, $scope.dateinfo.minutes, 0, 0, 0);
            var endDateTime = $scope.getEventEndDate(startDateTime);
            

            var strAvec=oldEventRec.contactName!==""? "avec " +oldEventRec.contactName:"";
            var objEventJson={
                title: oldEventRec.description+strAvec,
                location: null,//$scope.event.apttype,
                notes: oldEventRec.description,
                startDate: startDateTime,
                endDate: endDateTime,
                firstReminderMinutes: null,
                secondReminderMinutes: null,
                recurrence: null, // options are: 'daily', 'weekly', 'monthly', 'yearly'
                recurrenceInterval: 1, // only used when recurrence is set
                recurrenceEndDate: null,
                calendarName: null,
                calendarId: null,
                url: null
            };

            var slotTimeInMinutes = [10080, 1440, 120, 60];
            var reminderSlotPosition = [oldEventRec.reminder7, oldEventRec.reminder1, oldEventRec.reminder8, oldEventRec.reminder0];
            var selectedSlotTime = [];
            for(var rSlot in reminderSlotPosition){
                if(parseInt(reminderSlotPosition[rSlot]) === 1){
                    selectedSlotTime.push(slotTimeInMinutes[rSlot]);
                }
            }
            if(selectedSlotTime[0] !== undefined){
                objEventJson.firstReminderMinutes=selectedSlotTime[0];
            }
            if(selectedSlotTime[1] !== undefined){
                objEventJson.secondReminderMinutes=selectedSlotTime[1];
            }
            return objEventJson;
 }

  	$scope.updateEvent=function(oldEventRec){
            $scope.dateinfo = {};
            var date = new Date(oldEventRec.oldaptdate);
            $scope.dateinfo.date = date.getDate();
            $scope.dateinfo.month = date.getMonth();
            $scope.dateinfo.fullyear = date.getFullYear();
            $scope.dateinfo.hours = date.getHours();
            $scope.dateinfo.minutes = date.getMinutes();
            var oldEventData=oldEventRec;

            var startDateTime=new Date($scope.dateinfo.fullyear, $scope.dateinfo.month, $scope.dateinfo.date, $scope.dateinfo.hours, $scope.dateinfo.minutes, 0, 0, 0);
            var endDateTime = $scope.getEventEndDate(startDateTime);
        
            var objOldEventJson={
            title: oldEventData.description+ " avec " + oldEventData.contactName,//oldEventData.contactName,
            //location: oldEventData.apttype,
            notes: oldEventData.description,
            startDate:startDateTime, 
            endDate: endDateTime
            };
            $cordovaCalendar.deleteEvent(objOldEventJson).then(function (result) {
                     var objModifedEvent=$scope.getEvent(oldEventRec);
                      $cordovaCalendar.createEventWithOptions(objModifedEvent).then(function (result) {
                            appntService.updateEvent(oldEventRec).then(function(result){
                            	$scope.reminderEventPopup.close();
                            	$scope.fetchEventList();
                            },function(error){
                                    console.log("Error Inserting Event : "+error);
                                    $ionicPopup.alert({
                                        title: 'Error',
                                        template: 'Unable to update event'
                                    });
                            });
                            
                            }, function (err) {
                                console.error("There was an error: " + err);
                                $ionicPopup.alert({
                                    title: 'Error',
                                    template: 'Unable to add event'
                                });
                    });
                    
            }, function (err) {
                console.error("There was an error: " + err);
                $ionicPopup.alert({
                    title: 'Error',
                    template: 'Unable to update event'
                });
            });
                
        }

  	$scope.openReminderPopup = function(objectData,timeValue,reminderType, customId){
  		$scope.reminderTimeValue = timeValue;
  		$scope.dontShowOtherOptions = true;
  		$rootScope.reminderPopup = $ionicPopup.show({
  			title: $translate.instant('REMIND_ME_IN'),
            templateUrl:'templates/remindmelater.html',
            cssClass:'form-alert-popup remindmelater-popup treatment-reminder',
            scope: $scope,
            animation: 'slide-in-up',
            buttons: [
	            { 
	                text: $translate.instant('ANNULER'), 
	                type:'button-default first-button',
	                onTap: function(e) {
	                	//ADB.trackState($translate.instant('SEPA_DASHBOARD_TREATMENT_REMIND_ANNULER'));
	                    $rootScope.reminderPopup.close();
	                    $scope.remindmelateroption.remindmelatertype = 0;
	                    $scope.remindmelateroption.remindmelatervalue = "";
	                    $scope.remindmelaterErrorShow = false;
	                    $scope.showingTreatmentRappelPopup = false;
	                    cordova.plugins.Keyboard.close();
	                }
	            },
	            { 
	            	text: $translate.instant('VALIDER'), 
	              	type:'button-default last-button',
	              	onTap: function(e) {
	              		//ADB.trackState($translate.instant('SEPA_DASHBOARD_TREATMENT_REMIND_VALIDER'));
	              		if($scope.remindmelateroption.remindmelatertype === 0){
	              			$scope.remindmelaterErrorShow = true;
	              			$scope.displayError = $scope.remindLateErrorMsgs.EMPTYRADIO;
	              			e.preventDefault();
	              			return false;
	              		}
	              		if($scope.remindmelateroption.remindmelatervalue ===  ""){
	              			$scope.remindmelaterErrorShow = true;
	              			$scope.displayError = $scope.remindLateErrorMsgs.EMPTYFIELD;
	              			e.preventDefault();
	              			return false;
	              		}
	              		if(isNaN($scope.remindmelateroption.remindmelatervalue) === true){
	              			$scope.remindmelaterErrorShow = true;
	              			$scope.displayError = $scope.remindLateErrorMsgs.INVALID;
	              			e.preventDefault();
	              			return false;
	              		}
	              		if($scope.remindmelateroption.remindmelatervalue >  30){
	              			$scope.remindmelaterErrorShow = true;
	              			$scope.displayError = $scope.remindLateErrorMsgs.MINUTESGRT;
	              			e.preventDefault();
	              			return false;
	              		}
	              		var timeValueObj =  $scope.reminderTimeValue.split("h");
	              		var remindmelaterValue = $scope.remindmelateroption.remindmelatervalue; 
				        var currentSlotTime = new Date();
					        currentSlotTime.setHours(timeValueObj[0]);
					        currentSlotTime.setMinutes(timeValueObj[1]);
					        currentSlotTime.setSeconds(0);
					    var newSlotTime = new Date(currentSlotTime.getTime() + (remindmelaterValue * 60 * 1000));
					    var currentDate = new Date();
						currentDate.setHours(0);
				        currentDate.setMinutes(0);
				        currentDate.setSeconds(0);
						var reminderTypeObj = objectData[reminderType+"Status"];
						if(reminderTypeObj == null){
							reminderTypeObj = new Object();
						} else {
							reminderTypeObj = JSON.parse(reminderTypeObj);
						}
						if(reminderType === "other"){
							if(reminderTypeObj["OTHERID"+customId] == null){
								reminderTypeObj["OTHERID"+customId] = new Object();
							}
							
							if(reminderTypeObj["OTHERID"+customId][Date.parse(currentDate)] == null){
								reminderTypeObj["OTHERID"+customId][Date.parse(currentDate)] = new Object();
							}
							reminderTypeObj["OTHERID"+customId][Date.parse(currentDate)]["newTime"] = Date.parse(newSlotTime);	
						}else{
							if(reminderTypeObj[Date.parse(currentDate)] == null){
								reminderTypeObj[Date.parse(currentDate)] = new Object();
							}
							reminderTypeObj[Date.parse(currentDate)]["newTime"] = Date.parse(newSlotTime);
						}
						$rootScope.reminderPopup.close();
						treatmentService.updateDosageIgnoreDetails(reminderType, objectData.id, JSON.stringify(reminderTypeObj)).then(function(result){
							var strMsg = $translate.instant('ADD_TREATMENTS_TAB_1') +' '+ objectData.name + ' ';
							if(reminderType === "other"){
					  			strMsg += objectData.doseUnit + ' ' + objectData.treatmentTypeName + ' ' + $translate.instant('THE') + ' ' + timeValue;
					  		} else{
					  			strMsg += objectData.doseUnit + ' ' + objectData.treatmentTypeName + ' ' + $translate.instant('THE') + ' ' + reminderType + ' ' + $scope.medicineTakePlace[parseInt(objectData.medicineIntake)-1];
					  		}
					  		if(localStorage.getItem('medicineToggle') === null ||localStorage.getItem('medicineToggle') === undefined || localStorage.getItem('medicineToggle') === true || localStorage.getItem('medicineToggle') === "true"){
								notificationutil.addSingleNotification(objectData.id, newSlotTime, strMsg);
							}
							$scope.fetchDashboardList();
							$scope.remindmelateroption.remindmelatertype = 0;
                    		$scope.remindmelateroption.remindmelatervalue = "";
                    		$scope.remindmelaterErrorShow = false;
                    		$scope.showingTreatmentRappelPopup = false;
                    		cordova.plugins.Keyboard.close();
						},function(error){
					        console.log(error);
					    });
	              		e.preventDefault();
	                }
	            }
	          ]
        });
  	}

  	$scope.loadTipOfTheWeek = function(){
  		
  		if($scope.naviagteFromCurrentDate === true){
  			return true;
  		}
  		ADB.trackState($translate.instant('SEPA_TIP_OF_THE_WEEK'),null);
  		$rootScope.menuBackButtonDisplay = true;
  		$state.go('app.tipoftheweek');
  	}

  	$scope.openKeyboardForced = function(){
        if(ionic.Platform.isAndroid()){
            cordova.plugins.Keyboard.show();
        }
    }
    
    var currentDate = new Date();
        var getWeekDay = currentDate.getDay();
        var weektiplastaccess = null;
        var lastAccessResult = null;

        $scope.fn_DateCompare = function (DateA, DateB) {
           var a = new Date(DateA);
           var b = new Date(DateB);
           
           var msDateA = Date.UTC(a.getFullYear(), a.getMonth()+1, a.getDate());
           var msDateB = Date.UTC(b.getFullYear(), b.getMonth()+1, b.getDate());

           var timeDiff = Math.abs(a.getTime() - b.getTime());
           var diffDays = Math.ceil(timeDiff / (1000 * 3600 * 24)); 
           
           if (parseFloat(msDateA) < parseFloat(msDateB))
             return -1;  // lt
           else if (parseFloat(msDateA) == parseFloat(msDateB))
             return 0;  // eq
           else if (diffDays > 7)
             return 7;  // gt
           else if(parseFloat(msDateA) > parseFloat(msDateB))
             return 1;
           else 
             return null;  // error
     	}

      $scope.getMonday = function (d) {
        d = new Date(d);
        var day = d.getDay(),
        diff = d.getDate() - day + (day == 0 ? -6:1); // adjust when day is sunday
        return new Date(d.setDate(diff));
      }

      $scope.loadTips = function () {
          if(localStorage.tipAccessed != undefined){
  	       weektiplastaccess = new Date(localStorage.tipAccessed); 
           lastAccessResult  = $scope.fn_DateCompare(currentDate,weektiplastaccess);
      } else{
           lastAccessResult = -1;
      }

      UTIL_SERVICE.jsonFileReader("languages/locale-en_US.json").then(function(result){
              var weeklytip = result.data.weeklytipslist;
              var jsonWeeklyTipCount = Object.keys(weeklytip).length;
              localStorage.setItem("totalTipCount", jsonWeeklyTipCount);
       },
       function(error) {
          console.log("Error reading JSON Data :"+error);
       });

      if(getWeekDay == 1 && lastAccessResult != 0) {
      	    
            localStorage.setItem("tipAccessed", currentDate);
            var tipNo;
            if(localStorage.tipOfWeekCount == undefined || localStorage.tipOfWeekCount >= localStorage.totalTipCount){
            	tipNo = 1;
            } else {
            	tipNo = parseInt(localStorage.tipOfWeekCount) + 1;
           	}
           	localStorage.setItem("tipOfWeekCount", tipNo);
           	$scope.weektip = $translate.instant('weeklytipslist.WEEKLY_TIP_'+tipNo);
     		    $state.go('app.tipoftheweek');
           
           
      } else if(lastAccessResult == 7) {
            var newTipNo;
            if(localStorage.tipOfWeekCount == undefined || localStorage.tipOfWeekCount >= localStorage.totalTipCount) {
              newTipNo = 1;
            } else {
              newTipNo = parseInt(localStorage.tipOfWeekCount) + 1;
            }
            
            $scope.weektip = $translate.instant('weeklytipslist.WEEKLY_TIP_'+newTipNo);
            localStorage.setItem("tipOfWeekCount", newTipNo);
            var accessedDate = $scope.getMonday(new Date());
            localStorage.setItem("tipAccessed", accessedDate);
            $state.go('app.tipoftheweek');

      } else if(localStorage.tipOfWeekCount == undefined) {
        
            localStorage.setItem("tipOfWeekCount", 1);
            $scope.weektip = $translate.instant('weeklytipslist.WEEKLY_TIP_'+localStorage.tipOfWeekCount);
            var accessedDate = $scope.getMonday(new Date());
            localStorage.setItem("tipAccessed", accessedDate);
            $state.go('app.tipoftheweek');
        
      } else {

            $scope.weektip = $translate.instant('weeklytipslist.WEEKLY_TIP_'+localStorage.tipOfWeekCount);
            $state.go('app.tipoftheweek');

      }

      $rootScope.firstLaunchHome = false;
            		$rootScope.menuBackButtonDisplay = true;

      }
      
      //$rootScope.menuBackButtonDisplay = false;


});