
app.controller('mytreatmentscontroller', function($scope, $rootScope, $state, $translate, $ionicPopup, TreatmentSharedProperties, DB,treatmentService,notificationutil, TreatmentSharedList) {

  //ADB.trackState($translate.instant('SEPA_MY_TREATMENTS'));
	$editMode = false;

  $scope.treatmentDosageList = [
        {listId: "1", listType:"tablet",  listName: $translate.instant('TREATMENTS_LIST_ITEM1')},
        {listId: "2", listType:"effervescent",  listName: $translate.instant('TREATMENTS_LIST_ITEM2')},
        {listId: "3", listType:"capsule", listName: $translate.instant('TREATMENTS_LIST_ITEM3')},
        {listId: "4", listType:"granules",  listName: $translate.instant('TREATMENTS_LIST_ITEM4')},
        {listId: "5", listType:"syrup",  listName: $translate.instant('TREATMENTS_LIST_ITEM5')},
        {listId: "6", listType:"oinment",  listName: $translate.instant('TREATMENTS_LIST_ITEM6')},
        {listId: "7", listType:"patch",  listName: $translate.instant('TREATMENTS_LIST_ITEM7')},
        {listId: "8", listType:"injection",  listName: $translate.instant('TREATMENTS_LIST_ITEM8')},
        {listId: "9", listType:"inhalation", listName: $translate.instant('TREATMENTS_LIST_ITEM9')},
        {listId: "10", listType:"suppository", listName: $translate.instant('TREATMENTS_LIST_ITEM10')},
        {listId: "11", listType:"bulb", listName: $translate.instant('TREATMENTS_LIST_ITEM11')},
        {listId: "12", listType:"drops", listName: $translate.instant('TREATMENTS_LIST_ITEM12')}
    ];

 $scope.init = function(){ 
      TreatmentSharedList.init();
  }
  $scope.alertUser = function(treatmentObj, callType) {
    ADB.trackState($translate.instant('SEPA_MY_TREATMENTS_MEDICATION_ENTRY_CLICKED'));
        var aptContentName = "<strong>"+treatmentObj.name+"</strong>";
        var aptContent = '';
        var slotNum = "small"
        if(treatmentObj.timeSlotsList != undefined && treatmentObj.timeSlotsList.length > 0){
            if(treatmentObj.timeSlotsList.length > 3 && treatmentObj.timeSlotsList.length <= 6){
                slotNum = "medium";
            } else if(treatmentObj.timeSlotsList.length > 6 && treatmentObj.timeSlotsList.length <= 9){
                slotNum = "large";
            } else{
                slotNum = "small";
            } 
            for(var jSlot in treatmentObj.timeSlotsList){
                aptContent+= '<div class="row event-popup padding-bottom"><div class="col">'+treatmentObj.doseUnit+' l '+treatmentObj.timeSlotsList[jSlot].value;
                if(treatmentObj.timeSlotsList[jSlot].meal != "")
                  aptContent+= ' l '+treatmentObj.timeSlotsList[jSlot].meal;
                aptContent += '</div></div>';
            }
        }
            /*if(treatmentObj.reminderMatin === 1 || treatmentObj.reminderMatin === "1")
            aptContent+= '<div class="row event-popup padding-bottom"><div class="col">'+treatmentObj.doseUnit+' l '+treatmentObj.reminderMatinTxt+' l '+treatmentObj.medicineIntakeTxt+'</div></div>';
            if(treatmentObj.reminderMidi === 1 || treatmentObj.reminderMidi === "1")
            aptContent+= '<div class="row event-popup padding-bottom"><div class="col">'+treatmentObj.doseUnit+' l '+treatmentObj.reminderMidiTxt+' l '+treatmentObj.medicineIntakeTxt+'</div></div>';
            if(treatmentObj.reminderSoir === 1 || treatmentObj.reminderSoir === "1")
            aptContent+= '<div class="row event-popup padding-bottom"><div class="col">'+treatmentObj.doseUnit+' l '+treatmentObj.reminderSoirTxt+' l '+treatmentObj.medicineIntakeTxt+'</div></div>';*/
        var alertUserForAction = $ionicPopup.show({
                                          template: aptContent,
                                          cssClass:'form-alert-popup treatment-popup-'+slotNum,
                                          title: aptContentName,
                                          scope: $scope,
                                          buttons: [
                                            { 
                                                text: $translate.instant('ANNULER'), 
                                                type:'button-default first-button',
                                                onTap: function(e) {
                                                  //ADB.trackState($translate.instant('SEPA_MY_TREATMENTS_MEDICATION_ENTRY_ANNULER_CLICKED'));
                                                   if(treatmentObj.type === "0" || treatmentObj.type === 0){
                                                      ADB.trackState($translate.instant('SEPA_MY_TREATMENTS_LONG_TERM_TREATMENTS_TAB'));
                                                  } else{
                                                       ADB.trackState($translate.instant('SEPA_MY_TREATMENTS_SECOND_TAB'));
                                                  }
                                                    alertUserForAction.close();
                                                }
                                            },
                                            { text: $translate.instant('MODIFY'),
                                              onTap: function(e) {
                                                    /* Perform Modify Option */
                                                  // ADB.trackState($translate.instant('SEPA_MY_TREATMENTS_MEDICATION_ENTRY_MODIFIER_CLICKED'));
                                                   $rootScope.treatmentCallIntiate = callType;
                                                   TreatmentSharedProperties.setTreatment(treatmentObj);
    	                                             $state.go('app.addtreatment');
                                                }
                                            },
                                            { text: $translate.instant('SUPPRIMER'), 
                                              type:'button-default last-button',
                                              onTap: function(e) {
                                                //ADB.trackState($translate.instant('SEPA_MY_TREATMENTS_MEDICATION_ENTRY_SUPPRIMER_CLICKED'));
                                                    $scope.deleteConfirmation(treatmentObj);
                                                }}
                                          ]
                                        });
    }

    $scope.deleteConfirmation = function(treatmentObj){
      ADB.trackState($translate.instant('SEPA_MY_TREATMENTS_MEDICATION_ENTRY_DELETE_CONFIRMATION'));
	    var deleteConfirm = $ionicPopup.confirm({
	        title: $translate.instant('LIST_DELETE_CONFIRM'),
	        template: $translate.instant('LIST_DELETE_CONFIRM_2'),
	        cssClass: "form-alert-popup sepa-confirmation-popup",
	        okText:$translate.instant('SUPPRIMER'),
	        okType:"custom-button button-default last-button",
	        cancelText:$translate.instant('ANNULER'),
	        cancelType:"custom-button button-default first-button"
	    });

	    deleteConfirm.then(function(response){
	        if(response){
	            /* Perform Delete */
              //ADB.trackState($translate.instant('SEPA_MY_TREATMENTS_MEDICATION_ENTRY_DELETE_CONFIRMATION_SUP'));
              if(treatmentObj.type === "0" || treatmentObj.type === 0){
                                                      ADB.trackState($translate.instant('SEPA_MY_TREATMENTS_LONG_TERM_TREATMENTS_TAB'));
                                                  } else{
                                                       ADB.trackState($translate.instant('SEPA_MY_TREATMENTS_SECOND_TAB'));
                                                  }
                treatmentService.deleteTreatmentMedicine(treatmentObj).then(function(result){
                    TreatmentSharedList.init();
                    notificationutil.deleteNotification(treatmentObj);
                },function(error){
                    console.log("Error Updating Treatment Data"+error);
                });
	        } else{
            if(treatmentObj.type === "0" || treatmentObj.type === 0){
                                                      ADB.trackState($translate.instant('SEPA_MY_TREATMENTS_LONG_TERM_TREATMENTS_TAB'));
                                                  } else{
                                                       ADB.trackState($translate.instant('SEPA_MY_TREATMENTS_SECOND_TAB'));
                                                  }
	            deleteConfirm.close();
	        }
	    });
	}
	
	$scope.navigateToAddTreatment = function(callType){
      TreatmentSharedProperties.resetTreatment();
      $rootScope.treatmentCallIntiate = callType;
    	$state.go('app.addtreatment');
    }

  $scope.showLongTermList = true; 
  $scope.longTermItems = TreatmentSharedList.longTermItems;
  $scope.$on('updateListData', function(event, data) {
      $scope.updateListData();
  });

  $scope.showSymptomList = true; 
  $scope.symptomItems = TreatmentSharedList.symptomItems;
  
  $scope.updateListData = function() {
      $scope.symptomItems = TreatmentSharedList.symptomItems;
      if($scope.symptomItems.length === 0){
          $scope.showSymptomList = false; 
      }

      $scope.longTermItems = TreatmentSharedList.longTermItems;
      if($scope.longTermItems.length === 0){
          $scope.showLongTermList = false; 
      }
  }

}).service('TreatmentSharedList', function (treatmentService, $translate, $rootScope) {
    var longTermTreatmentType=0, symptomTreatmentType=1;
    var treatmentTimingList=[$translate.instant('MATIN'),$translate.instant('MIDI'),$translate.instant('SOIR')];
    var treatmentFoodTimingList=[$translate.instant('AVANT_LE_REPAS'),$translate.instant('PENDANT_LE_REPAS'),$translate.instant('APRES_LE_REPAS')];
 
    var treatmentDosageList = [
        {listId: "1", listType:"tablet",  listName: $translate.instant('TREATMENTS_LIST_ITEM1')},
        {listId: "2", listType:"effervescent",  listName: $translate.instant('TREATMENTS_LIST_ITEM2')},
        {listId: "3", listType:"capsule", listName: $translate.instant('TREATMENTS_LIST_ITEM3')},
        {listId: "4", listType:"granules",  listName: $translate.instant('TREATMENTS_LIST_ITEM4')},
        {listId: "5", listType:"syrup",  listName: $translate.instant('TREATMENTS_LIST_ITEM5')},
        {listId: "6", listType:"oinment",  listName: $translate.instant('TREATMENTS_LIST_ITEM6')},
        {listId: "7", listType:"patch",  listName: $translate.instant('TREATMENTS_LIST_ITEM7')},
        {listId: "8", listType:"injection",  listName: $translate.instant('TREATMENTS_LIST_ITEM8')},
        {listId: "9", listType:"inhalation", listName: $translate.instant('TREATMENTS_LIST_ITEM9')},
        {listId: "10", listType:"suppository", listName: $translate.instant('TREATMENTS_LIST_ITEM10')},
        {listId: "11", listType:"bulb", listName: $translate.instant('TREATMENTS_LIST_ITEM11')},
        {listId: "12", listType:"drops", listName: $translate.instant('TREATMENTS_LIST_ITEM12')}
    ];
    var self = this;
 
    self.init = function(){
         self.longTermItems=[];
          self.symptomItems=[];
            treatmentService.treatmentArray = [];
            treatmentService.selectAllTreatmentMedicines().then(function (result) {
              var treatmentsCount = result.rows.length;
              if(treatmentsCount>0){
                  for(var i=0;i<treatmentsCount;i++){

                      var tempItem=result.rows.item(i);
                      tempItem.name = aesUtil.decrypt(salt, iv, passPhrase, tempItem.name);
                      tempItem.boiteNote = aesUtil.decrypt(salt, iv, passPhrase, tempItem.boiteNote);
                      var dosageItemNo = parseInt(result.rows.item(i).medicineType) - 1;
                      var timeSlots = [];
                      var timeSlotLength = 0;

                      var tempTreatFoodTiming="";
                      tempItem.treatmentTypeName = (!isNaN(dosageItemNo))?treatmentDosageList[dosageItemNo].listName:"";
                      tempItem.treatmentTypeIcon = (!isNaN(dosageItemNo))?treatmentDosageList[dosageItemNo].listType:"";
                      
                      if(tempItem.medicineIntake == null){
                          tempItem.medicineIntake = 0; 
                      }

                      if(tempItem.doseTakenCount === null || tempItem.doseTakenCount === "null" || tempItem.doseTakenCount === "" || tempItem.doseTakenCount === undefined || tempItem.doseTakenCount === "undefined"){
                        tempItem.doseTakenCount = 0;
                        tempItem.trackTakenCount = 0;
                      }

                      if(tempItem.reminderMatin===1){
                        tempItem["reminderMatinTxt"]=treatmentTimingList[0];
                        timeSlots.push({index:timeSlotLength, id:parseInt(timeSlotLength)+1, value: treatmentTimingList[0], meal:treatmentFoodTimingList[parseInt(tempItem.medicineIntake)-1]});
                        timeSlotLength += 1;
                      }

                      if(tempItem.reminderMidi===1){
                        tempItem["reminderMidiTxt"]=treatmentTimingList[1];
                        timeSlots.push({index:timeSlotLength, id:parseInt(timeSlotLength)+1, value: treatmentTimingList[1], meal:treatmentFoodTimingList[parseInt(tempItem.medicineIntake)-1]});
                        timeSlotLength += 1;
                      }

                      if(tempItem.reminderSoir===1){
                        tempItem["reminderSoirTxt"]=treatmentTimingList[2];
                        timeSlots.push({index:timeSlotLength, id:parseInt(timeSlotLength)+1, value: treatmentTimingList[2], meal:treatmentFoodTimingList[parseInt(tempItem.medicineIntake)-1]});
                        timeSlotLength += 1;
                      }

                      if(tempItem.reminderOther != "" && tempItem.reminderOther !== null){
                          var slotListObj = JSON.parse(tempItem.reminderOther);
                          for(var iSlot in slotListObj){
                              timeSlots.push({index:timeSlotLength, id:parseInt(timeSlotLength)+1, value: slotListObj[iSlot].value, meal:""});
                              timeSlotLength += 1; 
                          }
                      }

                      if(tempItem.doseHour != null && tempItem.doseMinute != null) {
                          tempItem.durationType = 1;
                          var doseHourArray = tempItem.doseHour.split("!");
                          var doseMinuteArray = tempItem.doseMinute.split("!");

                          for(var iSlot in doseHourArray) {
                              if(!isNaN(doseHourArray[iSlot])) {
                                  var timeSlotValue;
                                  timeSlotValue = ((doseHourArray[iSlot]) < 10) ? "0"+doseHourArray[iSlot]+ " h " : doseHourArray[iSlot]+ " h ";
                                  timeSlotValue += ((doseMinuteArray[iSlot]) < 10) ? "0"+doseMinuteArray[iSlot] : doseMinuteArray[iSlot];    
                                  timeSlots.push({index:timeSlotLength, id:parseInt(timeSlotLength)+1, value: timeSlotValue, meal:""});
                                  timeSlotLength += 1;
                              } 
                          }

                          var doseFrequenceUnit = tempItem.doseFrequencyUnit;
                          var lastBoxDate = new Date(tempItem.lastBoxOpenedDate);
                          
                          if(doseFrequenceUnit == 2) {
                            
                            tempItem.doseFrequencyUnit = 4;
                            tempItem.doseFrequencyUnitValue = "2,1";

                          } else if(doseFrequenceUnit == 3) {
                            
                            tempItem.doseFrequencyUnit = 2;
                            var treatmentDay = parseInt(lastBoxDate.getDay());
                            tempItem.doseFrequencyUnitValue = (treatmentDay == 0) ? 7 : treatmentDay;                            


                          } else if(doseFrequenceUnit == 4) {
                            
                            tempItem.doseFrequencyUnit = 3;
                            tempItem.doseFrequencyUnitValue = parseInt(lastBoxDate.getDate());;

                          }

                          if(tempItem.fileName === null || tempItem.fileName === "null"){
                              tempItem.fileName = "./img/Camera@3x.png";
                          }
                      }

                      tempItem.timeSlotsList = timeSlots;

                      treatmentService.treatmentArray.push(tempItem);
                      if(tempItem.type === longTermTreatmentType) {
                        self.longTermItems.push(tempItem);
                      }else{
                        self.symptomItems.push(tempItem);
                      }
                  //self.longTermItems = treatmentService.getTreatmentMedicine(longTermTreatmentType);
                  //self.symptomItems = treatmentService.getTreatmentMedicine(symptomTreatmentType);
                }
              }else{// no treatment records
                treatmentService.treatmentArray = [];
                self.longTermItems = [];
                self.symptomItems = [];
              }

            $rootScope.$broadcast('updateListData', {
                data: 'something'
            });
        },function(error){
          console.log("TreatmentSharedList error:"+error);
            treatmentService.treatmentArray = [];
            self.longTermItems = [];
            self.symptomItems = [];
        });
    }
}).controller('mytreatmentslongtermcontroller', function($scope, $state, $translate, DB,treatmentService,TreatmentSharedList) {
    ADB.trackState($translate.instant('SEPA_MY_TREATMENTS_LONG_TERM_TREATMENTS_TAB'));
    
}).controller('mytreatmentssymptomscontroller', function($scope, $state, $translate, DB,treatmentService,TreatmentSharedList) {
   ADB.trackState($translate.instant('SEPA_MY_TREATMENTS_SECOND_TAB'));
});