
app.controller('pictogramcontroller', function($scope,$rootScope, $ionicPopup,$ionicPlatform, $state, $translate, $ionicSlideBoxDelegate, DB) {
//ADB.trackState($translate.instant('SEPA_PICTOGRAM_LAUNCH_SCREEN'));

    $scope.showButtonSection = false;
    $scope.disableSwipe = function() {
	   $ionicSlideBoxDelegate.enableSlide(false);
	};

	 $scope.getPICTOCompletedText = function() {
        return $translate.instant('PICTO_COMPLETED_TEXT');
    };

    $scope.nextSlide = function() {
    	ADB.trackState($translate.instant('SEPA_PICT_NEXT_SLIDE'));
    	$ionicSlideBoxDelegate.slide(1);
	    $scope.showButtonSection = true;
	}

	$scope.navigateToPictoSurvey = function(){
		ADB.trackState($translate.instant('SEPA_PICT_SURVEY'));
        localStorage.setItem("pictogramAccessed", new Date());
		$state.go('pictogramquestion');
	}

	$scope.navigateToDashboard = function(){
//		ADB.trackState($translate.instant('SEPA_PICTO_IGNORER'));
       	localStorage.setItem("pictogramAccessed", new Date());
		$state.go('app.dashboard');
	}

	$scope.disableDoubleTap = function(event){
		event.preventDefault();
		return false;
	}
});

app.controller('pictogramquestioncontroller', function($scope,$rootScope, $ionicPopup,$ionicPlatform, $state, $translate, $ionicSlideBoxDelegate, DB) {
  	$scope.options = {
	  loop: false,
	  effect: "fade",
	  speed: 500,
	}
	$scope.data = {};
	$scope.$watch('data.slider', function(nv, ov) {
	  $scope.slider = $scope.data.slider;
	});
  	$scope.normalSwipe = true;
  	$scope.normalDrag = false;
  	if(ionic.Platform.isAndroid()) {
  		var currentPlatformVersion = ionic.Platform.version();
  		if(parseFloat(currentPlatformVersion) >= 4.4 && parseFloat(currentPlatformVersion) < 5){
  			$scope.normalSwipe = false;
  			$scope.normalDrag = true;
  		}
  	}
  	$scope.backButtonSlide = -1;
  	$scope.showPictoResult = false;
  	$scope.q1details = {
	    tab1status : "active",
	    tab2status : "inactive",
	    tab3status : "inactive",
	    tab4status : "inactive",
	    tab5status : "inactive",
	    activeImage : 1,
	    activeMessage : $translate.instant('SMILEY_1_MESSGAE')
    };

    $scope.q2details = {
	    tab1status : "active",
	    tab2status : "inactive",
	    tab3status : "inactive",
	    tab4status : "inactive",
	    tab5status : "inactive",
	    activeImage : 1,
	    activeMessage : $translate.instant('SMILEY_1_MESSGAE')
    };

    $scope.q3details = {
	    tab1status : "active",
	    tab2status : "inactive",
	    tab3status : "inactive",
	    tab4status : "inactive",
	    tab5status : "inactive",
	    activeImage : 1,
	    activeMessage : $translate.instant('SMILEY_1_MESSGAE')
    };


    $ionicPlatform.onHardwareBackButton(function(event){
    		event.preventDefault();
          if($scope.backButtonSlide === 0 || $scope.showPictoResult === true){
          	console.log("Go to dashboard");
          	//$state.go('app.dashboard');
          }
          if($scope.backButtonSlide > 0){
          	 $scope.slideTo(parseInt($scope.backButtonSlide)-1);
          }
    });

  	//document.getElementsByClassName('slidder-wrapper')[0].style.height = 600;
  	setTimeout(function(){ 
  		var tabWrapper = document.getElementsByClassName('slidder-wrapper');
  		var i;
  		var heightCalc = window.innerHeight-44;
  		/*if(ionic.Platform.isAndroid()){
  			if(screen.height == 567 || screen.height == 659)
  				heightCalc = heightCalc - 50;
  		}*/
		for (i = 0; i < tabWrapper.length; i++) {
		    tabWrapper[i].style.minHeight = heightCalc+"px";
		}
  	}, 0);

  	$scope.disableSwipe = function() {
	   $ionicSlideBoxDelegate.enableSlide(false);
	};

    $scope.slideTo = function(index) {
    	var trackStateValue = $translate.instant('SEPA_QUESTION_NAV') + " " + (parseInt(index)+1);
    	ADB.trackState(trackStateValue);
    	$scope.backButtonSlide = index;
    	if(index === 1 || index === 2){
    		$rootScope.showingPictoQuestionPopup = true;
    	} else{
    		$rootScope.showingPictoQuestionPopup = false;
    	}
	    $ionicSlideBoxDelegate.slide(index);
	}

	$scope.triggerTabs = function(qIndex,tabIndex){
		/*switch(tabIndex){
			case 1: ADB.trackState($translate.instant('SEPA_PICTO_SMILEY1'));
					break;
			case 2: ADB.trackState($translate.instant('SEPA_PICTO_SMILEY2'));
					break;
			case 3: ADB.trackState($translate.instant('SEPA_PICTO_SMILEY3'));
					break;
			case 4: ADB.trackState($translate.instant('SEPA_PICTO_SMILEY4'));
					break;
			case 5: ADB.trackState($translate.instant('SEPA_PICTO_SMILEY5'));
					break;
			default: break;
		}*/
		var tablength = 5;
		var i;
		for(i=1;i<=tablength;i++){
			if(i == tabIndex){
				$scope["q"+qIndex+"details"]["tab"+i+"status"] = "active";
			} else{
				$scope["q"+qIndex+"details"]["tab"+i+"status"] = "inactive";
			}
		}
		$scope["q"+qIndex+"details"].activeImage = tabIndex;
		$scope["q"+qIndex+"details"].activeMessage = $translate.instant('SMILEY_'+tabIndex+'_MESSGAE');
	}

	$scope.swipeLeftTabs = function(qIndex){
		//ADB.trackState($translate.instant('SEPA_PICTO_SWIPE_LEFT'));
		var tabIndex = $scope["q"+qIndex+"details"].activeImage +  1;
		if(tabIndex <= 5 ){
			$scope.triggerTabs(qIndex, tabIndex);
		}
	}

	$scope.swipeRightTabs = function(qIndex){
		//ADB.trackState($translate.instant('SEPA_PICTO_SWIPE_RIGHT'));
		var tabIndex = $scope["q"+qIndex+"details"].activeImage -  1;
		if(tabIndex >=1 ){
			$scope.triggerTabs(qIndex, tabIndex);
		}
	}

	$scope.validatePicto = function(){
		$rootScope.showingPictoQuestionPopup = false;
		ADB.trackState($translate.instant('SEPA_PICTO_VALIDER'));
		localStorage.setItem("pictogramCompleted", new Date());
		$scope.showPictoResult = true;
	}

	$scope.goToDashboard = function(){
		$rootScope.showingPictoQuestionPopup = false;
//		ADB.trackState($translate.instant('SEPA_PICTO_TO_DAHSBOARD'));
        localStorage.setItem("pictogramAccessed", new Date());
		$state.go('app.dashboard');
	}

	$scope.disableDoubleTap = function(event){
		event.preventDefault();
		return false;
	}

});