app.controller('weeklytipcontroller', function($scope, $rootScope, $state, $translate, DB, UTIL_SERVICE) {
		var currentDate = new Date();
        var getWeekDay = currentDate.getDay();
        var weektiplastaccess = null;
        var lastAccessResult = null;

        $scope.fn_DateCompare = function (DateA, DateB) {
           var a = new Date(DateA);
           var b = new Date(DateB);
           
           var msDateA = Date.UTC(a.getFullYear(), a.getMonth()+1, a.getDate());
           var msDateB = Date.UTC(b.getFullYear(), b.getMonth()+1, b.getDate());

           var timeDiff = Math.abs(a.getTime() - b.getTime());
           var diffDays = Math.ceil(timeDiff / (1000 * 3600 * 24)); 
           
           if (parseFloat(msDateA) < parseFloat(msDateB))
             return -1;  // lt
           else if (parseFloat(msDateA) == parseFloat(msDateB))
             return 0;  // eq
           else if (diffDays > 7)
             return 7;  // gt
           else if(parseFloat(msDateA) > parseFloat(msDateB))
             return 1;
           else 
             return null;  // error
     	}

      $scope.getMonday = function (d) {
        d = new Date(d);
        var day = d.getDay(),
        diff = d.getDate() - day + (day == 0 ? -6:1); // adjust when day is sunday
        return new Date(d.setDate(diff));
      }

      if(localStorage.tipAccessed != undefined){
  	       weektiplastaccess = new Date(localStorage.tipAccessed); 
           lastAccessResult  = $scope.fn_DateCompare(currentDate,weektiplastaccess);
      } else{
           lastAccessResult = -1;
      }

      UTIL_SERVICE.jsonFileReader("languages/locale-en_US.json").then(function(result){
              var weeklytip = result.data.weeklytipslist;
              var jsonWeeklyTipCount = Object.keys(weeklytip).length;
              localStorage.setItem("totalTipCount", jsonWeeklyTipCount);
       },
       function(error) {
          console.log("Error reading JSON Data :"+error);
       });

      if(getWeekDay == 1 && lastAccessResult != 0) {
      	    
            localStorage.setItem("tipAccessed", currentDate);
            var tipNo;
            if(localStorage.tipOfWeekCount == undefined || localStorage.tipOfWeekCount >= localStorage.totalTipCount){
            	tipNo = 1;
            } else {
            	tipNo = parseInt(localStorage.tipOfWeekCount) + 1;
           	}
           	localStorage.setItem("tipOfWeekCount", tipNo);
           	$scope.weektip = $translate.instant('weeklytipslist.WEEKLY_TIP_'+tipNo);
     		    $state.go('app.tipoftheweek');
           
           
      } else if(lastAccessResult == 7) {
            var newTipNo;
            if(localStorage.tipOfWeekCount == undefined || localStorage.tipOfWeekCount >= localStorage.totalTipCount) {
              newTipNo = 1;
            } else {
              newTipNo = parseInt(localStorage.tipOfWeekCount) + 1;
            }
            
            $scope.weektip = $translate.instant('weeklytipslist.WEEKLY_TIP_'+newTipNo);
            localStorage.setItem("tipOfWeekCount", newTipNo);
            var accessedDate = $scope.getMonday(new Date());
            localStorage.setItem("tipAccessed", accessedDate);
            $state.go('app.tipoftheweek');

      } else if(localStorage.tipOfWeekCount == undefined) {
        
            localStorage.setItem("tipOfWeekCount", 1);
            $scope.weektip = $translate.instant('weeklytipslist.WEEKLY_TIP_'+localStorage.tipOfWeekCount);
            var accessedDate = $scope.getMonday(new Date());
            localStorage.setItem("tipAccessed", accessedDate);
            $state.go('app.tipoftheweek');
        
      } else {

            $scope.weektip = $translate.instant('weeklytipslist.WEEKLY_TIP_'+localStorage.tipOfWeekCount);
            $state.go('app.tipoftheweek');

      }

      $rootScope.firstLaunchHome = false;
      //$rootScope.menuBackButtonDisplay = false;


});