angular.module('util.services',[]).service('UTIL_SERVICE', function($q,$translate,$cordovaSocialSharing,$ionicPopup,$ionicPlatform,$http) {

    var self = this;
                                           
    self.dailNumber = function(number,$scope) {
        var tempPhone=number.replace(/ /g, '');
        window.open('tel:' + tempPhone, '_system');
                        
    };

    self.openWebsite = function(redirectURL,$scope) {
        if(redirectURL.indexOf("http") > -1) {
            var actUrl = redirectURL;
        } else {
            var actUrl = "http://"+redirectURL;
        }
        window.open(actUrl, "_system");
                        
    };
    
    self.shareToMail = function(toArr) {
               var action = "shareViaEmail";
               if (ionic.Platform.isAndroid()) {
                 action = "shareViaEmailSimple";
                }
               var is_emailconfig=$cordovaSocialSharing.canShareViaEmail();
               if(is_emailconfig){
                 $cordovaSocialSharing
                 .shareViaEmail(action, "", "", toArr, "", "", null)
                 .then(function(result) {
                       }, function(err) {
                         //$scope.displayAlertConfirmation1("eMail", $translate.instant('NO_EMAIL_CONFIG'));
                       });
               }else{
                 //$scope.displayAlertConfirmation1("eMail", $translate.instant('NO_EMAIL_CONFIG'));
               }
        };


      self.jsonFileReader = function(filePath){
          return $http.get(filePath);
      };
    
    // Input validation     

self.isValidEmail=function (email){
   var regEmail = /^\w+([-+.']\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*$/;
   if (regEmail.test(email)){
     return true; 
    } else{
      return false;
   }
};  

self.isValidPhoneNo=function(phoneno){
  var regPhoneno = /^\+?[0]?([0-9]{2})\)?[-. ]?([0-9]{4})[-. ]?([0-9]{4})$/; 
  //var regPhoneno1 = /^+?([0-9]{10})/;
  //var regPhoneno2 = /^0?([0-9]{10})/;
  if(regPhoneno.test(phoneno) ){
     return true;  
   } else {
     return false;
   }
};

self.isValidPostalCode=function(postalCode){
  //var regPhoneno = /^\(?([0-9]{3})\)?[-. ]?([0-9]{3})[-. ]?([0-9]{4})$/;
  var regPhoneno = /^[0-9]+$/;///^([0-9]{6})$/;
  if(regPhoneno.test(postalCode)){
     return true;  
   } else {
     return false;
   }
};

self.isValidWeb=function(webLink){
  //var regPhoneno = /^\(?([0-9]{3})\)?[-. ]?([0-9]{3})[-. ]?([0-9]{4})$/;
  var regWebLink = /^(http:\/\/www.|https:\/\/www.|ftp:\/\/www.|www.|.){1}([0-9A-Za-z]+\.)/;
  //var regWebLink = /^( http:\/\/WWW.|https:\/\/WWW.|ftp:\/\/WWW.|http:\/\/www.|https:\/\/www.|ftp:\/\/www.|www.){1}([0-9A-Za-z]+\.)/;
  var tempLowCaseWebLink=webLink.toLowerCase();
  ///(((https?:\/\/)|(www\.))[^\s]+)/g;
  if(regWebLink.test(tempLowCaseWebLink)){
     return true;  
   } else {
     return false;
   }
};     
});