angular.module('AppInfo.services', ['SEPAgenda.services']).factory('appInfoService', function($q,DB) {

    var self = this;
  
    self.insertAppInfo = function() {
        var sqlQuery = 'insert or replace into AppInfos(fl,patientDisclaimer,contactDisclaimer,websiteDisclaimer,wt,ar) values (?,?,?,?,?,?)';
        var bindingvalues = ['undo','','','','1','1'];
        return DB.query(sqlQuery, bindingvalues).then(function(result) {
               return result;
               },function(error){
                  return error;
               });
    };
                                                                   
                                                                   
                                                                   
    self.isFirstLaunch = function(){
         return DB.query('SELECT count(*) as cnt FROM AppInfos').then(function(result) {
            return result;
          },function(error){
            return error;
        });
    };
                                                                

    self.isTermsVisited = function() {
        return DB.query('SELECT fl FROM AppInfos').then(function(result) {
            return result;
            },function(error){
            return error;
            });
    };
                                                                   
    self.updateTermsVisited = function(){
        var sqlQuery = 'update AppInfos set fl = ? where Id = ?';
        var bindingvalues = ['done','1'];
        return DB.query(sqlQuery, bindingvalues).then(function(result) {
                return result;
                },function(error){
                return error;
                });
    };
                                                                   
    return self;
});